'From Squeak 2.0 BETA of May 8, 1998 on 12 May 1998 at 9:06:18 pm'!

!PluggableTextMorph methodsFor: 'updating' stamp: 'di 5/12/1998 21:05'!
update: aSymbol
	aSymbol == #flash ifTrue: [^ self flash].
	aSymbol == getTextSelector ifTrue:
			[self setText: self getText.
			^ self setSelection: self getSelection].
	aSymbol == getSelectionSelector ifTrue: [^ self setSelection: self getSelection].
	aSymbol == #autoSelect ifTrue:
			[self handleEdit:
				[textMorph editor setSearch: model autoSelectString;
							againOrSame: true]].
	aSymbol == #clearUserEdits ifTrue: [^ self hasUnacceptedEdits: false].
	aSymbol == #wantToChange ifTrue:
			[self canDiscardEdits ifFalse: [^ self promptForCancel].
			^ self].
	aSymbol == #appendEntry ifTrue:
			[self handleEdit: [self appendEntry].
			^ self world displayWorld].
	aSymbol == #clearText ifTrue:
			[self handleEdit: [self changeText: Text new].
			^ self world displayWorld].
! !


!TextMorph methodsFor: 'private' stamp: 'di 5/12/1998 20:56'!
updateFromParagraph
	| newStyle sel oldLast |
	paragraph ifNil: [^ self].
	wrapFlag ifNil: [wrapFlag _ true].
	editor ifNotNil: [sel _ editor selectionInterval.
					editor storeSelectionInParagraph].
	paragraph textStyle = textStyle
		ifTrue: [self fit]
		ifFalse: ["Broadcast style changes to all morphs"
				newStyle _ paragraph textStyle.
				(self firstInChain text: text textStyle: newStyle) recomposeChain.
				sel ifNotNil: [self installEditor selectFrom: sel first to: sel last]].
	sel ifNil: [^ self].

	"If selection is in top line, then recompose predecessor for possible ripple-back"
	predecessor ifNotNil:
		[sel first <= (paragraph lines first last+1) ifTrue:
			[oldLast _ predecessor lastCharacterIndex.
			predecessor paragraph recomposeFrom: oldLast orLineAbove: false.
			oldLast = predecessor lastCharacterIndex
				ifFalse: [predecessor changed. "really only last line"
						self predecessorChanged]]].

	((predecessor~~nil and: [sel first <= paragraph firstCharacterIndex])
		or: [successor~~nil and: [sel first > (paragraph lastCharacterIndex+1)]])
		ifTrue:
		["The selection is no longer inside this paragraph.
		Pass focus to the paragraph that should be in control."
		self releaseEditor.
		self firstInChain withSuccessorsDo:
			[:m |  (sel first between: m firstCharacterIndex
								and: m lastCharacterIndex+1)
					ifTrue: [m installEditor selectFrom: sel first to: sel last.
							m selectionChanged.
							^ self passKeyboardFocusTo: m]].
		^ self].
	editor ifNil:
		["Reinstate selection after, eg, style change"
		self installEditor selectFrom: sel first to: sel last]
! !


!TextMorphEditor methodsFor: 'mvc compatibility' stamp: 'di 5/12/1998 20:56'!
storeSelectionInParagraph
	paragraph selectionStart: startBlock selectionStop: stopBlock! !


