'From Squeak 2.0 of May 22, 1998 on 10 June 1998 at 11:43:37 am'!

!ChangeSorter methodsFor: 'creation' stamp: 'tk 6/10/1998 07:19'!
oldOpenAsMorphIn: window rect: rect
	"Add a set of change sorter views to the given top view offset by the given amount. To create a single change sorter, call this once with an offset of 0@0. To create a dual change sorter, call it twice with offsets of 0@0 and 0.5@0."
	| buttonView col |
	contents _ ''.
	self addDependent: window.		"so it will get changed: #relabel"
	buttonView _ PluggableButtonMorph
		on: self
		getState: #mainButtonState
		action: #changeSetMenuStart
		label: #mainButtonName
		menu: #changeSetMenu:.
	col _ Color perform: self defaultBackgroundColor.
	buttonView
		label: myChangeSet name; 
		onColor: col offColor: col;
		triggerOnMouseDown: true; borderColor: window color.
	window addMorph: buttonView
		frame: (((0@0 extent: 1.0@0.06) scaleBy: rect extent) translateBy: rect origin).

	window addMorph: (PluggableListMorphByItem on: self
			list: #classList
			selected: #currentClassName
			changeSelected: #currentClassName:
			menu: #classMenu:)
		frame: (((0@0.06 extent: 0.5@0.3) scaleBy: rect extent) translateBy: rect origin).

	window addMorph: (PluggableListMorphByItem on: self
			list: #messageList
			selected: #currentSelector
			changeSelected: #currentSelector:
			menu: #messageMenu:shifted:
			keystroke: #messageListKey:from:)
		frame: (((0.5@0.06 extent: 0.5@0.3) scaleBy: rect extent) translateBy: rect origin).

	window addMorph: (PluggableTextMorph on: self 
			text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
		frame: (((0@0.36 corner: 1@1) scaleBy: rect extent) translateBy: rect origin).
! !

!ChangeSorter methodsFor: 'creation' stamp: 'tk 6/8/1998 17:35'!
oldOpenView: topView offsetBy: offset
	"Add a set of change sorter views to the given top view offset by the given amount. To create a single change sorter, call this once with an offset of 0@0. To create a dual change sorter, call it twice with offsets of 0@0 and 360@0."
	| classView messageView codeView buttonView |
	contents _ ''.
	self addDependent: topView.		"so it will get changed: #relabel"
	buttonView _ PluggableButtonView
		on: self
		getState: #mainButtonState
		action: #changeSetMenuStart
		label: #mainButtonName
		menu: #changeSetMenu:.
	buttonView
		label: myChangeSet name;
		triggerOnMouseDown: true; borderWidth: 1; 
		window: ((0 @ 0 extent: 360 @ 20) translateBy: offset).
	topView addSubView: buttonView.

	classView _ PluggableListViewByItem on: self
		list: #classList
		selected: #currentClassName
		changeSelected: #currentClassName:
		menu: #classMenu:.
	classView window: (0 @ 0 extent: 180 @ 160).
	topView addSubView: classView below: buttonView.

	messageView _ PluggableListViewByItem on: self
		list: #messageList
		selected: #currentSelector
		changeSelected: #currentSelector:
		menu: #messageMenu:shifted:
		keystroke: #messageListKey:from:.
	messageView window: (0 @ 0 extent: 180 @ 160).
	topView addSubView: messageView toRightOf: classView.

	codeView _ PluggableTextView on: self 
			text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	codeView window: (0 @ 0 extent: 360 @ 180).
	topView addSubView: codeView below: classView.! !

!ChangeSorter methodsFor: 'creation' stamp: 'tk 6/10/1998 07:53'!
openAsMorphIn: window rect: rect
	"Add a set of change sorter views to the given top view offset by the given amount. To create a single change sorter, call this once with an offset of 0@0. To create a dual change sorter, call it twice with offsets of 0@0 and 0.5@0."

	| chgSetList |
	contents _ ''.
	self addDependent: window.		"so it will get changed: #relabel"
	window addMorph: (chgSetList _ PluggableListMorphByItem on: self
			list: #changeSetList
			selected: #currentCngSet
			changeSelected: #showChangeSetNamed:
			menu: #changeSetMenu:)
		frame: (((0@0 extent: 0.5@0.25) scaleBy: rect extent) translateBy: rect origin).
	chgSetList autoDeselect: false.

	window addMorph: (PluggableListMorphByItem on: self
			list: #classList
			selected: #currentClassName
			changeSelected: #currentClassName:
			menu: #classMenu:)
		frame: (((0.5@0 extent: 0.5@0.25) scaleBy: rect extent) translateBy: rect origin).

	window addMorph: (PluggableListMorphByItem on: self
			list: #messageList
			selected: #currentSelector
			changeSelected: #currentSelector:
			menu: #messageMenu:shifted:
			keystroke: #messageListKey:from:)
		frame: (((0@0.25 extent: 1@0.25) scaleBy: rect extent) translateBy: rect origin).

	window addMorph: (PluggableTextMorph on: self 
			text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
		frame: (((0@0.5 corner: 1@1) scaleBy: rect extent) translateBy: rect origin).
! !

!ChangeSorter methodsFor: 'creation' stamp: 'tk 6/5/1998 07:08'!
openView: topView offsetBy: offset
	"Add a set of change sorter views to the given top view offset by the given amount. To create a single change sorter, call this once with an offset of 0@0. To create a dual change sorter, call it twice with offsets of 0@0 and 360@0."
	| classView messageView codeView cngSetListView |
	contents _ ''.
	self addDependent: topView.		"so it will get changed: #relabel"
	cngSetListView _ PluggableListViewByItem on: self
		list: #changeSetList
		selected: #currentCngSet
		changeSelected: #showChangeSetNamed:
		menu: #changeSetMenu:.
	cngSetListView window: ((0 @ 0 extent: 180 @ 100) translateBy: offset).
	topView addSubView: cngSetListView.

	classView _ PluggableListViewByItem on: self
		list: #classList
		selected: #currentClassName
		changeSelected: #currentClassName:
		menu: #classMenu:.
	classView window: (180 @ 0 extent: 180 @ 100).
	topView addSubView: classView toRightOf: cngSetListView.

	messageView _ PluggableListViewByItem on: self
		list: #messageList
		selected: #currentSelector
		changeSelected: #currentSelector:
		menu: #messageMenu:shifted:
		keystroke: #messageListKey:from:.
	messageView window: (0 @ 100 extent: 360 @ 100).
	topView addSubView: messageView below: cngSetListView.

	codeView _ PluggableTextView on: self 
			text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	codeView window: (0 @ 0 extent: 360 @ 180).
	topView addSubView: codeView below: messageView.! !

!ChangeSorter methodsFor: 'access' stamp: 'tk 6/10/1998 08:15'!
showChangeSet: chgSet

	myChangeSet == chgSet ifFalse: [
		myChangeSet _ chgSet.
		currentClassName _ nil.
		currentSelector _ nil].
	self changed: #relabel.
	self changed: #currentCngSet.	"new -- list of sets"
	self changed: #mainButtonName.	"old, button"
	self changed: #classList.
	self changed: #messageList.
	self setContents.
	self changed: #contents.! !

!ChangeSorter methodsFor: 'access' stamp: 'tk 6/10/1998 07:38'!
showChangeSetNamed: aName

	aName ifNil: [^ self showChangeSet: nil].
	self showChangeSet: 
		(AllChangeSets detect: [:each | each name = aName]) ! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'tk 6/10/1998 08:53'!
changeSetList

	ChangeSet instanceCount > AllChangeSets size ifTrue: [self class gatherChangeSets].
	^ AllChangeSets collect: [:each | each name]! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'tk 6/5/1998 06:47'!
currentCngSet
	^ myChangeSet name! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'tk 6/10/1998 09:00'!
update
	"recompute all of my panes"

	self okToChange ifFalse: [^ self].
	self changed: #changeSetList.
	self showChangeSet: myChangeSet.
	parent ifNotNil: [
		(parent other: self) okToChange ifTrue: [
			(parent other: self) changed: #changeSetList.
			(parent other: self) showChangeSet: 
				(parent other: self) myChangeSet]].! !


!SystemWindow methodsFor: 'top window' stamp: 'tk 6/10/1998 11:37'!
activate
	"Bring me to the front and make me able to respond to mouse and keyboard"
	| oldTop |
	oldTop _ TopWindow.
	TopWindow _ self.
	oldTop ifNotNil: [oldTop passivate].
	owner firstSubmorph == self ifFalse: [owner addMorphFront: self].
	self submorphsDo: [:m | m unlock].
	self setStripeColorsFrom: self paneColor.
	self addHandles.
	self isCollapsed ifFalse: [model modelWakeUp].
! !


