"ScrollingPrefs.st
Make the preferences control panel scrolling.

        TITLE                   ScrollingPrefs.st
        AUTHOR                  Georg Gollmann (georg.gollmann@tuwien.ac.at)
        VERSION                 1.1
        IMAGE VERSION   2.4
        PREREQUISITES   none
        DATE                    April 27, 1999"!


!Preferences class methodsFor: 'preferences panel' stamp: 'go 4/26/1999 10:02'!
initialExtent
        ^ 219 @ 309! !

!Preferences class methodsFor: 'preferences panel' stamp: 'go 4/26/1999 14:12'!
openPreferencesControlPanel
        "Preferences openPreferencesControlPanel"
        | aPanel aWindow aRow wrapper but aList odd aColor w width1 width2 spacer |
        Smalltalk verifyMorphicAvailability ifFalse: [^ self beep].
        aPanel _ AlignmentMorph newColumn.
        aPanel beSticky.
        aList _ OrderedCollection new.
        FlagDictionary associationsDo: [:assoc | aList add: (Array
                                with: assoc key
                                with: assoc value
                                with: (self helpMessageForPreference: assoc key))].
        odd _ false.
        width1 _ 172.
        spacer _ 4.
        width2 _ 14.
        (aList asSortedCollection: [:a :b | a first < b first])
                do: 
                        [:triplet | 
                        aPanel addMorphBack: (aRow _ AlignmentMorph newRow).
                        aRow color: (aColor _ odd
                                                        ifTrue: [Color green muchLighter]
                                                        ifFalse: [Color red veryMuchLighter]).
                        odd _ odd not.
                        aRow addMorph: (wrapper _ Morph new color: aColor).
                        wrapper setBalloonText: triplet third.
                        wrapper extent: width1 @ 15.
                        wrapper addMorph: (StringMorph new contents: triplet first).
                        aRow addMorphBack: (Morph new color: aColor; extent: (spacer @ 15)).
                        aRow addMorphBack: (wrapper _ Morph new color: aColor).
                        wrapper extent: width2 @ 15.
                        wrapper addMorphBack: (but _ UpdatingBooleanStringMorph new contents: triplet second printString).
                        but getSelector: triplet first;
                        putSelector: #setPreference:toValue:;
                        stepFrequency: 1800;
                         target: self].
                wrapper _ ScrollPane new.
                wrapper scroller addMorph: aPanel.
        Smalltalk isMorphic
                ifTrue:
                        [aWindow _ SystemWindow new model: self.
                        aWindow addMorph: wrapper frame: (0 @ 0 extent: 1 @ 1).
                        aWindow setLabel: 'Preferences'.
                        aWindow openInWorld]
                ifFalse:
                        [w _ WorldMorph new addMorph: wrapper.
                        wrapper
                                retractable: false;
                                extent: self initialExtent + (wrapper scrollbarWidth @ 0).
                        w startSteppingSubmorphsOf: wrapper.
                        MorphWorldView openOn: w
                                label: 'Preferences'
                                extent: w fullBounds extent]
! !


!ScrollPane methodsFor: 'geometry' stamp: 'go 4/26/1999 10:06'!
extent: newExtent
        super extent: (newExtent max: (self scrollbarWidth + 20)@16).
        self resizeScrollBar; resizeScroller; setScrollDeltas! !


PluggableListMorph removeSelector: #extent:!

