'From Squeak 2.0 of May 22, 1998 on 17 June 1998 at 8:33:53 pm'!

!FileDirectory class methodsFor: 'name utilities' stamp: 'TPR 5/10/1998 21:32'!
changeSuffix
"if 'changes' is not suitable, override this message to return something that is ok"
	^'changes'! !

!FileDirectory class methodsFor: 'name utilities' stamp: 'TPR 5/10/1998 21:31'!
imageSuffix
"if 'image' is not suitable, override this message to return something that is ok"
	^'image'! !

!FileDirectory class methodsFor: 'platform specific' stamp: 'TPR 5/12/1998 22:49'!
pathNameDelimiter
"return the active directory class's directory seperator character"
	^ DirectoryClass pathNameDelimiter! !

!FileDirectory class methodsFor: 'private' stamp: 'TPR 5/10/1998 21:47'!
activeDirectoryClass
	"Return the concrete FileDirectory subclass for the platform on which we are currently running."

	FileDirectory allSubclasses do: [:class |
		class isActiveDirectoryClass ifTrue: [^ class]].

	"no responding subclass; use FileDirectory"
	^ FileDirectory
! !

!FileDirectory class methodsFor: 'private' stamp: 'TPR 5/10/1998 21:40'!
isActiveDirectoryClass
	"Does this class claim to be that properly active subclass of FileDirectory for this platform?
	Default test is whether the primPathNameDelimiter matches the one for this class. Other tests are possible"

	^self pathNameDelimiter = self primPathNameDelimiter
! !


!AcornFileDirectory class methodsFor: 'platform specific' stamp: 'TPR 5/12/1998 23:09'!
byteReverseForm: aForm
	"Byte-reverse the words of the given Form's bitmap. Supports porting a Squeak image to the Acorn."

	| bits mask pixelDepth dstWord srcWord srcPix nPix |
	(aForm isKindOf: Cursor)
		ifFalse:[aForm unhibernate].
	bits _ aForm bits.
	pixelDepth _ aForm depth.
	nPix _ 32 // pixelDepth.
	1 to: bits size do: [:i |
		srcWord _ bits at: i.
		mask _ (1 << pixelDepth) - 1.
		dstWord _ 0.
		1 to: nPix do: [:p|
			srcPix _ srcWord bitAnd: mask.
			srcWord _ srcWord >> pixelDepth.
			dstWord _ ((dstWord << pixelDepth) bitOr: srcPix)].
		bits at: i put: dstWord].
	(aForm isKindOf: Cursor)
		ifFalse:[aForm hibernate]
! !

!AcornFileDirectory class methodsFor: 'platform specific' stamp: 'TPR 5/12/1998 22:48'!
isActiveDirectoryClass
	"Does this class claim to be that properly active subclass of FileDirectory for this platform?
	On Acorn, the test is whether systemAttribute 1001 = 'RiscOS' (on newer VMs) or if the primPathNameDelimiter is $. (on older ones), which is what we would like to use for a dirsep if only it would work out. See pathNameDelimiter for more woeful details - then just get on and enjoy Squeak"
	| attr |
	attr _ Smalltalk getSystemAttribute: 1001.
	attr isNil ifFalse:[^attr = 'RiscOS'].
	^self primPathNameDelimiter = $.
! !

!AcornFileDirectory class methodsFor: 'platform specific' stamp: 'TPR 5/10/1998 21:45'!
pathNameDelimiter
"Acorn RiscOS uses a dot as the directory separator and has no real concept of filename extensions. We tried to make code handle this, but there are just too many uses of dot as a filename extension - so fake it out by pretending to use a slash. The file prims do conversions instead.
Sad, but pragmatic"
	^ $/
! !


!SystemDictionary methodsFor: 'snapshot and quit' stamp: 'TPR 5/10/1998 21:33'!
saveAs

	| dir newName newImageName newChangesName |
	dir _ FileDirectory default.
	newName _ (FillInTheBlank
		request: 'New File Name?'
		initialAnswer: 'NewImageName') asFileName.
	newName _ FileDirectory baseNameFor: newName.

	newImageName _ newName, FileDirectory dot, FileDirectory imageSuffix.
	newChangesName _ newName, FileDirectory dot, FileDirectory changeSuffix.
	((dir includesKey: newImageName) or:
	 [dir includesKey: newChangesName]) ifTrue: [
		^ self notify: newName, ' is already in use.
Please choose another name.'].

	dir copyFileNamed: self changesName toFileNamed: newChangesName.
	self logChange: '----SAVEAS ', newName, '----', Date dateAndTimeNow printString.
	self imageName: (dir fullNameFor: newImageName).
	LastImageName _ self imageName.
	self closeSourceFiles; openSourceFiles.  "so SNAPSHOT appears in new changes file"
	self snapshot: true andQuit: false.
! !

AcornFileDirectory class removeSelector: #extensionDelimiter!
SystemDictionary removeSelector: #fileNameEnds!