'From Squeak 2.5 of August 6, 1999 [latest update: #1499] on 28 September 1999 at 11:24:34 pm'!
"Change Set:		FastUnsentMsgs
Date:			28 September 1999
Author:			Bert Freudenberg

Greatly speeds up Smalltalk>>allUnSentMessages etc. by using decent-sized IdentityDictionaries.
"!


!SystemDictionary methodsFor: 'retrieving' stamp: 'bf 9/22/1999 16:56'!
allImplementedMessages
	"Answer a Set of all the messages that are sent by a method in the system 
	but are not implemented."

	| aSet |
	aSet _ IdentitySet new: Symbol instanceCount.
	Cursor wait showWhile: 
		[self allBehaviorsDo: [:cl | cl selectorsDo: [:aSelector | aSet add: aSelector]]].
	^aSet! !

!SystemDictionary methodsFor: 'retrieving' stamp: 'bf 9/22/1999 16:39'!
allSentMessages
	"Answer the set of selectors which are sent somewhere in the system."
	| sent |
	sent _ IdentitySet new: CompiledMethod instanceCount.
	Cursor execute showWhile: 
		[self allBehaviorsDo: 
			[:cl | cl selectorsDo: 
				[:sel | "Include all sels, but not if sent by self"
			(cl compiledMethodAt: sel) literals do: 
				[:m | 
				(m isMemberOf: Symbol) ifTrue:  "might be sent"
					[m == sel ifFalse: [sent add: m]].
				(m isMemberOf: Array) ifTrue:  "might be performed"
					[m do: [:x | (x isMemberOf: Symbol) ifTrue:
						[x == sel ifFalse: [sent add: x]]]]]]].
		"The following may be sent without being in any literal frame"
		1 to: self specialSelectorSize do: 
			[:index | 
			sent add: (self specialSelectorAt: index)]].
	^ sent! !


