'From Squeak 2.5 of August 6, 1999 [latest update: #1534] on 13 October 1999 at 12:06:20 pm'!
"Change Set:		selFinder2-bf
Date:			13 October 1999
Author:			Bert Freudenberg

Fixes a bug that slipped into the previous changeset. Also displays the new list format even from the lower pane (morphic only)."! 


!MethodFinder methodsFor: 'search' stamp: 'bf 10/13/1999 11:10'!
findMessage
	"Control the search."

	data do: [:alist |
		(alist isKindOf: SequenceableCollection) ifFalse: [
			^ 'first and third items are not Arrays']].
	Approved ifNil: [self initialize].	"Sets of allowed selectors"
	expressions _ WriteStream on: (String new: 400).
	self search: true.	"multi"
	selector isEmpty ifTrue: [^ 'no single method does that function'].
 	^ expressions contents ! !


!MethodFinder class methodsFor: 'as yet unclassified' stamp: 'bf 10/13/1999 11:22'! methodFor: dataAndAnswers
	"Return an expression that computes these answers."

	| result selFinder |
	result _ (self new) load: dataAndAnswers; findMessage.
	Smalltalk isMorphic ifTrue: [
		((selFinder _ World submorphs first model) 
			isKindOf: SelectorBrowser) ifTrue: [
	 			selFinder searchResult: result]].
	^result! !


!SelectorBrowser methodsFor: 'as yet unclassified' stamp: 'bf 10/13/1999 11:53'! listFromResult: resultString
	"ResultString is of the form '(data1 op data2) (...)'. Answer a sorted array."
	| resultArray |
	resultString first == $( ifFalse: [^#()].
	resultArray _ (resultString findTokens: '(') collect:
			[:s | s withBlanksTrimmed allButLast "remove $)"].
	resultArray sortBy: [:a :b | 
		(a copyFrom: 6 to: a size) < (b copyFrom: 6 to: b size)].
	^resultArray
! !

!SelectorBrowser methodsFor: 'as yet unclassified' stamp: 'bf 10/13/1999 11:55'! 
quickList
	"Compute the selectors for the single example of receiver and args, in the very top pane" 

	| data array result resultArray |
	data _ contents asString.
	"delete trailing period. This should be fixed in the Parser!!"
 	[data last isSeparator] whileTrue: [data _ data allButLast]. 
	data last = $. ifTrue: [data _ data allButLast]. 	"Eval"
	array _ Compiler evaluate: '{', data, '}'. "#( data1 data2 result )"
 	array size < 2 ifTrue: [self inform: 'If you are giving an example of receiver, \args, and result, please put periods between the parts.\Otherwise just type one selector fragment' withCRs. ^#()].
 	array _ Array with: array allButLast with: array last. "#( (data1 data2) result )" 
	result _ MethodFinder new load: array; findMessage.
 	resultArray _ self listFromResult: result. 
	resultArray isEmpty ifTrue: [self inform: result].
 	^ resultArray! !

!SelectorBrowser methodsFor: 'as yet unclassified' stamp: 'bf 10/13/1999 11:58'! searchResult: anExternalSearchResult

	self contents: ''.
	classList _ #(). classListIndex _ 0.
	selectorIndex _ 0.
	selectorList _ self listFromResult: anExternalSearchResult.
 	self changed: #messageList.
	self changed: #classList.
	Smalltalk isMorphic ifTrue: [self changed: #contents.]. 
! !


MethodFinder removeSelector: #findMessageForDisplay! 
MethodFinder class removeSelector: #methodForDisplay:!