'From Squeak2.6 of 11 October 1999 [latest update: #1633] on 23 November 1999 at 10:57:01 pm'!
"Change Set:		FixDblClickGrab-di
Date:			23 November 1999
Author:			Dan Ingalls

If a morph subscribed to double-clicks, and then wanted to be grabbed by the first drag: event (this is proper procedure), it used to be grabbed with an offset if the hand was in motion.
This change fixes that.
"!


!HandMorph methodsFor: 'double click support' stamp: 'di 11/23/1999 22:46'!
checkForDoubleClick: evt
	"Process the given mouse event to detect a click, double-click, or drag."

	| t tfmEvt nowPos |
	tfmEvt _ evt transformedBy: eventTransform.
	clickState = #dragging ifTrue:
		[clickClient drag: tfmEvt.
		tfmEvt isMouseMove ifFalse: [self resetClickState].
		^ self].
	t _ Time millisecondClockValue - firstClickTime.
	clickState = #firstClickDown ifTrue:
		[(t > DoubleClickTime or:
		 [(tfmEvt cursorPoint - firstClickEvent cursorPoint) r > 15]) ifTrue:
			["consider it a drag if hand moves or timeout expires"
			"NOTE: First drag point must be from first click point,
			AND handPos must revert in case the target wants to be grabbed."
			nowPos _ self position.
			self position: firstClickEvent cursorPoint.
			clickClient drag: firstClickEvent.
			clickState _ #dragging.
			self position: nowPos.
			^ self].
		tfmEvt isMouseUp ifTrue:
			[clickState _ #firstClickUp.
			^ self]].

	clickState = #firstClickUp ifTrue:
		[tfmEvt isMouseDown ifTrue:
			[clickClient doubleClick: firstClickEvent.
			^ self resetClickState].
		t > DoubleClickTime ifTrue:
			[clickClient click: firstClickEvent.
			^ self resetClickState]]! !


