'From Squeak2.6 of 11 October 1999 [latest update: #1657] on 27 November 1999 at 10:31:04 am'!
"Change Set:		ColorAndProjectFix
Date:			27 November 1999
Author:			Dan Ingalls

Makes Choose Desktop Color work in inner worlds.
Preempts attempt to change projects from inner worlds.
"!


!ColorPickerMorph methodsFor: 'other' stamp: 'di 11/27/1999 09:12'!
addToWorld: world near: box
	| goodLocation |
	goodLocation _ self bestPositionNear: box inWorld: world.
	world allMorphsDo:
		[:p | (p isMemberOf: ColorPickerMorph) ifTrue:
		[(p ~~ self and: [p owner notNil and: [p target == target]]) ifTrue:
			[(p selector == selector and: [p argument == argument])
				ifTrue: [^ p comeToFront  "uncover existing picker"]
				ifFalse: ["place second picker relative to first"
						goodLocation _ self bestPositionNear: p bounds inWorld: world]]]].
	self position: goodLocation.
	world addMorphFront: self.
	self changed
! !

!ColorPickerMorph methodsFor: 'other' stamp: 'di 11/27/1999 08:51'!
bestPositionNear: box inWorld: world
	| points b |
	points _ #(topCenter rightCenter bottomCenter leftCenter).  "possible anchors"
	1 to: 4 do:
		[:i |  "Try the four obvious anchor points"
		b _ self bounds align: (self bounds perform: (points at: i))
					with: (box perform: (points atWrap: i + 2)).
		(world viewBox containsRect: b) ifTrue:
			[^ b topLeft"  Yes, it fits"]].

	^ 20@20  "when all else fails"
! !


!HandMorph methodsFor: 'world menu' stamp: 'di 11/27/1999 10:16'!
buildWorldMenu
	"Build the meta menu for the world."
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	menu add: 'previous project' target: owner action: #goBack.
	menu add: 'jump to project...' target: owner action: #jumpToProject.
	menu add: 'save for future revert' target: self world project 
			action: #saveForRevert.
	menu add: 'revert to saved copy' target: self world project action: #revert.
	menu add: 'restore display' target: self world action: #restoreDisplay.

	menu addLine.
	menu add: 'open...' action: #openWindow.
	menu add: 'windows & flaps...' action: #windowsDo.
	menu add: 'changes...' action: #changesDo.
	menu add: 'help...' action: #helpDo.
	menu add: 'appearance...' action: #appearanceDo.
	menu add: 'do...' target: Utilities action: #offerCommonRequests.

	menu addLine.
	menu add: 'new morph...' action: #newMorph.
	menu add: 'authoring tools...' action: #scriptingDo.
	menu add: 'playfield options...' action: #playfieldDo.
	menu add: 'print PS to file...' action: #printWorldOnFile.
	menu add: 'debug...' action: #debugDo.

	menu addLine.
	menu add: 'save' action: #saveSession.
	menu add: 'save as...' action: #saveAs.
	menu add: 'save and quit' action: #saveAndQuit.
	menu add: 'quit' action: #quitSession.

	^ menu! !

!HandMorph methodsFor: 'world menu commands' stamp: 'di 11/27/1999 09:18'!
changeColorTarget: aMorph selector: aSymbol originalColor: aColor

	^ ColorPickerMorph new
		sourceHand: self;
		target: aMorph;
		selector: aSymbol;
		originalColor: aColor;
		addToWorld: self world
			near: (aMorph
					ifNil: [Rectangle center: self position extent: 20]
					ifNotNil: [aMorph == self world
								ifTrue: [aMorph viewBox bottomLeft + (20@-20) extent: 150]
								ifFalse: [aMorph fullBounds]]);
		yourself! !


!PasteUpMorph methodsFor: 'world state' stamp: 'di 11/27/1999 10:11'!
exit

	Project current exit.
! !

!PasteUpMorph methodsFor: 'world state' stamp: 'di 11/27/1999 10:11'!
goBack

	Project returnToPreviousProject.
! !

!PasteUpMorph methodsFor: 'world state' stamp: 'di 11/27/1999 10:20'!
jumpToProject

	Project jumpToProject.
! !


!Project methodsFor: 'menu messages' stamp: 'di 11/27/1999 10:15'!
saveState
	"Save the current state in me prior to leaving this project"

	changeSet _ Smalltalk changes.
	World isMorph
		ifTrue: [world _ World.
				world sleep]
		ifFalse: [world _ ScheduledControllers.
				ScheduledControllers unCacheWindows].
	transcript _ Transcript.
	activeProcess _ nil
! !


!WiWPasteUpMorph methodsFor: 'as yet unclassified' stamp: 'di 11/27/1999 10:27'!
goBack
	PopUpMenu notify: 'Project changes are not yet allowed
from inner worlds.'! !

!WiWPasteUpMorph methodsFor: 'as yet unclassified' stamp: 'di 11/27/1999 10:27'!
jumpToProject
	PopUpMenu notify: 'Project changes are not yet allowed
from inner worlds.'! !


