'From Squeak 2.1 of June 30, 1998 on 3 August 1998 at 9:52:55 pm'!
"Change Set:		SystemWindowStepping
Date:			3 August 1998
Author:			Lex Spoon

a couple of changes related to SystemWindow stepping:

  1. at openInWorld and openInWorldExtent, System windows start stepping.  This is needed if you add a window to the world programmatically instead of using drag-and-drop.

  2. SystemWindow>>wantsSteps and >>stepTime simply call the model's method of the same name, if the model implements them."!


!SystemWindow methodsFor: 'open/close' stamp: 'ls 7/21/1998 00:29'!
openInWorld
	"This msg and its callees result in the window being activeOnlyOnTop"
	Smalltalk isMorphic ifFalse: [^ self openInMVC].
	self bounds: (RealEstateAgent initialFrameFor: self).
	World addMorph: self.
	self activate.
	World startSteppingSubmorphsOf: self.! !

!SystemWindow methodsFor: 'open/close' stamp: 'ls 7/21/1998 00:30'!
openInWorldExtent: extent
	"This msg and its callees result in the window being activeOnlyOnTop"
	Smalltalk isMorphic ifFalse: [^ self openInMVCExtent: extent].
	self position: (RealEstateAgent initialFrameFor: self) topLeft; extent: extent.
	World addMorph: self.
	self activate.
	World startSteppingSubmorphsOf: self.! !

!SystemWindow methodsFor: 'stepping' stamp: 'ls 8/3/1998 21:49'!
stepTime
	(model respondsTo: #stepTime) ifTrue: [ ^model stepTime ].

	^ 200 "milliseconds"! !

!SystemWindow methodsFor: 'stepping' stamp: 'ls 7/23/1998 02:51'!
wantsSteps
	"Return true if the model responds to step (except if it is a debugger)."
	| c |
	c _ model class.
	(c respondsTo: #wantsSteps) ifTrue: [ ^c wantsSteps ].
	[c == nil] whileFalse:
		[(c includesSelector: #step) ifTrue: [^ c ~= Debugger].
		c _ c superclass].
	^ false! !


