'From Squeak2.6 of 11 October 1999 [latest update: #1756] on 4 January 2000 at 2:42:46 pm'!
"Change Set:		ScanCharsFailFix2
Date:			4 January 2000
Author:			Dan Ingalls

Supplants the change of #1756 with an earlier check for failure.  While the other fix did improve display, several situations remained with glitches.  Those are now fixed.

Fixes a strange bug originally reported by Bob Arning, wherein if the text scanCharacters primitive failed due to, eg, translucency mode, its destX value had been changed by partial operation of the primitive up to when the BB failure takes effect.  This resulted in improper positioning when the Squeak-level retry was attempted.
"!


!BitBltSimulation methodsFor: 'interpreter interface' stamp: 'di 1/4/2000 14:19'!
scanCharacters
	self inline: true.
	scanDisplayFlag ifTrue: [
		self clipRange.
		(combinationRule = 30) | (combinationRule = 31) ifTrue:
			[^ interpreterProxy primitiveFail].
		self lockSurfaces ifFalse: [^ interpreterProxy primitiveFail]].
	self scanCharactersLockedAndClipped.
	scanDisplayFlag ifTrue:[self unlockSurfaces].! !

!BitBltSimulation methodsFor: 'setup' stamp: 'di 1/4/2000 14:19'!
scanCharactersLockedAndClipped
	"Perform the actual scanCharacters operation.
	Assume: Surfaces have been locked and clipping was performed."
	| left top lastIndex charVal ascii sourceX2 nextDestX |
	self inline: true.
	scanDisplayFlag ifTrue:
		[left _ dx.
		top _ dy].
	lastIndex _ scanStart.
	[lastIndex <= scanStop]
		whileTrue: [
			charVal _ interpreterProxy stObject: scanString at: lastIndex.
			ascii _ interpreterProxy integerValueOf: charVal.
			interpreterProxy failed ifTrue: [^ nil].
			stopCode _ interpreterProxy stObject: scanStopArray at: ascii + 1.
			interpreterProxy failed ifTrue: [^ nil].
			stopCode = interpreterProxy nilObject
				ifFalse: [^ self returnAt: ascii + 1
							 lastIndex: lastIndex
								  left: left
								  top: top].
			sourceX _ interpreterProxy stObject: scanXTable at: ascii + 1.
			sourceX2 _ interpreterProxy stObject: scanXTable at: ascii + 2.
			interpreterProxy failed ifTrue: [^ nil].
			(interpreterProxy isIntegerObject: sourceX) & (interpreterProxy isIntegerObject: sourceX2)
				ifTrue: [sourceX _ interpreterProxy integerValueOf: sourceX.
						sourceX2 _ interpreterProxy integerValueOf: sourceX2]
				ifFalse: [interpreterProxy primitiveFail. ^ nil].
			nextDestX _ destX + (width _ sourceX2 - sourceX).
			nextDestX > scanRightX
				ifTrue: [^ self returnAt: CrossedX
							 lastIndex: lastIndex
								  left: left
								  top: top].
			(scanDisplayFlag) ifTrue:[
				self clipRange.	"Must clip again"
				(bbW > 0 and:[bbH > 0])
					ifTrue: [self copyBitsLockedAndClipped].
			].
			destX _ nextDestX.
			interpreterProxy storeInteger: BBDestXIndex ofObject: bitBltOop withValue: destX.
			lastIndex _ lastIndex + 1].
	self returnAt: EndOfRun
		 lastIndex: scanStop
			  left: left
			  top: top! !


