'From Squeak2.7 of 5 January 2000 [latest update: #1791] on 19 January 2000 at 7:27:53 pm'!
"Change Set:		debugHandleFix-sw
Date:			19 January 2000
Author:			Scott Wallace

Fixes a glitch in update 1792 relating to the debug handle."!


!HaloMorph methodsFor: 'private' stamp: 'sw 1/19/2000 17:57'!
addHandlesTo: aHaloMorph box: box

	| s dismissHandle lab |
	s _ aHaloMorph handleSize.

	aHaloMorph addHandleAt: box topLeft color: Color red
		on: #mouseDown send: #doMenu:with: to: self.

	"innerTarget colorSettable ifTrue:
		[aHaloMorph addGraphicalHandle: ColorHalo at: (box topLeft + (0@14)) on: #mouseDown send: #doRecolor:with: to: self]."  "possible future"

	aHaloMorph addHandleAt: (box leftCenter + (0 @ (s+2)) min: box leftCenter + box bottomLeft // 2)
		color: Color lightBrown
		on: #mouseDown send: #tearOffTile to: innerTarget.

	dismissHandle _ aHaloMorph addHandleAt: (box topLeft + ((s+2)@0) min: box topLeft + box topCenter // 2)
		color: Color red muchLighter
		on: #mouseDown send: #mouseDownInDimissHandle:with: to: self.
	dismissHandle on: #mouseUp send: #maybeDismiss:with: to: self.
	dismissHandle on: #mouseStillDown send: #setDismissColor:with: to: self.
	dismissHandle addMorphBack: (lab _ StringMorph contents: 'X' font: Preferences standardButtonFont).
	lab position: dismissHandle position + (4 @ 0).
	lab lock.

	aHaloMorph addHandleAt: box leftCenter color: Color cyan
		on: #mouseDown send: #openViewerForArgument to: innerTarget.

	aHaloMorph addHandleAt: box topCenter color: Color black
		on: #mouseDown send: #doGrab:with: to: self.

	(aHaloMorph addHandleAt: (box topCenter + ((s+2)@0) min: box topCenter + box topRight // 2)
		color: Color brown
		on: #mouseDown send: #startDrag:with: to: self)
		on: #mouseStillDown send: #doDrag:with: to: self.

	aHaloMorph addHandleAt: box topRight color: Color green
		on: #mouseDown send: #doDup:with: to: self.

	Preferences debugHaloHandle ifTrue:
		[aHaloMorph addHandleAt: ((box topRight + box rightCenter) // 2)
			color: Color blue veryMuchLighter
			on: #mouseDown send: #doDebug:with: to: self].

	target balloonText ifNotNil:
		[(aHaloMorph addHandleAt: box bottomCenter color: Color lightBlue
			on: #mouseDown send: #mouseDownOnHelpHandle: to: innerTarget)
			on: #mouseUp send: #deleteBalloon to: innerTarget].

	(aHaloMorph addHandleAt: box bottomLeft color: Color blue
		on: #mouseDown send: #startRot:with: to: self)
		on: #mouseStillDown send: #doRot:with: to: self.

	target isFlexMorph
		ifTrue: [(aHaloMorph addHandleAt: box bottomRight color: Color lightOrange
				on: #mouseDown send: #startScale:with: to: self)
				on: #mouseStillDown send: #doScale:with: to: self]
		ifFalse: [(aHaloMorph addHandleAt: box bottomRight color: Color yellow
				on: #mouseDown send: #startGrow:with: to: self)
				on: #mouseStillDown send: #doGrow:with: to: self].

	innerTarget addOptionalHandlesTo: aHaloMorph box: box! !


!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'sw 1/19/2000 17:57'!
addHandlesTo: aHaloMorph box: box
	| dismissHandle s lab |
	s _ aHaloMorph handleSize.
	myActor getTexturePointer == nil ifFalse:[
		aHaloMorph addHandleAt: box rightCenter color: Color lightGray on: #mouseDown send: #extractTexture: to: aHaloMorph target].

	aHaloMorph addHandleAt: box topLeft color: Color red
		on: #mouseDown send: #doMenu:with: to: aHaloMorph.

	aHaloMorph addHandleAt: (box leftCenter + (0 @ (s+2)) min: box leftCenter + box bottomLeft // 2)
		color: Color lightBrown
		on: #mouseDown send: #yourself "#tearOffTile" to: self.

	dismissHandle _ aHaloMorph addHandleAt: (box topLeft + ((s+2)@0) min: box topLeft + box topCenter // 2)
		color: Color red muchLighter
		on: #mouseDown send: #mouseDownInDimissHandle:with: to: aHaloMorph.
	dismissHandle on: #mouseUp send: #maybeDismiss:with: to: aHaloMorph.
	dismissHandle on: #mouseStillDown send: #setDismissColor:with: to: aHaloMorph.
	dismissHandle addMorphBack: (lab _ StringMorph contents: 'X' font: Preferences standardButtonFont).
	lab position: dismissHandle position + (4 @ 0).
	lab lock.

	aHaloMorph addHandleAt: box leftCenter color: Color cyan
		on: #mouseDown send: #yourself "#openViewerForArgument" to: self.

	aHaloMorph addHandleAt: box topCenter color: Color black
		on: #mouseDown send: #grabFromHalo:with: to: self.

	(aHaloMorph addHandleAt: (box topCenter + ((s+2)@0) min: box topCenter + box topRight // 2)
		color: Color brown
		on: #mouseDown send: #dragStartFromHalo:with: to: self)
		on: #mouseStillDown send: #dragMoveFromHalo:with: to: self;
		on: #mouseUp send: #dragEndFromHalo:with: to: self.

	(aHaloMorph addHandleAt: box topRight color: Color green
		on: #mouseDown send: #dupStartFromHalo:with: to: self)
		on: #mouseStillDown send: #dupMoveFromHalo:with: to: self;
		on: #mouseUp send: #dupEndFromHalo:with: to: self.

	Preferences debugHaloHandle ifTrue:
		[aHaloMorph addHandleAt: ((box topRight + box rightCenter) // 2)
			color: Color blue veryMuchLighter
			on: #mouseDown send: #doDebug:with: to: aHaloMorph].

	(aHaloMorph addHandleAt: box bottomLeft color: Color blue
		on: #mouseDown send: #rotateStartFromHalo:with: to: self)
		on: #mouseStillDown send: #rotateMoveFromHalo:with: to: self;
		on: #mouseUp send: #rotateEndFromHalo:with: to: self.

	(aHaloMorph addHandleAt: box bottomRight color: Color yellow
		on: #mouseDown send: #growStartFromHalo:with: to: self)
		on: #mouseStillDown send: #growMoveFromHalo:with: to: self;
		on: #mouseUp send: #growEndFromHalo:with: to: self! !


