'From Squeak2.7 of 5 January 2000 [latest update: #1789] on 5 February 2000 at 1:41:57 pm'!
"Change Set:		1005BrowserCmdKeys-jlm
Date:			26 September 1999
Author:			Jason McVay (edited by SMA)

just a couple of more key bindings for browser menus:

	Cmd+r		recent classes...
	Cmd+h		spawn hierarchy
	Cmd+h		method inheritance

"!


!StringHolder methodsFor: 'message list menu' stamp: 'sma 2/5/2000 13:40'!
classListKey: aChar from: view 
	"Respond to a Command key.  I am a model with a list of classes and a 
	code pane, and I also have a listView that has a list of methods.  The 
	view knows how to get the list and selection."

	aChar == $f ifTrue: [^ self findMethod].
	aChar == $r ifTrue: [^ self recent].
	aChar == $h ifTrue: [^ self spawnHierarchy].
	^ self messageListKey: aChar from: view! !

!StringHolder methodsFor: 'message list menu' stamp: 'sma 2/5/2000 13:41'!
messageListKey: aChar from: view
	"Respond to a Command key.  I am a model with a code pane, and I also
	have a listView that has a list of methods.  The view knows how to get
	the list and selection."

	| sel class |
	(class _ self selectedClassOrMetaClass) ifNil: [^ self arrowKey: aChar from: view].
	sel _ self selectedMessageName.
	aChar == $b ifTrue: [^ Browser fullOnClass: class selector: sel].
	aChar == $N ifTrue: [^ self browseClassRefs].
	aChar == $h ifTrue: [^ self methodHierarchy].

	sel ifNil: [^ self arrowKey: aChar from: view].
	aChar == $m ifTrue: [^ Smalltalk browseAllImplementorsOf: sel].
	aChar == $n ifTrue: [^ Smalltalk browseAllCallsOn: sel].
	aChar == $v ifTrue: [^ self browseVersions].
	aChar == $O ifTrue: [^ self openSingleMessageBrowser].

	^ self arrowKey: aChar from: view! !


!Browser methodsFor: 'system category functions' stamp: 'sma 2/5/2000 13:24'!
systemCategoryMenu: aMenu

^ aMenu labels:
'find class... (f)
recent classes... (r)
browse all
browse
printOut
fileOut
reorganize
update
add item...
rename...
remove' 
	lines: #(2 4 6 8)
	selections:
		#(findClass recent browseAllClasses buildSystemCategoryBrowser
		printOutSystemCategory fileOutSystemCategory
		editSystemCategories updateSystemCategories
		addSystemCategory renameSystemCategory removeSystemCategory )! !

!Browser methodsFor: 'class functions' stamp: 'sma 2/5/2000 13:25'!
classListMenu: aMenu 
^ aMenu labels: 
'browse class
browse full (b)
printOut
fileOut
hierarchy
definition
comment
spawn hierarchy (h)
spawn protocol
inst var refs...
inst var defs...
class var refs...
class vars
class refs (N)
rename...
copy...
remove
unsent methods
find method...
fetch documentation'
		lines: #(4 7 9 11 14 17 )
		selections: #(buildClassBrowser browseMethodFull printOutClass fileOutClass hierarchy editClass editComment spawnHierarchy spawnProtocol browseInstVarRefs browseInstVarDefs browseClassVarRefs browseClassVariables browseClassRefs renameClass copyClass removeClass browseUnusedMethods findMethod fetchClassDocPane )! !

!Browser methodsFor: 'message functions' stamp: 'sma 2/5/2000 13:29'!
messageListMenu: aMenu shifted: shifted
	^ shifted ifFalse: [aMenu labels:
'browse full (b)
fileOut
printOut
senders of... (n)
implementors of... (m)
method inheritance (h)
versions (v)
inst var refs...
inst var defs...
class var refs...
class variables
class refs (N)
remove
more...'
	lines: #(3 7 12)
	selections:
		#(browseMethodFull fileOutMessage printOutMessage
		browseSendersOfMessages browseMessages methodHierarchy browseVersions
		browseInstVarRefs browseInstVarDefs browseClassVarRefs 
			browseClassVariables browseClassRefs
		removeMessage shiftedYellowButtonActivity )]

	ifTrue: [aMenu labels: 'browse class hierarchy
browse class
browse method (O)
make stand-alone method pane
toggle diffing
implementors of sent messages
change sets with this method
inspect instances
inspect subinstances
remove from this browser
change category...
revert to previous version
remove from current change set
revert and forget
fetch documentation
more...' 
	lines:  #(5 7 9 11 14)
	selections: #(classHierarchy browseClass 
		openSingleMessageBrowser makeIsolatedCodePane toggleDiffing browseAllMessages findMethodInChangeSets 
		inspectInstances inspectSubInstances
		removeMessageFromBrowser 
		changeCategory
		revertToPreviousVersion 
		removeFromCurrentChanges revertAndForget 
		fetchDocPane
		unshiftedYellowButtonActivity)]
! !


