'From Squeak2.7 of 5 January 2000 [latest update: #1789] on 5 February 2000 at 7:33:34 pm'!
"Change Set:		ColorPickerEnh
Date:			2 February 2000
Author:			Leandro Caniglia

When the mouse goes down on the RevertBox in a ColorPicker, the event is not reported to the CP since it doesn't contain such points. As a consequence, the user cannot revert to the original color with a simple click on that box. This can be frustrating. Here is a fix. I've also added a selectedColor printString to theSelectorDisplayMorph."!


!ColorPickerMorph methodsFor: 'initialization' stamp: 'LC 2/2/2000 03:18'!
updateSelectorDisplay
	theSelectorDisplayMorph position: self bottomLeft.
	theSelectorDisplayMorph firstSubmorph contents: selector asString , ' ' , selectedColor printString! !

!ColorPickerMorph methodsFor: 'event handling' stamp: 'LC 2/2/2000 03:34'!
mouseDown: evt
	| localPt |
	localPt _ evt cursorPoint - self topLeft.
	(DragBox containsPoint: localPt)
		ifTrue: [^ evt hand grabMorph: self].
	(RevertBox containsPoint: localPt)
		ifTrue: [^ self updateColor: originalColor feedbackColor: originalColor].
	self comeToFront.
	sourceHand _ evt hand.
	self startStepping.
! !

!ColorPickerMorph methodsFor: 'private' stamp: 'LC 2/2/2000 03:17'!
updateTargetColor
	| nArgs |
	(target ~~ nil and: [selector ~~ nil]) ifTrue:
		[self updateSelectorDisplay.
		nArgs _ selector numArgs.
		nArgs = 1 ifTrue:[^target perform: selector with: selectedColor].
		nArgs = 2 ifTrue:[^target perform: selector with: selectedColor with: sourceHand].
		nArgs = 3 ifTrue:[^target perform: selector with: selectedColor with: argument with: sourceHand]].
! !

!ColorPickerMorph methodsFor: 'other' stamp: 'LC 2/2/2000 04:28'!
containsPoint: aPoint 
	^ (super containsPoint: aPoint)
		or: [RevertBox containsPoint: aPoint - self topLeft]! !


