'From Squeak2.8alpha of 12 January 2000 [latest update: #1980] on 4 April 2000 at 1:35:28 pm'!
"Change Set:		RemovalChanges
Date:			4 April 2000
Author:			Dan Ingalls

In the interest of simplicity, removes the convention that removeAllSuchThat: returns a collection of the removals.  This was never used, to the author's knowledge.

Also introduces keysAndValuesRemove:, analogous to keysAndValuesDo:, for removing a number of Dictionary entries without having to maintain a copy during the operation.
"!


!Collection methodsFor: 'removing' stamp: 'di 4/4/2000 12:28'!
removeAllSuchThat: aBlock
	"Apply the condition to each element and remove it if the condition is true.  Use a copy to enumerate collections whose order changes when an element is removed (Set)."

	self copy do:
		[:element | (aBlock value: element) ifTrue: [self remove: element]].
! !


!Dictionary methodsFor: 'removing' stamp: 'di 4/4/2000 11:47'!
keysAndValuesRemove: keyValueBlock
	"Removes all entries for which keyValueBlock returns true."
	"When removing many items, you must not do it while iterating over the dictionary, since it may be changing.  This method takes care of tallying the removals in a first pass, and then performing all the deletions afterward.  Many places in the sytem could be simplified by using this method."

	| removals |
	removals _ OrderedCollection new.
	self associationsDo:
		[:assoc | (keyValueBlock value: assoc key value: assoc value)
			ifTrue: [removals add: assoc key]].
 	removals do:
		[:aKey | self removeKey: aKey]! !


!OrderedCollection methodsFor: 'removing' stamp: 'di 4/4/2000 12:30'!
removeAllSuchThat: aBlock 
	"Evaluate aBlock for each element of the receiver.
	Remove each element for which aBlock evaluates to true."

	| index |
	index _ firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[(aBlock value: (array at: index))
				ifTrue: [self removeIndex: index]
				ifFalse: [index _ index + 1]].
! !


!Path methodsFor: 'removing' stamp: 'di 4/4/2000 12:33'!
removeAllSuchThat: aBlock 
	"Evaluate aBlock for each element of the receiver.
	Remove each element for which aBlock evaluates to true."

	collectionOfPoints removeAllSuchThat: aBlock.
! !

Dictionary removeSelector: #removeAllSuchThatKeyValue:!
