'From Squeak2.8alpha of 4 February 2000 [latest update: #2005] on 22 April 2000 at 6:42:45 pm'!
"Change Set:		1036Speedups-av
Date:			11 April 2000
Author:			Andres Valloud

Fast implementations of methods related to
copying a SequenceableCollection, padding
it with anObject, etc."!


!SequenceableCollection methodsFor: 'accessing' stamp: 'sma 4/22/2000 17:45'!
atAllPut: anObject 
	"Put anObject at every one of the receiver's indices."

	| size |
	(size _ self size) > 26 "first method faster from 27 accesses and on"
		ifTrue: [self from: 1 to: size put: anObject]
		ifFalse: [1 to: size do: [:index | self at: index put: anObject]]! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'sma 4/22/2000 17:52'!
from: startIndex to: endIndex put: anObject
	"Put anObject in all indexes between startIndex 
	and endIndex. Very fast. Faster than to:do: for
	more than 26 positions. No range checks are 
	performed. Answer anObject."

	| written toWrite thisWrite |
	self at: startIndex put: anObject.
	written _ 1.
	toWrite _ endIndex - startIndex + 1.
	[written < toWrite] whileTrue:
		[thisWrite _ written min: toWrite - written.
		self 
			replaceFrom: startIndex + written
			to: startIndex + written + thisWrite - 1
			with: self startingAt: startIndex.
		written _ written + thisWrite].
	^ anObject! !

!SequenceableCollection methodsFor: 'copying' stamp: 'sma 4/22/2000 17:58'!
copyAt: index put: anObject
	"Answer a copy of the receiver with anObject inserted at index."

	^ (self copyFrom: 1 to: self size) at: index put: anObject; yourself! !

!SequenceableCollection methodsFor: 'copying' stamp: 'sma 4/22/2000 18:01'!
forceTo: length paddingWith: elem
	"Force the length of the collection to length, padding
	if necessary with elem.  Note that this makes a copy."

	| newCollection copyLen |
	newCollection _ self species new: length.
	copyLen _ self size min: length.
	newCollection replaceFrom: 1 to: copyLen with: self startingAt: 1.
	newCollection from: copyLen + 1 to: length put: elem.
	^ newCollection! !


!ByteArray methodsFor: 'accessing' stamp: 'sma 4/22/2000 17:47'!
atAllPut: value
	"Fill the receiver with the given value"

	<primitive: 145>
	super atAllPut: value! !


!SharedQueue methodsFor: 'private' stamp: 'sma 4/22/2000 18:04'!
makeRoomAtEnd
	| contentsSize |
	readPosition = 1
		ifTrue: [contentsArray _ contentsArray , (Array new: 10)]
		ifFalse: 
			[contentsSize _ writePosition - readPosition.
			"BLT direction ok for this. Lots faster!!!!!!!!!!!! SqR!!!! 4/10/2000 10:47"
			contentsArray
				replaceFrom: 1
				to: contentsSize
				with: contentsArray
				startingAt: readPosition.
			readPosition _ 1.
			writePosition _ contentsSize + 1]! !


!WordArray methodsFor: 'accessing' stamp: 'sma 4/22/2000 17:47'!
atAllPut: value
	"Fill the receiver with the given value"

	<primitive: 145>
	super atAllPut: value! !

