'From Squeak2.8alpha of 13 January 2000 [latest update: #2081] on 9 May 2000 at 3:22:05 am'!
"Change Set:		reluctantEmbed-sw
Date:			9 May 2000
Author:			Scott Wallace

Simplifies the mechanism by which a PasteUpMorph decides which kinds of drops to accept and which not to accept.  Motivated by a suggestion from Bert Freudenberg.

For the moment, SystemWindows and MenuMorphs obey the systemWindowEmbedOK Preference to decide whether they're willing to be embedded.

Viewers and BookPageSorterMorphs simply decline to be embedded.  To embed them anyway, you would need to drop the over the target, then use the 'embed' command explicitly" !


!Morph methodsFor: 'dropping/grabbing' stamp: 'sw 5/9/2000 02:56'!
willingToBeEmbeddedUponLanding
	"Answer whether the receiver, when dropped over a container that is open to drag-and-drop, is eager to be embedded in the it.  SystemWindows and MenuMorphs are examples of morphs that are reluctant in this regard."
	
	^ true! !


!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2000 03:15'!
willingToBeEmbeddedUponLanding
	^ false! !


!HandMorph methodsFor: 'grabbing/dropping' stamp: 'sw 5/9/2000 02:34'!
dropTargetFor: aMorph event: evt
	"Return the morph that the given morph is to be dropped onto.  Return nil if we must repel the morph.  Return the world, if no other morph wants the dropping morph."

	| root coreSample |
	aMorph willingToBeEmbeddedUponLanding ifFalse: [^ self world].
	root _ nil.
	owner submorphsReverseDo: [:m |
		((m fullContainsPoint: evt cursorPoint) and:
		 [(m isKindOf: HaloMorph) not]) ifTrue: [root _ m]].
	root == nil ifTrue: [^ self world].
	coreSample _ root morphsAt: evt cursorPoint.
	coreSample do:
		[:m |
			(m repelsMorph: aMorph event: evt) ifTrue:
				[^ nil]].

	coreSample do:
		[:m |
			(m wantsDroppedMorph: aMorph event: evt) ifTrue: [^ m]].
	^ self world
! !


!MenuMorph methodsFor: 'control' stamp: 'sw 5/9/2000 02:32'!
willingToBeEmbeddedUponLanding
	^ Preferences systemWindowEmbedOK! !


!PasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'sw 5/9/2000 03:14'!
repelsMorph: aMorph event: ev
	aMorph willingToBeEmbeddedUponLanding ifFalse: [^ false].
	(aMorph isKindOf: Viewer) ifTrue: [^ false].
	openToDragNDrop ifFalse: [^ true].
	(self wantsDroppedMorph: aMorph event: ev) ifFalse: [^ true].
	^ super repelsMorph: aMorph event: ev "consults #repelling flag"! !

!PasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'sw 5/9/2000 03:16'!
wantsDroppedMorph: aMorph event: evt
	aMorph willingToBeEmbeddedUponLanding ifFalse: [^ false].
	self visible ifFalse: [^ false].
	self openToDragNDrop ifFalse: [^ false].
	(self bounds containsPoint: (self pointFromWorld: evt cursorPoint)) ifFalse: [^ false].
	^ true! !


!Preferences class methodsFor: 'help' stamp: 'sw 5/9/2000 03:12'!
moreHelpA

	^ #(	
(systemWindowEmbedOK
	'Determines whether, in Morphic, when a SystemWindow or MenuMorph is dropped onto a willing receptor, it should be deposited into that receptor.')

			) 
! !


!SystemWindow methodsFor: 'events' stamp: 'sw 5/9/2000 02:33'!
willingToBeEmbeddedUponLanding
	^ Preferences systemWindowEmbedOK! !


!Viewer methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2000 03:16'!
willingToBeEmbeddedUponLanding
	^ false! !

"Postscript:"
Preferences callHelpMessageInitializers.!

