'From Squeak2.8alpha of 4 February 2000 [latest update: #2052] on 3 May 2000 at 11:17:09 pm'!
"Change Set:		038CollapseHandle-bk
Date:			14 April 2000
Author:			Bolot Kerimbaev & Chris Norton

Adds a collapse handle, equivalent to the menu item 'collapse'

Also included a fix by Chris: 

1. Create a SketchMorph.
2. Open the Menu halo and choose 'keep this menu up'.
3. Choose collapse.
4. Choose collapse again.

The CollapseMorph suffers a walkback because the collapsed SketchMorph has no personal world."!


!Morph methodsFor: 'accessing' stamp: 'sma 5/3/2000 23:14'!
balloonHelpTextForHandle: aHandle
	|  itsSelector |
	itsSelector _ aHandle eventHandler firstMouseSelector.
	#(	(addFullHandles							'More halo handles')
		(addSimpleHandles						'Fewer halo handles')
		(chooseEmphasisOrAlignment				'Emphasis & alignment')
		(chooseFont								'Change font')
		(chooseStyle								'Change style')
		(dismiss									'Remove')
		(doDebug:with:							'Debug')
		(doDirection:with:						'Choose forward direction')
		(doDup:with:							'Duplicate')
		(doMenu:with:							'Menu')
		(doGrab:with:							'Pick up')
		(doRecolor:with:							'Change color')
		(editDrawing							'Repaint')
		(maybeDoDup:with:						'Duplicate')
		(makeNascentScript						'Make a scratch script')
		(makeNewDrawingWithin				'Paint new object')
		(mouseDownInDimissHandle:with:			'Move to trash')
		(mouseDownInCollapseHandle:with:		'Collapse morph')
		(mouseDownOnHelpHandle:				'Help')
		(openViewerForArgument				'Open a Viewer for me')
		(paintBackground						'Paint background')
		(prepareToTrackCenterOfRotation:with:	'Set center of rotation')
		(startDrag:with:							'Move')
		(startGrow:with:							'Change size') 
		(startRot:with:							'Rotate')
		(startScale:with:							'Change scale') 
		(tearOffTile								'Make a tile representing this object')
		(trackCenterOfRotation:with:				'Set center of rotation')) 


	do:
		[:pair | itsSelector == pair first ifTrue: [^ pair last]].

	^ 'unknown halo handle'! !


!CollapsedMorph methodsFor: 'as yet unclassified' stamp: 'ccn 4/27/2000 22:33'!
beReplacementFor: aMorph

	| itsWorld |
	(itsWorld _ aMorph world) ifNil: [^self].
	uncollapsedMorph _ aMorph.
	self setLabel: aMorph externalName.
	aMorph delete.
	itsWorld addMorphFront: self.
	self collapseOrExpand! !


!HaloMorph methodsFor: 'private' stamp: 'bolot 4/14/2000 19:32'!
maybeCollapse: evt with: collapseHandle
	"Ask hand to collapse my target if mouse comes up in it."

	(collapseHandle containsPoint: evt cursorPoint)
		ifFalse:
			[self delete.
			target addHalo: evt]
		ifTrue:
			[self delete.
			target collapse]! !

!HaloMorph methodsFor: 'private' stamp: 'sma 5/3/2000 23:12'!
mouseDownInCollapseHandle: evt with: collapseHandle
	self removeAllHandlesBut: collapseHandle.
	collapseHandle color: Color tan darker! !

!HaloMorph methodsFor: 'handles' stamp: 'sma 5/3/2000 23:13'!
addCollapseHandle: handleSpec
	"we're hacking here - using mostly dismiss' infrastructure"
	| dismissHandle |
	dismissHandle _ self addHandle: handleSpec
		on: #mouseDown send: #mouseDownInCollapseHandle:with: to: self.
	dismissHandle on: #mouseUp send: #maybeCollapse:with: to: self.
	dismissHandle on: #mouseStillDown send: #setDismissColor:with: to: self.
! !


!Preferences class methodsFor: 'halos' stamp: 'sma 5/3/2000 22:55'!
iconicHaloSpecifications

	"Preferences resetHaloSpecifications"

	^ #(
	"  	selector				horiz		vert			color info						icon key
		---------				------		-----------		-------------------------------		---------------"
	(addCollapseHandle:		left			topCenter		(tan)							'Halo-Collapse')
	(addPoohHandle:			right		center			(white)							'Halo-Pooh')
	(addDebugHandle:		right		topCenter		(blue	veryMuchLighter)		'Halo-Debug')
	(addDismissHandle:		left			top				(red		muchLighter)			'Halo-Dismiss')
	(addRotateHandle:		left			bottom			(blue)							'Halo-Rot')
	(addMenuHandle:		leftCenter	top				(red)							'Halo-Menu')
	(addTileHandle:			left			bottomCenter	(lightBrown)					'Halo-Tile')
	(addViewHandle:			left			center			(cyan)							'Halo-View')
	(addGrabHandle:			center		top				(black)							'Halo-Grab')
	(addDragHandle:			rightCenter	top				(brown)							'Halo-Drag')
	(addDupHandle:			right		top				(green)							'Halo-Dup')	
	(addHelpHandle:			center		bottom			(lightBlue)						'Halo-Help')
	(addGrowHandle:		right		bottom			(yellow)						'Halo-Scale')
	(addScaleHandle:		right		bottom			(lightOrange)					'Halo-Scale')
	(addScriptHandle:		right		bottomCenter	(green muchLighter)			'Halo-Script')
	(addPaintBgdHandle:		right		center			(lightGray)						'Halo-Paint')
	(addRepaintHandle:		right		center			(lightGray)						'Halo-Paint')
	(addFontSizeHandle:		leftCenter	bottom			(lightGreen)						'Halo-FontSize')
	(addFontStyleHandle:		center		bottom			(lightRed)						'Halo-FontStyle')
	(addFontEmphHandle:	rightCenter	bottom			(lightBrown darker)				'Halo-FontEmph')
		) ! !

"Postscript:
Add a collapse icon, reset halo handles"
ScriptingSystem
	saveForm:
	(Form
		extent: 10@16
		depth: 1
		fromArray: #( 0 0 0 0 503316480 2130706432 1635778560 3246391296 3246391296 3246391296 3808428032 2130706432 1006632960 0 0 0)
		offset: 0@0)
	atKey: 'Halo-Collapse'.
Preferences resetHaloSpecifications.
Preferences haloSpecifications.!

