'From Squeak2.8alpha of 13 January 2000 [latest update: #2121] on 15 May 2000 at 3:55:05 am'!
"Change Set:		cmdShiftClickFix-sw
Date:			15 May 2000
Author:			Scott Wallace

Fixes some glitches in the response to the cmd-shift-click halo gesture.

In the progression of halo-bearing objects traversed upon successive cmd-shift-clicks, each step takes you to the next outer morph, but renderers no longer try to appear directly in this sequence, and (in combination with changes in companion changeset 'rendererBlend'), the names beneath the halo at each step are more correct"
!


!HandMorph methodsFor: 'halos' stamp: 'sw 5/14/2000 22:24'!
popUpHaloFromShiftClick: evt
	| oldTargets targets anIndex |
	"Given that the shift key is down, pop up a halo on an appropriate morph.  Go to the deepest morph (locked or not), unless there is an existing halo, in which case go out one level"
	oldTargets _ OrderedCollection new.
	self world haloMorphs do:
		[:h | oldTargets addLast: h innerTarget. h delete].

	targetOffset _ self position.
	(argument _ self argumentOrNil) ifNil: [^ owner "the world" addHalo: evt].
	argument submorphCount = 0 ifTrue: [^ argument addHalo: evt "sole target"].

	"Multiple possible targets, choose the deepest first, but if one already has a halo, then choose the next farther out.   Ignore renderers in the list"
	targets _ (argument morphsAt: targetOffset) reject: [:m | m isRenderer].

	targets size = 0 ifTrue: [^ argument addHalo: evt "sole target"].
	targets size = 1 ifTrue: [^ targets first addHalo: evt "sole target"].
	anIndex _ targets findFirst: [:t | oldTargets includes: t].
	anIndex = 0 ifTrue: [^ targets first addHalo: evt "deepest target"].
	^ (targets atWrap: anIndex + 1) addHalo: evt from: (targets at: anIndex) "next outer target"
! !

