'From Squeak2.8alpha of 4 February 2000 [latest update: #2158] on 20 May 2000 at 6:41:06 pm'!
"Change Set:		078XlucentDND-svp
Date:			17 May 2000
Author:			Stephen Pair

Makes the Browser drag and drop appear with white text on a translucent blue
background.  It also centers the drag morph w.r.t. the cursor."!


!Object methodsFor: 'converting' stamp: 'svp 5/16/2000 18:14'!
asDraggableMorph
	^(StringMorph contents: self printString)
		color: Color white;
		yourself! !


!HandMorph methodsFor: 'grabbing/dropping' stamp: 'svp 5/16/2000 18:27'!
grabMorph: aMorph
	"Grab the given morph (i.e., add it to this hand and remove it from its current owner) without changing its position. This is used to pick up a morph under the hand's current position, versus attachMorph: which is used to pick up a morph that may not be near this hand."
	| editor localPt m trans morphToGrab pos |
	m _ aMorph.
	formerOwner _ m owner.
	formerPosition _ m position.
	m isTileLike ifTrue:
		[editor _ m topEditor].

	(m owner isKindOf: DropShadowMorph) ifTrue:
		[self grabMorph: m owner.
		^ editor ifNotNil: [editor scriptEdited]].

	"Check if the morph will keep it's transform while grabbed"
	m keepsTransform
		ifTrue:[localPt _ self position]
		ifFalse:[localPt _ m pointFromWorld: self position].

	m _ m aboutToBeGrabbedBy: self.
	m == nil ifTrue: [^ self].

	(formerOwner == nil
		or: [m keepsTransform
		or: [(trans _ formerOwner transformFromWorld) isPureTranslation]]) 
		ifTrue: [m position: self position + (m position - localPt).
				morphToGrab _ m.
				addedFlexAtGrab _ false]
		ifFalse: ["Morph was in a flexed environment.  Flex it in the hand."
				pos _ m position.
				morphToGrab _ m addFlexShell transform: trans asMorphicTransform.
				m position: pos.  "revert offset from addFlexShell"
				morphToGrab transform: (trans withOffset: (trans offset + (trans localPointToGlobal: pos + targetOffset) - self position)).
				addedFlexAtGrab _ true].

	gridOn ifTrue: [
		morphToGrab position: (morphToGrab position grid: grid).
	] ifFalse: [ 
		morphToGrab align: morphToGrab center with: self position.
	].
	self addMorphBack: morphToGrab.

	editor ifNotNil: [editor scriptEdited]! !


!TransferMorph methodsFor: 'private' stamp: 'svp 5/16/2000 18:29'!
initDraggedMorph
	| plusMorph |
	draggedMorph ifNil: [
		draggedMorph _ self passenger asDraggableMorph.
		self shouldCopy ifTrue: [
			plusMorph _ ImageMorph new image: CopyPlusIcon.
			draggedMorph addMorph: plusMorph.
			plusMorph position: plusMorph width negated@0].
		draggedMorph position: self position.
		self extent: (draggedMorph fullBounds extent + (6@6)).
		draggedMorph align: draggedMorph topLeft with: (self topLeft + (3@3)).
		self addMorph: draggedMorph]! !

!TransferMorph methodsFor: 'initialization' stamp: 'svp 5/16/2000 18:28'!
initialize
	super initialize.
	self extent: 0@0.
	accepted _ false.
	copy _ false.
	self color: (Color blue alpha: 0.4)! !

