'From Squeak2.9alpha of 13 June 2000 [latest update: #2411] on 18 June 2000 at 12:46:32 pm'!
"Change Set:		154MoreDiscards-sma
Date:			18 June 2000
Author:			Stefan Matthias Aust

Implemented a 80% working discardVMConstruction method and added warning to all old, probably obsolete discard methods which I neverthess tried to fix as best as I could."!


!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:17'!
discard3D
	"Discard 3D Support.
	NOTE: This is untested for 2.8 and later."

	Smalltalk removeKey: #AliceConstants ifAbsent: [].
	Smalltalk removeKey: #B3DEngineConstants ifAbsent: [].
	Smalltalk removeKey: #WonderlandConstants ifAbsent: [].

	SystemOrganization removeCategoriesMatching: 'Balloon3D-*'.
	SystemOrganization removeCategoriesMatching: 'Pooh-*'! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:32'!
discardDiscards
	"Discard all discard* methods - including this one."

	(self class selectors select: [:each | each beginsWith: 'discard']) 
		do: [:each | self class removeSelector: each].
	#(lastRemoval majorShrink zapMVCprojects)
		do: [:each | self class removeSelector: each]! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:19'!
discardFlash
	"Discard Flash and TrueType support.
	NOTE: This is untested for 2.8 and later."

	SystemOrganization removeCategoriesMatching: 'Balloon-MM-Flash*'.
	SystemOrganization removeCategoriesMatching: 'Balloon-TrueType*'! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:20'!
discardFor2Point7
	"Discard additional classes
	NOTE: This is untested for 2.8 and later."

	self discardVMConstruction.
	self discardSoundAndSpeech.
	self discard3D.
	SystemOrganization removeSystemCategory: 'ST80-Morphic'.
	SystemOrganization removeSystemCategory: 'Tools-File Contents Browser'.
	SystemOrganization removeSystemCategory: 'System-Digital Signatures'.
	Smalltalk removeClassNamed: #ProjectController.
	Smalltalk removeClassNamed: #ProjectView.
	Smalltalk removeClassNamed: #Project.
	Smalltalk removeClassNamed: #Environment.
	Smalltalk removeClassNamed: #SmalltalkEnvironment! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:27'!
discardMVC   "Smalltalk discardMVC"
	"NOTE: This is untested for 2.8 and later."

	| keepers |
	Smalltalk isMorphic
		ifFalse: [^ self inform: 'You must be in a Morphic project to discard MVC.'].

	"Check that there are no MVC Projects"
	(Project allInstances inject: true into: [:ok :proj | ok & proj isMorphic])
		ifFalse:
			[(self confirm: 'Would you like a chance to remove your
MVC projects in an orderly manner?')
					ifTrue: [^ self].
			(self confirm: 'If you wish, I can remove all MVC projects,
make this project be the top project, and place
all orphaned sub-projects of MVC parents here.
Would you like be to do this
and proceed to discard all MVC classes?')
					ifTrue: [self zapMVCprojects]
					ifFalse: [^ self]].

	Smalltalk reclaimDependents.

	"Remove old Paragraph classes and View classes."
	(ChangeSet superclassOrder: Paragraph withAllSubclasses asArray)
		reverseDo: [:c | c removeFromSystem].
	(ChangeSet superclassOrder: View withAllSubclasses asArray)
		reverseDo: [:c | c removeFromSystem].

	"Get rid of ParagraphEditor's ScrollController dependence"
	#(markerDelta viewDelta scrollAmount scrollBar computeMarkerRegion)
		do: [:sel | ParagraphEditor removeSelector: sel].
	ParagraphEditor compile: 'updateMarker'.
	SystemOrganization classify: #ParagraphEditor under: 'Morphic-Text Support'.

	"Get rid of all Controller classes not needed by ParagraphEditor and ScreenController"
	keepers _ TextMorphEditor withAllSuperclasses copyWith: ScreenController.
	(ChangeSet superclassOrder: Controller withAllSubclasses asArray)
		reverseDo: [:c | (keepers includes: c) ifFalse: [c removeFromSystem]].

	SystemOrganization removeCategoriesMatching: 'Graphics-Symbols'.
	SystemOrganization removeCategoriesMatching: 'Graphics-Paths'.
	SystemOrganization removeCategoriesMatching: 'Interface-Pluggable'.

	Smalltalk removeClassNamed: 'FormButtonCache'.
	Smalltalk removeClassNamed: 'WindowingTransformation'.
	Smalltalk removeClassNamed: 'ControlManager'.
	Smalltalk removeClassNamed: 'DisplayTextView'.

	ScheduledControllers _ nil.
	Undeclared removeUnreferencedKeys.
	SystemOrganization removeEmptyCategories.
	Symbol rehash! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:28'!
discardMorphic   "Smalltalk discardMorphic"
	"NOTE: This is untested for 2.8 and later."

	| subs |
	"Check that we are in an MVC Project and that there are no Morphic Projects
		or WorldMorphViews."
	Utilities clobberFlapTabList.
	Smalltalk discard3D.
	Smalltalk discardFlash.
	subs _ OrderedCollection new.
	Morph allSubclassesWithLevelDo: [:c :i | subs addFirst: c]
		startingLevel: 0.
	subs do: [:c | c removeFromSystem].
	Smalltalk removeKey: #BalloonEngineConstants ifAbsent: [].
	SystemOrganization removeCategoriesMatching: 'User Objects'.
	SystemOrganization removeCategoriesMatching: 'Experimental-*'.
	SystemOrganization removeCategoriesMatching: 'Balloon-*'.
	SystemOrganization removeCategoriesMatching: 'Morphic-*'.
	SystemOrganization removeCategoriesMatching: 'TrueType-*'.
	SystemOrganization removeSystemCategory: 'Graphics-Transformations'.

! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:29'!
discardNetworking
	"Discard the support for TCP/IP networking.
	NOTE: This is untested for 2.8 and later."

	SystemOrganization removeSystemCategory: 'Network-*'! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:30'!
discardOddsAndEnds    "Smalltalk discardOddsAndEnds"
	"This method throws out lots of classes that are not frequently used.
	NOTE: This is untested for 2.8 and later."

	SystemOrganization removeSystemCategory: 'System-Serial Port'.
	SystemOrganization removeSystemCategory: 'Graphics-Symbols'.
	SystemOrganization removeSystemCategory: 'Interface-File Contents Browser'.
	SystemOrganization removeSystemCategory: 'System-Compression'.
	SystemOrganization removeSystemCategory: 'Interface-Explorer'.

	Form removeSelector: #edit.
	Smalltalk at: #FormView ifPresent:
		[:c | c compile: 'defaultControllerClass  ^ NoController'
			classified: 'controller access'].
	Smalltalk removeClassNamed: #FormEditorView.
	Smalltalk removeClassNamed: #FormEditor.
	SystemOrganization removeSystemCategory: 'Graphics-Paths'.

	"bit editor (remove Form editor first):"
	Form removeSelector: #bitEdit.
	Form removeSelector: #bitEditAt:scale:.
	StrikeFont removeSelector: #edit:.
	Smalltalk removeClassNamed: #FormButtonCache.
	Smalltalk removeClassNamed: #FormMenuController.
	Smalltalk removeClassNamed: #FormMenuView.
	Smalltalk removeClassNamed: #BitEditor.

	"inspector for Dictionaries of Forms"
	Dictionary removeSelector: #inspectFormsWithLabel:.
	SystemDictionary removeSelector: #viewImageImports.
	ScreenController removeSelector: #viewImageImports.
	Smalltalk removeClassNamed: #FormHolderView.
	Smalltalk removeClassNamed: #FormInspectView.

	"experimental hand-drawn character recoginizer:"
	ParagraphEditor removeSelector: #recognizeCharacters.
	ParagraphEditor removeSelector: #recognizer:.
	ParagraphEditor removeSelector: #recognizeCharactersWhileMouseIn:.
	Smalltalk removeClassNamed: #CharRecog.

	"experimental updating object viewer:"
	Object removeSelector: #evaluate:wheneverChangeIn:.
	Smalltalk removeClassNamed: #ObjectViewer.
	Smalltalk removeClassNamed: #ObjectTracer.

	"miscellaneous classes:"
	Smalltalk removeClassNamed: #Array2D.
	Smalltalk removeClassNamed: #DriveACar.
	Smalltalk removeClassNamed: #EventRecorder.
	Smalltalk removeClassNamed: #FindTheLight.
	Smalltalk removeClassNamed: #PluggableTest.
	Smalltalk removeClassNamed: #SystemMonitor.
	Smalltalk removeClassNamed: #DocLibrary.

	Smalltalk removeClassNamed: #ProtocolBrowser.
	Smalltalk removeClassNamed: #ObjectExplorerWrapper.
	Smalltalk removeClassNamed: #HierarchyBrowser.
	Smalltalk removeClassNamed: #LinkedMessageSet.
	Smalltalk removeClassNamed: #ObjectExplorer.
	Smalltalk removeClassNamed: #PackageBrowser.
	Smalltalk removeClassNamed: #AbstractHierarchicalList.
	Smalltalk removeClassNamed: #ChangeList.
	Smalltalk removeClassNamed: #VersionsBrowser.
	Smalltalk removeClassNamed: #ChangeRecord.

	Smalltalk at: #SampledSound ifPresent: [:c |
		(Smalltalk confirm: 'Remove all sounds from the SampledSound library?')
		ifTrue: [c initialize]].
	#(Helvetica Palatino Courier ComicBold ComicPlain) do:
		[:k | TextConstants removeKey: k ifAbsent: []].

Preferences setButtonFontTo:	(StrikeFont familyName: #NewYork size: 12).
Preferences setFlapsFontTo:	(StrikeFont familyName: #NewYork size: 12).

#(GZipConstants ZipConstants KlattResonatorIndices ) do:
	[:k | Smalltalk removeKey: k ifAbsent: []].
! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:30'!
discardSoundSynthesis
	"Discard the sound synthesis facilities, and the methods and classes that use it.
	NOTE: This is untested for 2.8 and later."

	SystemOrganization removeCategoriesMatching: 'Sound-*'.

	Smalltalk removeClassNamed: #EnvelopeLineMorph.
	Smalltalk removeClassNamed: #EnvelopeEditorMorph.
	Smalltalk removeClassNamed: #PianoKeyboardMorph.
	Smalltalk removeClassNamed: #WaveEditor.
	Smalltalk removeClassNamed: #SoundSequencerMorph.
	Smalltalk removeClassNamed: #SoundMorph.
	Smalltalk removeClassNamed: #SoundLoopMorph.
	Smalltalk removeClassNamed: #InterimSoundMorph.
	Smalltalk removeClassNamed: #RecordingControlsMorph.
	Smalltalk removeClassNamed: #PermanentRecordingControlsMorph.
	Smalltalk removeClassNamed: #SoundDemoMorph.
	Smalltalk removeSelector: #(GraphMorph playOnce).
	Smalltalk removeSelector: #(GraphMorph readDataFromFile).
	Smalltalk removeSelector: #(TrashCanMorph samplesForDelete).
	Smalltalk removeSelector: #(TrashCanMorph samplesForMouseEnter).
	Smalltalk removeSelector: #(TrashCanMorph samplesForMouseLeave)! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:31'!
discardVMConstruction
	"NOTE: Removing the plugins (Squeak-Plugins) leads to a lot of dangling 
	references in Balloon, Speech and Sound classes."

	Smalltalk removeKey: #InterpreterLog ifAbsent: [].

	SystemOrganization removeCategoriesMatching: 'VMConstruction-*'.
	SystemOrganization removeCategoriesMatching: 'Squeak-Interpreter'.
	SystemOrganization removeCategoriesMatching: 'Squeak-Plugins'.

	Smalltalk removeClassNamed: #FXBltSimulator.
	Smalltalk removeClassNamed: #FXBltSimulation.
	ParseNode withAllSubclassesDo: [:e | e removeSelector: #asTranslatorNode].
	Smalltalk removeSelector: #(BitBlt copyBitsSimulated).
	Smalltalk removeSelector: #(FXBlt copyBitsSimulated).
	Smalltalk removeSelector: #(WarpBlt warpBitsSimulated:sourceMap:).
	Smalltalk removeSelector: #(FloatArray class cCodeString).

	Smalltalk removeSelector: #(Object primitive:parameters:receiver:)! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:41'!
lastRemoval  "Smalltalk lastRemoval"

	"Some explicit removals - add unwanted methods keeping other methods."
	#(abandonSources printSpaceAnalysis)
		do: [:each | self class removeSelector: each].

	"Get rid of all unsent methods."
	[self removeAllUnSentMessages > 0] whileTrue.

	"Shrink method dictionarys."
	Set allSubInstancesDo: [:each | each rehash].

	Smalltalk allClassesDo: [:c | c zapOrganization].
	SystemOrganization _ nil.

	Smalltalk changes initialize! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'sma 6/18/2000 12:45'!
majorShrink    "Smalltalk majorShrink; abandonSources; lastRemoval"
	"This method throws out lots of the system that is not needed for, eg, operation in a hand-held PC.  Currently, since it discards Morphic, majorShrink must be run in an MVC project.  Moreover, since it throws out projects, it shouod be run in the top (and only) project.  majorShrink altogether saves about 5,620k in Squeak 2.4"

"First delete all the PlayWithMe windows and projects, and the class Component1"

	self inform: 'This method is obsolete.
It still does a good job reducing the
image size but you have need warned.

Press OK to continue.'.

	Wonderland removeActorPrototypesFromSystem.
	Player freeUnreferencedSubclasses.
	MorphicModel removeUninstantiatedModels.
	Utilities classPool at: #ScrapsBook put: nil.
"==>"	Smalltalk discardFor2Point7.
	Smalltalk discardVMConstruction.  "666k"
	Smalltalk discardSoundSynthesis.  "358k"
	Smalltalk discardOddsAndEnds.  "158k"
	Smalltalk discardNetworking.  "243k"
	Smalltalk discardMorphic.  "2,494k"
	Symbol rehash.  "40k"
	"Above by itself saves about 3,960k"

"
	| a | a _ Smalltalk garbageCollect.
	Smalltalk majorShrink.
	Smalltalk garbageCollect - a
"
	"Remove references to a few classes to be deleted, so that they won't leave obsolete versions around."
	FileList removeSelector: #fileIntoNewChangeSet.
	ChangeSet class compile: 'defaultName
		^ ''Changes'' ' classified: 'initialization'.
	ScreenController removeSelector: #openChangeManager.
	ScreenController removeSelector: #exitProject.
	ScreenController removeSelector: #openProject.
	ScreenController removeSelector: #viewImageImports.

	"Now delete lots of classes.."
	SystemOrganization removeSystemCategory: 'Graphics-Symbols'.
	SystemOrganization removeSystemCategory: 'Graphics-Files'.
	SystemOrganization removeSystemCategory: 'Interface-Projects'.
	SystemOrganization removeSystemCategory: 'System-Object Storage'.

	Smalltalk removeClassNamed: #FormSetFont.
	Smalltalk removeClassNamed: #FontSet.
	Smalltalk removeClassNamed: #InstructionPrinter.
	Smalltalk removeClassNamed: #ChangeSorter.
	Smalltalk removeClassNamed: #DualChangeSorter.
	Smalltalk removeClassNamed: #EmphasizedMenu.
	Smalltalk removeClassNamed: #MessageTally.

	StringHolder class removeSelector: #originalWorkspaceContents.
	CompiledMethod removeSelector: #symbolic.

	RemoteString removeSelector: #makeNewTextAttVersion.
	Utilities class removeSelector: #absorbUpdatesFromServer.
	Smalltalk removeClassNamed: #PenPointRecorder.
	Smalltalk removeClassNamed: #Path.
	Smalltalk removeClassNamed: #Base64MimeConverter.
	Smalltalk removeClassNamed: #EToySystem.
	Smalltalk removeClassNamed: #RWBinaryOrTextStream.
	Smalltalk removeClassNamed: #AttributedTextStream.
	Smalltalk removeClassNamed: #CornerRounder.
	Smalltalk removeClassNamed: #WordNet.
	Smalltalk removeClassNamed: #SelectorBrowser.

	TextStyle allSubInstancesDo:
		[:ts | ts newFontArray: (ts fontArray copyFrom: 1 to: (2 min: ts fontArray size))].
	ListParagraph initialize.
	PopUpMenu initialize.
	StandardSystemView initialize.

	Smalltalk noChanges.
	ChangeSorter classPool at: #AllChangeSets 
		put: (OrderedCollection with: Smalltalk changes).
	ScriptingSystem _ nil.
	SystemDictionary removeSelector: #majorShrink.

	[Smalltalk removeAllUnSentMessages > 0]
		whileTrue:
		[Smalltalk unusedClasses do: [:c | (Smalltalk at: c) removeFromSystem]].
	SystemOrganization removeEmptyCategories.
	Smalltalk allClassesDo: [:c | c zapOrganization].
	Symbol rehash.! !

SystemDictionary removeSelector: #discardMIDI!
SystemDictionary removeSelector: #discardPluggableWebServer!
