'From Squeak2.9alpha of 13 June 2000 [latest update: #2426] on 25 June 2000 at 3:40:42 pm'!
"Change Set:		167ColorMix-sma
Date:			25 June 2000
Author:			Stefan Matthias Aust

Karl noticed that #lighter and #darker for translucent colors didn't work.  Here's a fix as suggested by Ted K."!


!Color methodsFor: 'transformations' stamp: 'sma 6/25/2000 15:36'!
alpha: alphaValue 
	"Answer a new Color with the given amount of opacity ('alpha')."

	alphaValue = 1.0
		ifFalse: [^ TranslucentColor basicNew setRgb: rgb alpha: alphaValue]! !

!Color methodsFor: 'transformations' stamp: 'sma 6/25/2000 15:35'!
alphaMixed: proportion with: aColor 
	"Deprecated. Use #mixed:with: instead."

	^ self mixed: proportion with: aColor! !

!Color methodsFor: 'transformations' stamp: 'sma 6/25/2000 15:34'!
mixed: proportion with: aColor 
	"Answer this color mixed with the given color. The proportion, a number 
	between 0.0 and 1.0, determines what what fraction of the receiver to  
	use in the mix. For example, 0.9 would yield a color close to the  
	receiver. This method uses RGB interpolation; HSV interpolation can lead 
	to surprises."

	| frac1 frac2 |
	frac1 _ proportion asFloat min: 1.0 max: 0.0.
	frac2 _ 1.0 - frac1.
	^ Color
		r: self red * frac1 + (aColor red * frac2)
		g: self green * frac1 + (aColor green * frac2)
		b: self blue * frac1 + (aColor blue * frac2)
		alpha: self alpha * frac1 + (aColor alpha * frac2)! !

