'From Squeak2.9alpha of 12 June 2000 [latest update: #2575] on 10 September 2000 at 9:32:43 am'!
"Change Set:		ResizableMonthMorph
Date:			10 September 2000
Author:			Dan Ingalls

Makes MonthMorphs be resizable in anticipation of their being used as components in other applications.
"!

AlignmentMorph subclass: #MonthMorph
	instanceVariableNames: 'month showingToday tileRect '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Demo'!
AlignmentMorph subclass: #WeekMorph
	instanceVariableNames: 'week month tileRect '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Demo'!

!MonthMorph methodsFor: 'all' stamp: 'di 9/7/2000 01:33'!
checkForTodayShowing

	| today ts sm thisMonth |
	today _ Date today.
	thisMonth _ today month.
	(thisMonth = month or: [showingToday ifNil: [true]]) ifFalse: [^ self].
	showingToday _ false.
	ts _ today dayOfMonth printString.
	self allMorphsDo:
		[:m | (m isKindOf: SimpleSwitchMorph) ifTrue:
			[(sm _ m findA: StringMorph) ifNotNil:
				[(sm contents = ts and: [thisMonth = month])
					ifTrue: [(m borderWidth = 2 and: [m borderColor = Color yellow]) ifFalse:
								[m borderWidth: 2; borderColor: Color yellow].
							showingToday _ true]
					ifFalse: [m borderWidth: 1;
								setSwitchState: m color = m onColor]]]].

! !

!MonthMorph methodsFor: 'all' stamp: 'di 9/10/2000 09:09'!
extent: newExtent

	tileRect _ 0@0 extent: (newExtent / 7.0 max: 18@12).
	self initializeWeeks.! !

!MonthMorph methodsFor: 'all' stamp: 'di 9/7/2000 01:14'!
initialize
	super initialize.
	tileRect _ 0@0 extent: 23@19.
	self inset: 1;
		color: Color red;
		orientation: #vertical;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		month: Date today month! !

!MonthMorph methodsFor: 'all' stamp: 'di 9/7/2000 01:25'!
initializeHeader
	| title sep  frame button monthName |
	title _ (self findA: WeekMorph) title.
	monthName _ month name.
	self width < 160 ifTrue:
		[(#(6 7 9) includes: month index)
			ifTrue: [monthName _ monthName copyFrom: 1 to: 4]
			ifFalse: [monthName _ monthName copyFrom: 1 to: 3]].
	sep _ Morph new color: Color transparent; extent: title width @ 1.
	self
		addMorph: sep;
		addMorph: title;
		addMorph: sep copy.
	button _ SimpleButtonMorph new
				target: self;
				actWhen: #whilePressed;
				color: (Color r: 0.8 g: 0.8 b: 0.8).
	frame _ AlignmentMorph new
		color: Color transparent;
		orientation: #horizontal;
		inset: 0.
	frame
		addMorph:
			(button
				label: '>>';
				actionSelector: #nextYear;
				width: 15);
		addMorph:
			(button copy
				label: '>';
				actionSelector: #next;
				width: 15);
		addMorph:
			((AlignmentMorph new
				color: Color transparent;
				orientation: #vertical;
				"hResizing: #shrinkWrap;"
				centering: #center;
				extent: (title fullBounds width - (button width * 3)) @ title height)
				addMorph:
					(StringMorph new
						contents:
							monthName, ' ', month year printString));
		addMorph:
			(button copy
				label: '<';
				actionSelector: #previous;
				width: 15);
		addMorph:
			(button copy
				label: '<<';
				actionSelector: #previousYear;
				width: 15).
	self addMorph: frame! !

!MonthMorph methodsFor: 'all' stamp: 'di 9/7/2000 00:52'!
initializeWeeks
	| weeks |
	self removeAllMorphs.
	weeks _ OrderedCollection new.
	month eachWeekDo: [:each | weeks add: (WeekMorph newWeek: each month: month tileRect: tileRect)].
	weeks reverseDo: [:each | self addMorph: each].
	self initializeHeader.

! !

!MonthMorph methodsFor: 'all' stamp: 'di 9/10/2000 09:09'!
minExtent

	^ (18 @ 12) * 7! !

!MonthMorph methodsFor: 'all' stamp: 'di 9/7/2000 01:35'!
month: aMonth
	month _ aMonth.
	self initializeWeeks.
	self checkForTodayShowing! !

!MonthMorph methodsFor: 'all' stamp: 'di 9/7/2000 01:33'!
step

	self checkForTodayShowing! !

!MonthMorph methodsFor: 'all' stamp: 'di 9/7/2000 01:35'!
stepTime

	^ 60000  "Once a minute is good enough to check for day rollover"! !


!WeekMorph methodsFor: 'all' stamp: 'di 9/7/2000 01:13'!
initialize

	^ self initializeForWeek: Date today week
		month: Date today month
		tileRect: (0@0 extent: 23@19)
! !

!WeekMorph methodsFor: 'all' stamp: 'di 9/7/2000 01:10'!
initializeForWeek: aWeek month: aMonth tileRect: rect

	super initialize.
	tileRect _ rect.
	self inset: 0;
		color: Color transparent;
		orientation: #horizontal;
		hResizing: #shrinkWrap;
		disableDragNDrop;
		height: tileRect height.
	self week: aWeek month: aMonth
! !

!WeekMorph methodsFor: 'all' stamp: 'di 9/6/2000 22:49'!
tile
	| onColor offColor |
	offColor _ Color r: 0.4 g: 0.8 b: 0.6.
	onColor _ offColor alphaMixed: 1/2 with: Color white.
	^ SimpleSwitchMorph new
		offColor: offColor;
		onColor: onColor;
		borderWidth: 1;
		useSquareCorners;
		extent: tileRect extent! !

!WeekMorph methodsFor: 'all' stamp: 'di 9/6/2000 22:49'!
tileLabeled: labelString
	| onColor offColor |
	offColor _ Color r: 0.4 g: 0.8 b: 0.6.
	onColor _ offColor alphaMixed: 1/2 with: Color white.
	^ (SimpleSwitchMorph newWithLabel: labelString)
		offColor: offColor;
		onColor: onColor;
		borderWidth: 1;
		useSquareCorners;
		extent: tileRect extent;
		setSwitchState: false! !

!WeekMorph methodsFor: 'all' stamp: 'di 9/6/2000 22:50'!
title
	"Answer a title with the names of the days."
	| title extent days |
	title _ AlignmentMorph new
		inset: 0;
		color: Color red;
		orientation: #horizontal;
		vResizing: #shrinkWarp;
		height: tileRect height.
		extent _ self tile extent.
	days _ Week startMonday
		ifTrue: [7 to: 1 by: -1]       "Original code, Mon-Sun."
		ifFalse: [#(6 5 4 3 2 1 7)].   "Sun-Sat."
	(days collect: [:each | Date nameOfDay: each]) do:
		[:each |
		title addMorph:
			((self tileLabeled: (each copyFrom: 1 to: 2))
				extent: extent;
				setBalloonText: each printString)].
	^ title
	! !


!WeekMorph class methodsFor: 'instance creation' stamp: 'di 9/6/2000 22:46'!
newWeek: aWeek month: aMonth

	^ self basicNew initializeForWeek: aWeek month: aMonth tileRect: (0@0 extent: 23@19)
! !

!WeekMorph class methodsFor: 'instance creation' stamp: 'di 9/6/2000 22:46'!
newWeek: aWeek month: aMonth tileRect: rect

	^ self basicNew initializeForWeek: aWeek month: aMonth tileRect: rect
! !

WeekMorph removeSelector: #initializeForWeek:month:!
MonthMorph removeSelector: #isAlignmentMorph!
