'From Squeak2.9alpha of 13 June 2000 [latest update: #2558] on 3 September 2000 at 1:40:34 pm'!
"Change Set:		006-SerialPortChanges-dns

I've been playing with serial ports on my Powerbook G3 and I discovered some not so nice actions in class SerialPort. If the port is in use elsewhere, trying to open it gets a Primitive Error.

I'd rather have my code get back some indication that the port didn't open, so I made some small mods to SerialPort, which are attached. Basically, primitives used during open answer nil if they fail, and the open method answers nil also.

Dave"!


!SerialPort methodsFor: 'open/close' stamp: 'dns 6/27/2000 19:49'!
openPort: portNumber
	"Open the given serial port, using the settings specified by my instance variables. If the port cannot be opened, such as when it is alreay in use, answer nil."  "(DNS)"

	self close.
	(self primClosePort: portNumber) isNil ifTrue: [
		^ nil ].
	(self primOpenPort: portNumber
		baudRate: baudRate
		stopBitsType: stopBitsType
		parityType: parityType
		dataBits: dataBits
		inFlowControlType: inputFlowControlType
		outFlowControlType: outputFlowControlType
		xOnByte: xOnByte
		xOffByte: xOffByte) isNil ifTrue: [
			^ nil ].
	port _ portNumber
! !

!SerialPort methodsFor: 'primitives' stamp: 'dns 6/27/2000 19:43'!
primClosePort: portNumber

	<primitive: 239>
	^ nil  "(DNS)"
	"self primitiveFailed."
! !

!SerialPort methodsFor: 'primitives' stamp: 'dns 6/27/2000 19:48'!
primOpenPort: portNumber baudRate: baud stopBitsType: stop
	parityType: parity dataBits: numDataBits
	inFlowControlType: inFlowCtrl outFlowControlType: outFlowCtrl
	xOnByte: xOn xOffByte: xOff

	<primitive: 238>
	^ nil  "(DNS)"
! !

