'From Squeak2.9alpha of 13 June 2000 [latest update: #2912] on 30 October 2000 at 8:16:10 am'!
"Change Set:		sMovie5DupFix
Date:			30 October 2000
Author:			Dan Ingalls

Makes green-handle duplication work properly for MoviePlayerMorphs.
"!


!MoviePlayerMorph methodsFor: 'initialization' stamp: 'di 10/30/2000 08:10'!
duplicate
	| dup |
	playDirection ~= 0 ifTrue: [self stopPlay].
	dup _ super duplicate.
	dup scorePlayer: scorePlayer copy.  "Share sound track if any."
	^ dup duplicateMore startStepping! !

!MoviePlayerMorph methodsFor: 'initialization' stamp: 'di 10/30/2000 08:11'!
duplicateMore
	"Duplicate dies not replicate Forms, but MoviePlayers need this."

	frameBufferIfScaled _ frameBufferIfScaled deepCopy.
	currentPage image: currentPage image deepCopy.
! !

!MoviePlayerMorph methodsFor: 'controls and layout' stamp: 'di 10/29/2000 12:02'!
extent: newExtent

	| tlMargin brMargin pageExtent scale fullSizeImage |
	fullSizeImage _ frameBufferIfScaled ifNil: [currentPage image].
	frameCount ifNil: [^ self].  "Not yet open"
	tlMargin _ currentPage topLeft - self topLeft.
	brMargin _ self bottomRight - currentPage bottomRight.
	pageExtent _ newExtent - brMargin - tlMargin.
	scale _ pageExtent x asFloat / frameSize x min: pageExtent y asFloat / frameSize y.
	(scale _ scale max: 0.25) > 0.9 ifTrue: [scale _ 1.0].

	pageExtent _ (frameSize * scale) rounded.
	pageExtent = frameSize
		ifTrue: [currentPage image: fullSizeImage.
				frameBufferIfScaled _ nil]
		ifFalse: [currentPage image: (Form extent: pageExtent depth: frameDepth).
				frameBufferIfScaled _ fullSizeImage.
				(WarpBlt current toForm: currentPage image) sourceForm: fullSizeImage;
					combinationRule: 3;
					copyQuad: fullSizeImage boundingBox innerCorners
						toRect: currentPage image boundingBox].
	^ self layoutChanged
! !

