'From Squeak2.9alpha of 17 July 2000 [latest update: #2974] on 8 November 2000 at 11:48:42 am'!
"Change Set:		leavingNebraska
Date:			8 November 2000
Author:			Bob Arning

- expanding UI for Nebraska clients with Quit button to end Nebraska session. Controls now in floating navigator bar."!

ProjectNavigationMorph subclass: #NebraskaNavigationMorph
	instanceVariableNames: 'nebraskaBorder '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!NetworkTerminalBorderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:31'!
initialize
	| |
	super initialize.
	self setBalloonText: 'I am a view on another Squeak'.
	"button _ BasicButton new label: ' 1x1 ' font: nil.
	button on: #mouseUp send: #toggleFullView to: self.
	button setBalloonText: 'Switch between 1x1 and scaled view'.
	self addMorphFront: button."! !


!NetworkTerminalMorph methodsFor: 'initialization' stamp: 'RAA 11/8/2000 11:38'!
openScaled

	| window tm |
	window _ NetworkTerminalBorderMorph new
		minWidth: 100;
		minHeight: 100;
		borderWidth: 8;
		borderColor: Color orange;
		bounds: (0@0 extent: Display extent * 3 // 4).
	tm _ BOBTransformationMorph new.
	tm useRegularWarpBlt: true.		"try to reduce memory used"
	window addMorphBack: tm.
	tm addMorph: self.
	window openInWorld.
	NebraskaNavigationMorph new 
		nebraskaBorder: window;
		openInWorld.! !


!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:28'!
initialColor

	^Color orange
! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:28'!
initialize

	super initialize.
	self useRoundedCorners.
	inset _ 6.
	color _ self initialColor.
	hResizing _ #shrinkWrap.
	vResizing _ #shrinkWrap.
	mouseInside _ false.

	self addButtons.
! !


!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:39'!
addButtons

	self addARow: {
		self inAColumn: {self buttonScale}.
		self inAColumn: {self buttonQuit}.
	}.
! !

!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:36'!
buttonQuit

	^self makeButton: 'Quit' balloonText: 'Quit this Nebraska session' for: #quitNebraska
! !

!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:34'!
buttonScale

	^self makeButton: '1x1' balloonText: 'Switch between 1x1 and scaled view' for: #toggleFullView
! !

!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:47'!
currentNavigatorVersion

	^1		"not particularly relevant here"! !

!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:27'!
fontForButtons

	^Preferences standardButtonFont! !

!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:29'!
initialColor

	^Color yellow! !

!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:35'!
nebraskaBorder: aNebraskaBorder

	nebraskaBorder _ aNebraskaBorder! !

!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:44'!
positionVertically

	| w |
	w _ self world ifNil: [^self].
	self top < w top ifTrue: [self top: w top].
	self bottom > w bottom ifTrue: [self bottom: w bottom].! !

!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:47'!
quitNebraska

	nebraskaBorder ifNotNil: [nebraskaBorder delete].
	self delete.! !

!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:37'!
step

	super step.
	(nebraskaBorder isNil or: [nebraskaBorder world isNil]) ifTrue: [self delete].! !

!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:48'!
toggleFullView

	nebraskaBorder ifNotNil: [nebraskaBorder toggleFullView]! !

!NebraskaNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/8/2000 11:42'!
wantsToBeDroppedInto: aMorph

	"avoid difficulties in placement"
	^(aMorph isKindOf: NetworkTerminalMorph) not! !

