'From Squeak2.9alpha of 13 June 2000 [latest update: #2915] on 12 November 2000 at 12:03:49 pm'!
"Change Set:		233ShiftCrOffBy1-hg
Date:			9 October 2000
Author:			Henrik Gedenryd

If you do shift-cr with the cursor at the end of the edited text (as regularly when typing a new method), you get an error. A fix for a long-standing off-by-one bug."!


!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'hg 10/6/2000 18:51'!
crWithIndent: characterStream 
	"Replace the current text selection with CR followed by as many tabs
	as on the current line (+/- bracket count) -- initiated by Shift-Return."
	| char s i tabCount |
	sensor keyboard.		"flush character"
	s _ paragraph string.
	i _ stopBlock stringIndex.
	tabCount _ 0.
	[(i _ i-1) > 0 and: [(char _ s at: i) ~= Character cr]]
		whileTrue:  "Count tabs and brackets (but not a leading bracket)"
		[(char = Character tab and: [i < s size and: [(s at: i+1) ~= $[ ]]) ifTrue: [tabCount _ tabCount + 1].
		char = $[ ifTrue: [tabCount _ tabCount + 1].
		char = $] ifTrue: [tabCount _ tabCount - 1]].
	characterStream crtab: tabCount.  "Now inject CR with tabCount tabs"
	^ false! !

