'From Squeak2.9alpha of 13 June 2000 [latest update: #2915] on 12 November 2000 at 12:15:57 pm'!
"Change Set:		236EnhBlockCxtErrMsg-mdr
Date:			5 October 2000
Author:			Mike Rutenberg

This changes the error message to not only tell you how many arguments are required by a block, but also how many were used in the attempted evaluation.

Can be tested by evaluating 
	[] value: 1 value: 2"!


!BlockContext methodsFor: 'evaluating' stamp: 'mdr 10/5/2000 10:33'!
valueWithArguments: anArray 
	"Primitive. Evaluate the block represented by the receiver. The argument 
	is an Array whose elements are the arguments for the block. Fail if the 
	length of the Array is not the same as the the number of arguments that 
	the block was expecting. Fail if the block is already being executed. 
	Essential. See Object documentation whatIsAPrimitive."

	<primitive: 82>
	self numArgs = anArray size
		ifTrue: [self error: 'Attempt to evaluate a block that is already being evaluated.']
		ifFalse: [self error: 'This block requires ' , self numArgs printString , ' arguments and is being evaluated with ', anArray size printString]! !

