'From Squeak2.9alpha of 12 June 2000 [latest update: #3162] on 11 December 2000 at 10:40:07 am'!
"Change Set:		DebugAids
Date:			11 December 2000
Author:			Dan Ingalls

Adds preferences for showing damage rectangles during morphic display, and for showing the bounds rectangle of a morph during halo display.  Both default to false.
"!


!HaloMorph methodsFor: 'drawing' stamp: 'di 12/10/2000 17:03'!
drawOn: aCanvas
	"Draw this morph only if it has no target."

	target == nil ifTrue: [^ super drawOn: aCanvas].
	Preferences showBoundsInHalo ifTrue:
		[aCanvas frameAndFillRectangle: target bounds
				fillColor: Color transparent
				borderWidth: 1
				borderColor: Color blue]! !


!WorldState methodsFor: 'update cycle' stamp: 'di 12/9/2000 10:58'!
displayWorld: aWorld submorphs: submorphs
	"Update this world's display."

	| deferredUpdateMode worldDamageRects handsToDraw handDamageRects allDamage |

	submorphs do: [:m | m fullBounds].  "force re-layout if needed"
	self checkIfUpdateNeeded ifFalse: [^ self].  "display is already up-to-date"

	deferredUpdateMode _ self doDeferredUpdatingFor: aWorld.
	deferredUpdateMode ifFalse: [self assuredCanvas].

	worldDamageRects _ self drawWorld: aWorld submorphs: submorphs invalidAreasOn: canvas.  "repair world's damage on canvas"
	"self handsDo:[:h| h noticeDamageRects: worldDamageRects]."
	handsToDraw _ self selectHandsToDrawForDamage: worldDamageRects.
	handDamageRects _ handsToDraw collect: [:h | h savePatchFrom: canvas].
	allDamage _ worldDamageRects, handDamageRects.

	handsToDraw reverseDo: [:h | canvas fullDrawMorph: h].  "draw hands onto world canvas"

	"*make this true to flash damaged areas for testing*"
	Preferences debugShowDamage ifTrue: [aWorld flashRects: allDamage color: Color black].

	canvas finish.
	"quickly copy altered rects of canvas to Display:"
	deferredUpdateMode
		ifTrue: [self forceDamageToScreen: allDamage]
		ifFalse: [canvas showAt: aWorld viewBox origin invalidRects: allDamage].
	handsToDraw do: [:h | h restoreSavedPatchOn: canvas].  "restore world canvas under hands"
	Display deferUpdates: false; forceDisplayUpdate.
! !

"Postscript:
Two new preferences for easy debugging."
Preferences addPreference: #debugShowDamage category: #debug default: false
balloonHelp: 'If true, every changed region of the morphic display will be flashed black before updating.'.
Preferences addPreference: #showBoundsInHalo category: #halos default: false
balloonHelp: 'If true, halos will include a fine rectangle around the bounds of the target morph.'.
!

