'From Squeak2.9alpha of 17 July 2000 [latest update: #3242] on 9 January 2001 at 11:58:13 am'!
"Change Set:		fixSwitches
Date:			9 January 2001
Author:			Bob Arning

Many changes to Browser to used fixed height panes where appropriate"!


!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 10:39'!
addMorphicSwitchesTo: window at: aLayoutFrame

	window 
		addMorph: (self buildMorphicSwitches borderWidth: 0)
		fullFrame: aLayoutFrame.

! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 11:20'!
addOptionalAnnotationsTo: window at: fractions plus: verticalOffset

	| aTextMorph delta |
	Preferences useAnnotationPanes ifFalse: [^verticalOffset].
	aTextMorph _ PluggableTextMorph 
		on: self
		text: #annotation 
		accept: nil
		readSelection: nil
		menu: nil.
	aTextMorph askBeforeDiscardingEdits: false.
	delta _ 25.
	window 
		addMorph: aTextMorph 
		fullFrame: (
			LayoutFrame 
				fractions: fractions 
				offsets: (0@verticalOffset corner: 0@(verticalOffset + delta))
		).
	^verticalOffset + delta

! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 11:15'!
addOptionalButtonsTo: window at: fractions plus: verticalOffset

	| delta |
	Preferences optionalButtons ifFalse: [^verticalOffset].
	delta _ 25.
	window 
		addMorph: self optionalButtonRow 
		fullFrame: (
			LayoutFrame 
				fractions: fractions 
				offsets: (0@verticalOffset corner: 0@(verticalOffset + delta))
		).
	^verticalOffset + delta
! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 10:59'!
buildMorphicClassList

	| myClassList |

	myClassList _ PluggableListMorph on: self list: #classList
			selected: #classListIndex changeSelected: #classListIndex:
			menu: #classListMenu:shifted: keystroke: #classListKey:from:.
	myClassList enableDragNDrop: Preferences browseWithDragNDrop.
	^myClassList

! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 11:01'!
buildMorphicCodePaneWith: editString

	| codePane |

	codePane _ PluggableTextMorph 
		on: self 
		text: #contents 
		accept: #contents:notifying:
		readSelection: #contentsSelection 
		menu: #codePaneMenu:shifted:.
	editString ifNotNil: [
		codePane editString: editString.
		codePane hasUnacceptedEdits: true
	].
	^codePane
! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 10:55'!
buildMorphicMessageCatList

	| myMessageCatList |
	myMessageCatList _ PluggableMessageCategoryListMorph on: self list: #messageCategoryList
			selected: #messageCategoryListIndex changeSelected: #messageCategoryListIndex:
			menu: #messageCategoryMenu: 
			keystroke: #arrowKey:from: getRawListSelector: #rawMessageCategoryList.
	myMessageCatList enableDragNDrop: Preferences browseWithDragNDrop.
	^myMessageCatList
! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 10:58'!
buildMorphicMessageList

	| aListMorph |

	aListMorph _ PluggableListMorph on: self list: #messageList
			selected: #messageListIndex changeSelected: #messageListIndex:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:.
	aListMorph enableDragNDrop: Preferences browseWithDragNDrop.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	^aListMorph

! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 11:40'!
openAsMorphClassEditing: editString
	"Create a pluggable version a Browser on just a single class."
	| window dragNDropFlag hSepFrac switchHeight mySingletonClassList nominalFractions verticalOffset |
	window _ (SystemWindow labelled: 'later') model: self.

	dragNDropFlag _ Preferences browseWithDragNDrop.
	hSepFrac _ 0.3.
	switchHeight _ 25.
	mySingletonClassList _ PluggableListMorph on: self list: #classListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #classListMenu:shifted: keystroke: #classListKey:from:.
	mySingletonClassList enableDragNDrop: dragNDropFlag.
	window 
		addMorph: mySingletonClassList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 0.5@0) 
				offsets: (0@0 corner: 0@switchHeight)
		).
	
	self 
		addMorphicSwitchesTo: window 
		at: (
			LayoutFrame 
				fractions: (0.5@0 corner: 1.0@0) 
				offsets: (0@0 corner: 0@switchHeight)
		).

	window 
		addMorph: self buildMorphicMessageCatList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 0.5@hSepFrac) 
				offsets: (0@switchHeight corner: 0@0)
		).

	window 
		addMorph: self buildMorphicMessageList
		fullFrame: (
			LayoutFrame 
				fractions: (0.5@0 corner: 1.0@hSepFrac) 
				offsets: (0@switchHeight corner: 0@0)
		).

	nominalFractions _ 0@hSepFrac corner: 1@hSepFrac.
	verticalOffset _ 0.
	verticalOffset _ self addOptionalAnnotationsTo: window at: nominalFractions plus: verticalOffset.
	verticalOffset _ self addOptionalButtonsTo: window  at: nominalFractions plus: verticalOffset.

	window 
		addMorph: (self buildMorphicCodePaneWith: editString)
		fullFrame: (
			LayoutFrame 
				fractions: (0@hSepFrac corner: 1@1) 
				offsets: (0@verticalOffset corner: 0@0)
		).

	window setUpdatablePanesFrom: #(messageCategoryList messageList).
	^ window! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 11:27'!
openAsMorphEditing: editString
	"Create a pluggable version of all the morphs for a Browser in Morphic"
	| window aListMorph dragNDropFlag switchHeight myCatList myClassList hSepFrac myMessageCatList nominalFractions verticalOffset |

	switchHeight _ 25.
	hSepFrac _ 0.4.
	window _ (SystemWindow labelled: 'later') model: self.

	dragNDropFlag _ Preferences browseWithDragNDrop.
	myCatList _ PluggableListMorph on: self list: #systemCategoryList
			selected: #systemCategoryListIndex changeSelected: #systemCategoryListIndex:
			menu: #systemCategoryMenu: keystroke: #systemCatListKey:from:.
	myCatList enableDragNDrop: dragNDropFlag.
	myClassList _ self buildMorphicClassList.
	myMessageCatList _ self buildMorphicMessageCatList.

	aListMorph _ self buildMorphicMessageList.

	window 
		addMorph: myCatList
		frame: (0@0 corner: 0.25@hSepFrac).
	window 
		addMorph: myClassList
		fullFrame: (
			LayoutFrame 
				fractions: (0.25@0 corner: 0.5@hSepFrac) 
				offsets: (0@0 corner: 0@switchHeight negated)
		).	
	self 
		addMorphicSwitchesTo: window 
		at: (
			LayoutFrame 
				fractions: (0.25@hSepFrac corner: 0.5@hSepFrac) 
				offsets: (0@switchHeight negated  corner: 0@0)
		).

	window 
		addMorph: myMessageCatList
		frame: (0.5@0 extent: 0.25@hSepFrac).
	window addMorph: aListMorph
		frame: (0.75@0 extent: 0.25@hSepFrac).

	nominalFractions _ 0@hSepFrac corner: 1@hSepFrac.
	verticalOffset _ 0.
	verticalOffset _ self addOptionalAnnotationsTo: window at: nominalFractions plus: verticalOffset.
	verticalOffset _ self addOptionalButtonsTo: window  at: nominalFractions plus: verticalOffset.

	window 
		addMorph: (self buildMorphicCodePaneWith: editString)
		fullFrame: (
			LayoutFrame 
				fractions: (0@hSepFrac corner: 1@1) 
				offsets: (0@verticalOffset corner: 0@0)
		).

	window setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	^ window! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 11:31'!
openAsMorphMessageEditing: editString
	"Create a pluggable version a Browser that shows just one message"
	| window mySingletonMessageList verticalOffset nominalFractions |
	window _ (SystemWindow labelled: 'later') model: self.

	mySingletonMessageList _ PluggableListMorph on: self list: #messageListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:.
	mySingletonMessageList enableDragNDrop: Preferences browseWithDragNDrop.
	verticalOffset _ 25.
	nominalFractions _ 0@0 corner: 1@0.
	window 
		addMorph: mySingletonMessageList
		fullFrame: (
			LayoutFrame 
				fractions: nominalFractions 
				offsets: (0@0 corner: 0@verticalOffset)
		).

	verticalOffset _ self addOptionalAnnotationsTo: window at: nominalFractions plus: verticalOffset.
	verticalOffset _ self addOptionalButtonsTo: window  at: nominalFractions plus: verticalOffset.

	window 
		addMorph: (self buildMorphicCodePaneWith: editString)
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@1) 
				offsets: (0@verticalOffset corner: 0@0)
		).

	^ window! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 11:38'!
openAsMorphMsgCatEditing: editString
	"Create a pluggable version a Browser on just a message category."

	| window hSepFrac verticalOffset nominalFractions |
	window _ (SystemWindow labelled: 'later') model: self.
	hSepFrac _ 0.3.
	window 
		addMorph: ((PluggableListMorph on: self list: #messageCatListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #messageCategoryMenu:) enableDragNDrop: Preferences browseWithDragNDrop)
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@0) 
				offsets: (0@0 corner: 0@25)
		).
	window 
		addMorph: self buildMorphicMessageList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@hSepFrac) 
				offsets: (0@25 corner: 0@0)
		).

	verticalOffset _ 0.
	nominalFractions _ 0@hSepFrac corner: 1@hSepFrac.
	verticalOffset _ self addOptionalAnnotationsTo: window at: nominalFractions plus: verticalOffset.
	verticalOffset _ self addOptionalButtonsTo: window  at: nominalFractions plus: verticalOffset.

	window 
		addMorph: (self buildMorphicCodePaneWith: editString)
		fullFrame: (
			LayoutFrame 
				fractions: (0@hSepFrac corner: 1@1) 
				offsets: (0@verticalOffset corner: 0@0)
		).
	window setUpdatablePanesFrom: #(messageCatListSingleton messageList).
	^ window! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 1/9/2001 11:52'!
openAsMorphSysCatEditing: editString
	"Create a pluggable version of all the views for a Browser, including views and controllers."
	| window hSepFrac nominalFractions verticalOffset switchHeight mySingletonList nextOffsets |
	window _ (SystemWindow labelled: 'later') model: self.

	hSepFrac _ 0.30.
	switchHeight _ 25.
	mySingletonList _ PluggableListMorph on: self list: #systemCategorySingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #systemCatSingletonMenu: keystroke: #systemCatSingletonKey:from:.
 	mySingletonList enableDragNDrop: Preferences browseWithDragNDrop.
	window 
		addMorph: mySingletonList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@0) 
				offsets: (0@0  corner: 0@switchHeight)
		).	

	nextOffsets _ 0@switchHeight corner: 0@0.
	window 
		addMorph: self buildMorphicClassList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 0.3333@hSepFrac) 
				offsets: (0@switchHeight corner: 0@switchHeight negated)
		).	
	
	self 
		addMorphicSwitchesTo: window 
		at: (
			LayoutFrame 
				fractions: (0@hSepFrac corner: 0.3333@hSepFrac) 
				offsets: (0@switchHeight negated  corner: 0@0)
		).

	window 
		addMorph: self buildMorphicMessageCatList
		fullFrame: (
			LayoutFrame 
				fractions: (0.3333@0 corner: 0.6666@hSepFrac) 
				offsets: nextOffsets
		).	

	window 
		addMorph: self buildMorphicMessageList
		fullFrame: (
			LayoutFrame 
				fractions: (0.6666@0 corner: 1@hSepFrac) 
				offsets: nextOffsets
		).	

	nominalFractions _ 0@hSepFrac corner: 1@hSepFrac.
	verticalOffset _ 0.
	verticalOffset _ self addOptionalAnnotationsTo: window at: nominalFractions plus: verticalOffset.
	verticalOffset _ self addOptionalButtonsTo: window  at: nominalFractions plus: verticalOffset.

	window 
		addMorph: (self buildMorphicCodePaneWith: editString)
		fullFrame: (
			LayoutFrame 
				fractions: (0@hSepFrac corner: 1@1) 
				offsets: (0@verticalOffset corner: 0@0)
		).

	window setUpdatablePanesFrom: #( classList messageCategoryList messageList).
	^ window! !

Browser removeSelector: #addOptionalAnnotationsTo:at:!
Browser removeSelector: #addOptionalButtonsTo:at:!
