'From Squeak2.9alpha of 17 July 2000 [latest update: #3261] on 13 January 2001 at 7:29:29 am'!
"Change Set:		reallySmall
Date:			13 January 2001
Author:			Bob Arning

- allow annotation pane to be made a bit smaller"!


!CodeHolder methodsFor: 'misc' stamp: 'RAA 1/13/2001 07:20'!
addOptionalAnnotationsTo: window at: fractions plus: verticalOffset

	| aTextMorph delta |
	Preferences useAnnotationPanes ifFalse: [^verticalOffset].
	aTextMorph _ PluggableTextMorph 
		on: self
		text: #annotation 
		accept: nil
		readSelection: nil
		menu: #annotationPaneMenu:shifted:.
	aTextMorph
		askBeforeDiscardingEdits: false;
		borderWidth: 1;
		borderColor: Color lightGray.
	delta _ 25.
	window 
		addMorph: aTextMorph 
		fullFrame: (
			LayoutFrame 
				fractions: fractions 
				offsets: (0@verticalOffset corner: 0@(verticalOffset + delta))
		).
	^verticalOffset + delta

! !

!CodeHolder methodsFor: 'misc' stamp: 'RAA 1/13/2001 07:20'!
annotationPaneMenu: aMenu shifted: shifted

	^ aMenu 
		labels: 'change pane size'
		lines: #()
		selections: #(toggleAnnotationPaneSize)! !


!PluggableTextMorph methodsFor: 'menu commands' stamp: 'RAA 1/13/2001 07:24'!
toggleAnnotationPaneSize

	| handle origin aHand siblings newHeight lf prevBottom m ht |

	self flag: #bob.		"CRUDE HACK to enable changing the size of the annotations pane"

	owner ifNil: [^self].
	siblings _ owner submorphs.
	siblings size > 3 ifTrue: [^self].
	siblings size < 2 ifTrue: [^self].

	aHand _ self primaryHand.
	origin _ aHand position.
	handle _ HandleMorph new
		forEachPointDo: [:newPoint |
			handle removeAllMorphs.
			newHeight _ (newPoint - origin) y asInteger min: owner height - 50 max: 16.
			lf _ siblings last layoutFrame.
			lf bottomOffset: newHeight negated.
			prevBottom _ newHeight.
			siblings size - 1 to: 1 by: -1 do: [ :index |
				m _ siblings at: index.
				lf _ m layoutFrame.
				ht _ (lf topOffset + lf bottomOffset) negated.
				lf topOffset: prevBottom.
				lf bottomOffset = 0 ifFalse: [
					lf bottomOffset: (prevBottom + ht) negated.
				].
				prevBottom _ prevBottom + ht.
			].
			owner layoutChanged.

		]
		lastPointDo:
			[:newPoint | handle deleteBalloon.
			self halo doIfNotNil: [:halo | halo addHandles].
		].
	aHand attachMorph: handle.
	handle setProperty: #helpAtCenter toValue: true.
	handle showBalloon:
'Move cursor farther from
this point to increase pane.
Click when done.' hand: aHand.
	handle startStepping

! !

Browser removeSelector: #addOptionalAnnotationsTo:at:plus:!
Browser removeSelector: #annotationPaneMenu:shifted:!
