'From Squeak2.9alpha of 13 June 2000 [latest update: #3289] on 19 January 2001 at 4:30:46 pm'!
"Change Set:		PluginProjects
Date:			19 January 2001
Author:			Andreas Raab

Allow Squeak plugins to handle project (.pr) files automatically, i.e., jump right into the project when a .pr file appears as in
<EMBED 
	TYPE = application/x-squeak-source
	SRC = sampleproject.001.pr
>
"!


!CodeLoader methodsFor: 'installing' stamp: 'ar 1/19/2001 16:28'!
installProject
	"Assume that we're loading a single file and it's a project"
	| aStream |
	aStream _ sourceFiles first contentStream.
	aStream ifNil:[^self error:'Project was not loaded'].
	ProjectLoading
			openFromFile: aStream
			fromDirectory: nil
			withProjectView: nil.
! !


!PluginLauncher methodsFor: 'running' stamp: 'ar 1/19/2001 16:29'!
startUp
	| scriptName loader |

	World ifNotNil: [World install].
	StandardFileStream isRunningAsBrowserPlugin
		ifFalse: [^self].
	scriptName _ self parameterAt: 'src'.
	scriptName isEmpty ifTrue:[^self].
	CodeLoader defaultBaseURL: (self parameterAt: 'Base').

	loader _ PluginCodeLoader new.
	loader loadSourceFiles: (Array with: scriptName).
	(scriptName asLowercase endsWith: '.pr') 
		ifTrue:[loader installProject]
		ifFalse:[loader installSourceFiles].! !

