'From Squeak 2.0 of May 22, 1998 on 23 September 1998 at 11:28:01 pm'!

!ChangeSet methodsFor: 'change management' stamp: 'SqR!!!! 9/23/1998 23:05'!
addClass: class 
	"Include indication that a new class was created."

	self atClass: class add: #add.
	self addCoherency: class name! !

!ChangeSet methodsFor: 'change management' stamp: 'SqR!!!! 9/23/1998 23:06'!
changeClass: class 
	"Include indication that a class definition has been changed. 
	 6/10/96 sw: don't accumulate this information for classes that don't want logging
	 7/12/96 sw: use wantsChangeSetLogging flag"

	class wantsChangeSetLogging ifTrue: 
		[
			self atClass: class add: #change.
			self addCoherency: class name
		]! !

!ChangeSet methodsFor: 'change management' stamp: 'SqR!!!! 9/23/1998 23:16'!
verifyClassRemoves
	"Verify the internal collection of classes to be
	removed. For every class name there, check if
	a class named like that exists. If it does, then
	remove it from the classRemoves. If it doesn't, 
	leave it alone. Use this to fix change sets broken
	by classes deleted and then added back.

	Also, delete the deleted items that are not symbols (?!!)"

	classRemoves _ classRemoves reject: [:one | (Smalltalk at: one ifAbsent: []) isNil not or: [one ~~ one asSymbol]]! !

!ChangeSet methodsFor: 'private' stamp: 'SqR!!!! 9/23/1998 23:08'!
addCoherency: className
	"SqR!! 19980923: If I recreate the class then don't remove it"

	classRemoves remove: className ifAbsent: [].
	(classChanges includesKey: className) ifTrue:
		[(classChanges at: className) remove: #remove ifAbsent: []]! !


