'From Squeak 2.2 of Sept 23, 1998 on 6 October 1998 at 2:15:40 pm'!
"Change Set:		diskLoadTweaks-sw
Date:			6 October 1998
Author:			Scott Wallace

Adds two variant spellings of the .jpg suffix to the list of suffixes being looked for in the new-morph-from-file command, and splits out the acceptable-graphics-suffix list into a separate method."!


!HandMorph methodsFor: 'world menu commands' stamp: 'sw 10/6/1998 14:13'!
readMorphFromAFile
	"Produce a morph from a file -- either a saved .morph file or a graphics file"

	| morphOrList ff aName f m |
	aName _ Utilities chooseFileWithSuffixFromList:
(#('.morph'), Utilities graphicsFileSuffixes) withCaption: 'Choose a file
to load'.
	aName ifNil: [^ self].  "User made no choice"
	aName == #none ifTrue: [^ self inform: 
'Sorry, no suitable files found
(names should end with .morph, .gif,
.bmp, .jpeg, .jpe, .jp, or .form)'].

	(aName asLowercase endsWith: '.morph')
		ifTrue:
			[ff _ FileStream oldFileNamed: aName.
			morphOrList _ ff fileInObjectAndCode.		"code filed in is the Model class"
			"the file may contain either a single morph or an array of morphs"
			self world addMorphsAndModel: morphOrList]
		ifFalse:
			[f _ Form fromFileNamed: aName.
			f ifNil: [^ self error: 'unrecognized image file format'].
			m _ self drawingClass new form: f.
			self attachMorph: m]
! !


!Utilities class methodsFor: 'summer97 additions' stamp: 'sw 10/6/1998 14:09'!
graphicsFileSuffixes
	"Answer a list of filename suffixes which signal file content which we are able to internalize"

	^#('.gif' '.bmp' '.jpg' '.jpeg' '.jpe', '.form')! !


