'From Squeak3.1alpha of 4 February 2001 [latest update: #3845] on 16 March 2001 at 12:35:14 am'!
"Change Set:		EvtClickFix-ar
Date:			16 March 2001
Author:			Andreas Raab

An attempt to fix the #mouseStillDown: click problem."!


!HandMorph methodsFor: 'private events' stamp: 'ar 3/16/2001 00:33'!
generateMouseEvent: evtBuf
	"Generate the appropriate mouse event for the given raw event buffer"
	| position buttons modifiers type trail stamp oldButtons evtChanged |
	(evtBuf at: 1) = (lastEventBuffer at: 1) ifTrue:[
		"Workaround for Mac VM bug, *always* generating 3 events on clicks"
		evtChanged _ false.
		3 to: evtBuf size do:[:i| (lastEventBuffer at: i) = (evtBuf at: i) ifFalse:[evtChanged _ true]].
		evtChanged ifFalse:[^nil]].

	stamp _ (evtBuf at: 2).
	stamp = 0 ifTrue:[stamp _ Time millisecondClockValue].
	position _ (evtBuf at: 3) @ (evtBuf at: 4).
	buttons _ (evtBuf at: 5).
	modifiers _ (evtBuf at: 6).
	buttons = 0 
		ifTrue:[	(lastEventBuffer at: 5) = 0
					ifTrue:[type _ #mouseMove]
					ifFalse:[type _ #mouseUp]]
		ifFalse:[	(lastEventBuffer at: 5) = 0
					ifTrue:[type _ #mouseDown]
					ifFalse:[type _ #mouseMove]].
	buttons _ buttons bitOr: (modifiers bitShift: 3).
	oldButtons _ (lastEventBuffer at: 5) bitOr: ((lastEventBuffer at: 6) bitShift: 3).
	lastEventBuffer _ evtBuf.
	type == #mouseMove ifTrue:[
		trail _ self mouseTrailFrom: evtBuf.
		^MouseMoveEvent new 
			setType: type 
			startPoint: trail first
			endPoint: trail last 
			trail: trail
			buttons: buttons
			hand: self
			stamp: stamp.
	].
	^MouseButtonEvent new 
		setType: type 
		position: position
		which: (oldButtons bitXor: buttons)
		buttons: buttons 
		hand: self
		stamp: stamp! !

