'From Squeak3.1alpha of 28 February 2001 [latest update: #4159] on 18 June 2001 at 10:44:45 am'!
"Change Set:		chgListAnnotTweak-sw
Date:			18 June 2001
Author:			Scott Wallace

When a method in a ChangeList browser has no in-image counterpart, make the annotation reflect that more directly."!


!ChangeList methodsFor: 'viewing access' stamp: 'sw 6/18/2001 10:44'!
annotation
	"Answer the string to be shown in an annotation pane.  Make plain that the annotation is associated with the current in-image version of the code, not of the selected disk-based version, and if the corresponding method is missing from the in-image version, mention that fact."

	| annot aChange aClass |

	annot _ super annotation.
	annot asString = '------' ifTrue: [^ annot].

	^ ((aChange _ self currentChange) notNil and: [aChange methodSelector notNil])
		ifFalse:
			[annot]
		ifTrue:
			[((aClass _ aChange methodClass) isNil or: [(aClass includesSelector: aChange methodSelector) not])
				ifTrue:
					[aChange methodClassName, ' >> ', aChange methodSelector, ' is not present in the current image.']
				ifFalse:
					['current version: ', annot]]! !

