'From Squeak3.1alpha of 28 February 2001 [latest update: #4175] on 27 June 2001 at 9:49:29 pm'!
"Change Set:		extSettings-mir
Date:			25 June 2001
Author:			Michael Rueger

Adds a very first version of an external settings mechanism.
Objects or classes can register themselves as clients to be notified at startup.
The preference files have to be in a folder 'prefs' either in the current working directory or in the vmPath directory."!

Object subclass: #ExternalSettings
	instanceVariableNames: ''
	classVariableNames: 'RegisteredClients '
	poolDictionaries: ''
	category: 'System-Support'!

!ExternalSettings commentStamp: '<historical>' prior: 0!
ExternalSettings manages settings kept externally, e.g. files.
Objects can register themselves as clients to be notified at startup time to read their settings.

Eventually all the preferences should be managed through this mechanism.
!


!ExternalSettings class methodsFor: 'private' stamp: 'mir 6/25/2001 18:46'!
registeredClients
	RegisteredClients ifNil: [RegisteredClients _ Set new].
	^RegisteredClients! !

!ExternalSettings class methodsFor: 'accessing' stamp: 'mir 6/26/2001 00:17'!
preferenceDirectory
	| prefDirName prefDir |
	prefDirName _ 'prefs'.
	^(FileDirectory default directoryExists: prefDirName)
		ifTrue: [FileDirectory default directoryNamed: prefDirName]
		ifFalse: [
			((FileDirectory on: Smalltalk vmPath) directoryExists: prefDirName)
				ifTrue: [(FileDirectory on: Smalltalk vmPath) directoryNamed: prefDirName]
				ifFalse: [
					prefDir _ FileDirectory default directoryNamed: prefDirName.
					prefDir assureExistance.
					prefDir]]
! !

!ExternalSettings class methodsFor: 'accessing' stamp: 'mir 6/25/2001 18:45'!
registerClient: anObject
	"Register anObject as a settings client to be notified on startup."

	self registeredClients add: anObject! !

!ExternalSettings class methodsFor: 'class initialization' stamp: 'mir 6/25/2001 18:46'!
initialize
	"ExternalSettings initialize"

	Smalltalk addToStartUpList: self! !

!ExternalSettings class methodsFor: 'class initialization' stamp: 'mir 6/26/2001 00:07'!
startUp
	"Look for external server defs and load them."
	"ExternalSettings startUp"

	self registeredClients do: [:client | 
		client fetchExternalSettingsIn: self preferenceDirectory]! !

ExternalSettings initialize!























