'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 6 January 2001 at 4:59:14 pm'!
"Change Set:		crlfzip-ls
Date:			6 January 2001
Author:			Lex Spoon

Changes decompression to use binary mode for reading files in a few places.  This is important if the file object is a CrLfFileStream.  (To see the problem, change FileStream>>concreteClass to return a CrLfFileStream and try decompressing files in the FileList.)

Also, it inserts a uses of withSqueakLineEndings in place of some code that intended to do the same thing."!


!FileList methodsFor: 'file list menu' stamp: 'ls 1/2/2001 11:45'!
saveGZipContents
	"Save the contents of a gzipped file"
	| zipped buffer unzipped newName |
	newName _ fileName copyUpToLast: FileDirectory extensionDelimiter.
	unzipped _ directory newFileNamed: newName.
	unzipped binary.
	zipped _ GZipReadStream on: (directory readOnlyFileNamed: self fullName).
	buffer _ ByteArray new: 50000.
	'Extracting ' , self fullName
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: zipped sourceStream size
		during: 
			[:bar | 
			[zipped atEnd]
				whileFalse: 
					[bar value: zipped sourceStream position.
					unzipped nextPutAll: (zipped nextInto: buffer)].
			zipped close.
			unzipped close].
	self updateFileList.
	^ newName! !

!FileList methodsFor: 'file list menu' stamp: 'ls 1/2/2001 11:55'!
viewGZipContents
	"View the contents of a gzipped file"
	| f |
	f _ (directory readOnlyFileNamed: self fullName).
	f binary.
	contents _ f contentsOfEntireFile.
	Cursor wait showWhile:[contents _ (GZipReadStream on: contents) upToEnd].
	contents _ contents asString withSqueakLineEndings.

	(StringHolder new)
		contents: contents;
		openLabel:'Contents of ', fileName printString! !


!InflateStream methodsFor: 'initialize' stamp: 'ls 1/2/2001 11:44'!
on: aCollectionOrStream
	aCollectionOrStream isStream 
		ifTrue:[	aCollectionOrStream binary.
				sourceStream _ aCollectionOrStream.
				self getFirstBuffer]
		ifFalse:[source _ aCollectionOrStream].
	^self on: source from: 1 to: source size.! !

