'From Squeak3.2alpha of 3 October 2001 [latest update: #4441] on 24 October 2001 at 9:46:23 am'!
"Change Set:		ZipToolInObjectsTool-nk
Date:			24 October 2001
Author:			Ned Konz

This adds the Archive Viewer to the Tools and Useful pages of the Object Tool as 'Zip Tool'.

It fixes the problem of opening an extra window that my prior change set had. This fix was contributed by Darryl Smith.

It also fixes the pane color in the AlternativeWindowLook, which was annoyingly translucent."!


!ArchiveViewer methodsFor: 'initialization' stamp: 'nk 10/24/2001 08:53'!
backgroundColor
	^self defaultBackgroundColor! !

!ArchiveViewer methodsFor: 'initialization' stamp: 'dls 10/22/2001 07:39'!
createWindow
	| list heading font text |
	self color: self backgroundColor.
	self minimumExtent: 550@230.
	self extent: self minimumExtent.

	font _ (TextStyle named: #DefaultFixedTextStyle)
		ifNotNilDo: [ :ts | ts fontArray first ].

	self addMorph: (self createButtonBar)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1.0@0.0) offsets: (0@0 corner: 0@44)).

	heading _ self createListHeadingUsingFont: font.
	self addMorph: heading
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1.0@0.0) offsets: (0@44 corner: 0@60)).

	(list _ PluggableListMorph new)
		on: self list: #memberList
		selected: #memberIndex changeSelected: #memberIndex:
		menu: #memberMenu:shifted: keystroke: nil.
	list color: self backgroundColor.
	font ifNotNil: [ list font: font ].
	self addMorph: list
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1.0@0.8) offsets: (0@60 corner: 0@0)).

	text _ PluggableTextMorph on: self 
			text: #contents accept: nil
			readSelection: nil menu: nil.
	self addMorph: text
		frame: (0@0.8 corner: 1.0@1.0).
	text lock.

	self setLabel: 'Ned''s Zip Viewer'! !

!ArchiveViewer methodsFor: 'initialization' stamp: 'nk 10/24/2001 08:53'!
defaultBackgroundColor
	^Color white! !

!ArchiveViewer methodsFor: 'panes' stamp: 'nk 10/24/2001 09:43'!
paneColor
	^self backgroundColor darker darker! !

!ArchiveViewer methodsFor: 'parts bin' stamp: 'dls 10/22/2001 07:40'!
initializeToStandAlone
	self initialize createWindow.! !


!ArchiveViewer class methodsFor: 'parts bin' stamp: 'nk 9/11/2001 17:58'!
descriptionForPartsBin

	^ self partName: 'Zip Tool'
		categories: #(Tools Useful)
		documentation: 'A viewer and editor for Zip archive files'
! !

"Postscript:
Regenerate thumbnails."
PartsBin initialize; cacheAllThumbnails 
!

