'From Squeak3.2alpha of 2 October 2001 [latest update: #4516] on 14 November 2001 at 10:05:32 pm'!
"Change Set:		CollapseFix
Date:			14 November 2001
Author:			Dan Ingalls for Scott Wallace

Fixes a bug arising from the changes in 4510RespectMinimumExtent.
Now the minimum extent is only applied to windows that are not collapsed.
"!


!SystemWindow methodsFor: 'geometry' stamp: 'di 11/14/2001 22:00'!
extent: aPoint 
	"Set the receiver's extent to value provided. Respect my minimumExtent."

	| newExtent |
	newExtent _ self isCollapsed
		ifTrue: [aPoint]
		ifFalse: [aPoint max: self minimumExtent].
	newExtent = self extent ifTrue: [^ self].

	isCollapsed
		ifTrue: [super extent: newExtent x @ (self labelHeight + 2)]
		ifFalse: [super extent: newExtent].
	labelArea ifNotNil:
		[self setStripeColorsFrom: self paneColorToUse.
		label fitContents; setWidth: (label width min: bounds width - self labelWidgetAllowance).
		label layoutFrame leftOffset: label width negated // 2].
	isCollapsed
		ifTrue: [collapsedFrame _ self bounds]
		ifFalse: [fullFrame _ self bounds]! !

