'From Squeak3.2alpha of 3 October 2001 [latest update: #4589] on 8 December 2001 at 12:53:27 am'!
"Change Set:		greenPref-sw
Date:			7 December 2001
Author:			Scott Wallace

A small point of closure -- if the interim #greenKeyboardFoci preference is found to be false, set the keyboard-focus-feedback color to transparent; in any case, expunge the green preference.  Use the keyboardFocusColor, possibly transparent of course, for drawing keyboard-focus-highlighting in menus (rather than the former hard-coded green)"!


!MenuMorph methodsFor: 'drawing' stamp: 'sw 12/8/2001 00:45'!
drawOn: aCanvas
	"Draw the menu.  Add keyboard-focus feedback if appropriate"

	super drawOn: aCanvas.
	ActiveHand keyboardFocus == self ifTrue:
		[aCanvas frameAndFillRectangle: self innerBounds fillColor: Color transparent borderWidth: 1 borderColor: Preferences keyboardFocusColor]! !

!PluggableListMorph methodsFor: 'drawing' stamp: 'sw 12/8/2001 00:38'!
drawOn: aCanvas
	"Draw the list on the canvas, and possibly also draw frame feedback"

	| colorToFillWith areaToFill next |

	super drawOn: aCanvas.
	
	selectedMorph ifNotNil:
		[colorToFillWith _ color.
		next _ self.
		[colorToFillWith isTransparent and: [(next _ next owner) notNil]] whileTrue:
			[colorToFillWith _ next color].
		colorToFillWith _ colorToFillWith luminance < 0.5
			ifTrue:
				[colorToFillWith muchLighter]
			ifFalse:
				[colorToFillWith darker].

		areaToFill _ ((scroller transformFrom: self) localBoundsToGlobal: selectedMorph bounds)
						intersect: scroller bounds.
		aCanvas fillRectangle: areaToFill color: colorToFillWith].

	self hasFocus ifTrue:
		[aCanvas frameRectangle: scroller bounds color: Preferences keyboardFocusColor]! !

"Postscript:"
Preferences greenKeyboardFoci ifFalse:
	[Preferences keyboardFocusColor: Color transparent].
Preferences expungePreferenceNamed: #greenKeyboardFoci.
!

