'From Squeak3.2alpha of 17 December 2001 [latest update: #4642] on 1 January 2002 at 8:05:28 pm'!
"Change Set:		DebugLayouts-ar
Date:			1 January 2002
Author:			Andreas Raab

The CS makes it simpler to debug layout problems. If an error is encountered during layout computation the fullBounds will be stored with the receiver's bounds before the error is passed on. 

The scheme will work unless the bounds of the morph in question are screwed up (but then you're in deep trouble anyways).

Note that the new scheme will compute the fullBounds correctly even if the exception is handled outside the exception handler established in #fullBounds."
!


!Morph methodsFor: 'layout' stamp: 'ar 1/1/2002 20:00'!
fullBounds
	"Return the bounding box of the receiver and all its children. Recompute the layout if necessary."
	fullBounds ifNotNil:[^fullBounds].
	"Errors at this point can be critical so make sure we catch 'em all right"
	[self doLayoutIn: self layoutBounds] on: Error do:[:ex|
		"This should do it unless you don't screw up the bounds"
		fullBounds _ bounds.
		ex pass].
	^fullBounds! !

