'From Squeak 2.3 beta of Nov 25, 1998 on 9 January 1999 at 10:54:57 pm'!
"Change Set:		FindChangeSet
Date:			9 January 1999
Author:			Dan Ingalls

Adds a feature similar to 'find class...' for changeSets.  Also defeats the exact match in find class, because it masked other useful matches.
"!


!Browser methodsFor: 'system category functions' stamp: 'di 1/9/1999 22:53'!
findClass
	"Search for a class by name.  Modified so that if only 1 class matches the user-supplied string then the pop-up menu is bypassed"
	| pattern foundClass classNames index |

	self okToChange ifFalse: [^ self classNotFound].
	pattern _ FillInTheBlank request: 'Class name or fragment?'.
	pattern isEmpty ifTrue: [^ self classNotFound].
	classNames _ Smalltalk classNames asArray select: 
				[:n | n includesSubstring: pattern caseSensitive: false].
	classNames isEmpty ifTrue: [^ self classNotFound].
	index _ classNames size = 1
		ifTrue:	[1]
		ifFalse:	[(PopUpMenu labelArray: classNames lines: #()) startUp].
	index = 0 ifTrue: [^ self classNotFound].
	foundClass _ Smalltalk at: (classNames at: index).
 	self systemCategoryListIndex: (self systemCategoryList indexOf: foundClass category).
	self classListIndex: (self classList indexOf: foundClass name). 
! !


!ChangeSorter methodsFor: 'changeSet menu' stamp: 'di 1/9/1999 22:53'!
changeSetMenu: aMenu 
	"Could be for a single or double changeSorter"
	parent ifNotNil: [
	^ aMenu labels: 
'make changes go to me
new...
file into new...
find...
show...
update
fileOut
browse
rename
copy all to other side
submerge into other side
subtract other side
edit preamble...
edit postscript...
clear
remove'
		lines: #(1 3 9 12 14 )
		selections: #(newCurrent newSet fileIntoNewChangeSet findCngSet chooseCngSet update fileOut browseChangeSet rename copyAllToOther submergeIntoOtherSide subtractOtherSide editPreamble editPostscript clearChangeSet remove )]

	ifNil: ["Single ChangeSorter"
	^ aMenu labels: 
'make changes go to me
new...
file into new...
find...
show...
update
fileOut
browse
rename
edit preamble...
edit postscript...
clear
remove'
		lines: #(1 3 9 11)
		selections: #(newCurrent newSet fileIntoNewChangeSet findCngSet chooseCngSet update fileOut browseChangeSet rename editPreamble editPostscript clearChangeSet remove )]! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'di 1/9/1999 22:53'!
findCngSet 
	"Search for a changeSet by name.  Pop up a menu of all changeSets whose name contains the string entered by the user.  If only one matches, then the pop-up menu is bypassed"
	| index pattern candidates |
	self okToChange ifFalse: [^ self].
	ChangeSet instanceCount > AllChangeSets size ifTrue: [self class gatherChangeSets].
	pattern _ FillInTheBlank request: 'ChangeSet name or fragment?'.
	pattern isEmpty ifTrue: [^ self classNotFound].
	candidates _ AllChangeSets select:
			[:c | c name includesSubstring: pattern caseSensitive: false].
	candidates size = 1 ifTrue:
		[^ self showChangeSet: candidates first].
	index _ (PopUpMenu labels: 
		(candidates collect: [:each | each name]) asStringWithCr) startUp.
	index = 0 ifFalse: [self showChangeSet: (candidates at: index)].
! !


