'From Squeak 2.3 of January 14, 1999 on 15 January 1999 at 5:53:18 pm'!
"Change Set:		ShortArrayFixes
Date:			15 January 1999
Author:			Andreas Raab

Fixes byte order problems with the short integer classes in Balloon"!

ArrayedCollection variableWordSubclass: #ShortIntegerArray
	instanceVariableNames: ''
	classVariableNames: 'LastSaveOrder '
	poolDictionaries: ''
	category: 'Balloon-Collections'!
ArrayedCollection variableWordSubclass: #ShortRunArray
	instanceVariableNames: ''
	classVariableNames: 'LastSaveOrder '
	poolDictionaries: ''
	category: 'Balloon-Collections'!

!ShortIntegerArray methodsFor: 'private' stamp: 'ar 1/15/1999 17:35'!
pvtAt: index
	"Private -- for swapping only"
	<primitive: 143>
	index isInteger ifTrue: [self errorSubscriptBounds: index].
	index isNumber ifTrue: [^ self at: index truncated].
	self errorNonIntegerIndex.
! !

!ShortIntegerArray methodsFor: 'private' stamp: 'ar 1/15/1999 17:35'!
pvtAt: index put: value
	"Private -- for swapping only"
	<primitive: 144>
	index isInteger
		ifTrue: [
			(index >= 1 and: [index <= self size])
				ifTrue: [self errorImproperStore]
				ifFalse: [self errorSubscriptBounds: index]].
	index isNumber ifTrue: [^ self at: index truncated put: value].
	self errorNonIntegerIndex.
! !

!ShortIntegerArray methodsFor: 'private' stamp: 'ar 1/15/1999 17:37'!
swapShortObjects
	"Private -- swap all the short quantities in the receiver"
	| tmp |
	1 to: self basicSize do:[:i|
		tmp _ (self pvtAt: i * 2).
		self pvtAt: i * 2 put: (self pvtAt: i * 2 - 1).
		self pvtAt: i * 2 - 1 put: tmp.
	]! !


!ShortIntegerArray class methodsFor: 'class initialization' stamp: 'ar 1/15/1999 17:31'!
initialize
	"ShortIntegerArray initialize"
	(SystemStartupList includes: self) ifFalse:[
		SystemStartupList add: self.
	].
	LastSaveOrder _ self new: 2.
	LastSaveOrder at: 1 put: 42.
	LastSaveOrder at: 2 put: 13.! !

!ShortIntegerArray class methodsFor: 'class initialization' stamp: 'ar 1/15/1999 17:51'!
obsolete
	"I am obsolete  - remove me from the startup list"
	SystemStartupList remove: self ifAbsent:[].
	^super obsolete! !

!ShortIntegerArray class methodsFor: 'class initialization' stamp: 'ar 1/15/1999 17:33'!
startUp
	"Check if the word order has changed from the last save"
	((LastSaveOrder at: 1) = 42 and:[(LastSaveOrder at: 2) = 13]) 
		ifTrue:[^self]. "Okay"
	((LastSaveOrder at: 2) = 42 and:[(LastSaveOrder at: 1) = 13]) 
		ifTrue:[^self swapShortObjects]. "Reverse guys"
	^self error:'This must never happen'! !

!ShortIntegerArray class methodsFor: 'class initialization' stamp: 'ar 1/15/1999 17:40'!
swapShortObjects
	self allSubInstancesDo:[:inst| inst swapShortObjects]! !

!ShortIntegerArray class methodsFor: 'instance creation' stamp: 'ar 1/15/1999 17:28'!
new: n
	^super new: n + 1 // 2! !


!ShortPointArray class methodsFor: 'instance creation' stamp: 'ar 1/15/1999 17:40'!
new: n
	^super new: n * 2! !


!ShortRunArray methodsFor: 'private' stamp: 'ar 1/15/1999 17:47'!
pvtAt: index
	"Private -- for swapping only"
	<primitive: 143>
	index isInteger ifTrue: [self errorSubscriptBounds: index].
	index isNumber ifTrue: [^ self at: index truncated].
	self errorNonIntegerIndex.
! !

!ShortRunArray methodsFor: 'private' stamp: 'ar 1/15/1999 17:47'!
pvtAt: index put: value
	"Private -- for swapping only"
	<primitive: 144>
	index isInteger
		ifTrue: [
			(index >= 1 and: [index <= self size])
				ifTrue: [self errorImproperStore]
				ifFalse: [self errorSubscriptBounds: index]].
	index isNumber ifTrue: [^ self at: index truncated put: value].
	self errorNonIntegerIndex.
! !

!ShortRunArray methodsFor: 'private' stamp: 'ar 1/15/1999 17:48'!
swapRuns
	"Private -- swap length/value pairs in the receiver"
	| tmp |
	1 to: self basicSize do:[:i|
		tmp _ (self pvtAt: i * 2).
		self pvtAt: i * 2 put: (self pvtAt: i * 2 - 1).
		self pvtAt: i * 2 - 1 put: tmp.
	]! !


!ShortRunArray class methodsFor: 'class initialization' stamp: 'ar 1/15/1999 17:45'!
initialize
	"ShortRunArray initialize"
	(SystemStartupList includes: self) ifFalse:[
		SystemStartupList add: self.
	].
	LastSaveOrder _ #(42 42 42) as: self.! !

!ShortRunArray class methodsFor: 'class initialization' stamp: 'ar 1/15/1999 17:51'!
obsolete
	"I am obsolete  - remove me from the startup list"
	SystemStartupList remove: self ifAbsent:[].
	^super obsolete! !

!ShortRunArray class methodsFor: 'class initialization' stamp: 'ar 1/15/1999 17:46'!
startUp
	"Check if the word order has changed from the last save"
	((LastSaveOrder valueAtRun: 1) = 42 and:[(LastSaveOrder lengthAtRun: 1) = 3]) 
		ifTrue:[^self]. "Okay"
	((LastSaveOrder lengthAtRun: 1) = 42 and:[(LastSaveOrder valueAtRun: 1) = 3]) 
		ifTrue:[^self swapRuns]. "Reverse guys"
	^self error:'This must never happen'! !

!ShortRunArray class methodsFor: 'class initialization' stamp: 'ar 1/15/1999 17:47'!
swapRuns
	self allSubInstancesDo:[:inst| inst swapRuns]! !


ShortIntegerArray initialize!
ShortRunArray initialize!
