'From Squeak 2.3 of January 14, 1999 on 23 February 1999 at 12:45:24 am'!
"Change Set:		FlashTweaksForAlan
Date:			23 February 1999
Author:			Andreas Raab

Two simple tweaks for the Flash stuff:
1) Compress flash bitmaps to 8bit depth if Preferences>>#compressFlashImages is set
   (EXTREMELY handy for the Studio A)
2) Allow custom Smalltalk code to be executed from any Flash button
  (Choose 'set custom action' from the halo)
"
Preferences setPreference: #compressFlashImages toValue: false.
!


!FlashButtonMorph methodsFor: 'menu' stamp: 'ar 2/23/1999 00:37'!
addCustomAction
	| string code |
	string _ FillInTheBlank request:'Enter the Smalltalk code to execute:' initialAnswer:'Smalltalk beep.'.
	string isEmpty ifTrue:[^self].
	string _ '[', string,']'.
	code _ Compiler evaluate: string for: self notifying: nil logged: false.
	self removeActions.
	target _ code.
	self on: #mouseDown send:(Message selector: #value).! !

!FlashButtonMorph methodsFor: 'menu' stamp: 'ar 2/23/1999 00:27'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	aCustomMenu add: 'set custom action' action: #addCustomAction.
	aCustomMenu add: 'remove all actions' action: #removeActions.
! !

!FlashButtonMorph methodsFor: 'menu' stamp: 'ar 2/23/1999 00:37'!
removeActions
	events _ nil.
	target _ nil.! !


!FlashFileReader methodsFor: 'processing tags' stamp: 'ar 2/23/1999 00:10'!
processDefineBits: data
	| id image |
	id _ data nextWord.
	image _ jpegDecoder decodeNextImageFrom: data.
	Preferences compressFlashImages ifTrue:[image _ image asFormOfDepth: 8].
	"image display."
	self recordBitmap: id data: image.
	^true! !

!FlashFileReader methodsFor: 'processing tags' stamp: 'ar 2/23/1999 00:10'!
processDefineBitsJPEG2: data
	| id image decoder |
	id _ data nextWord.
	decoder _ FlashJPEGDecoder new.
	decoder isStreaming: self isStreaming.
	decoder decodeJPEGTables: data.
	image _ decoder decodeNextImageFrom: data.
	Preferences compressFlashImages ifTrue:[image _ image asFormOfDepth: 8].
	self recordBitmap: id data: image.
	^true! !

!FlashFileReader methodsFor: 'processing tags' stamp: 'ar 2/23/1999 00:10'!
processDefineBitsJPEG3: data
	"TODO: Read zlib compressed alpha."
	| id image decoder alphaOffset dataOffset |
	id _ data nextWord.
	self flag: #wrongSpec.
	alphaOffset _ data nextWord.
	dataOffset _ data nextWord.
	decoder _ FlashJPEGDecoder new.
	decoder isStreaming: self isStreaming.
	decoder decodeJPEGTables: data.
	image _ decoder decodeNextImageFrom: data.
	Preferences compressFlashImages ifTrue:[image _ image asFormOfDepth: 8].
	"Note: We must read the zlib compressed alpha values here."
	self recordBitmap: id data: image.
	^true! !


