'From Squeak 2.3 of January 14, 1999 on 25 February 1999 at 4:44:44 pm'!
"Change Set:		sysInfo-sw
Date:			25 February 1999
Author:			Scott Wallace

Cleans up the about-this-system mechanism and also factors it such that the various pieces of information it offers can be separately obtained for other purposes."!


!HandMorph methodsFor: 'world menu' stamp: 'sw 2/15/1999 16:17'!
helpMenu
	"Build the help menu for the world."
	| menu screenCtrl |
	screenCtrl _ ScreenController new.
	menu _ (MenuMorph entitled: 'General help') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'edit preferences...' target: Preferences action: #openPreferencesInspector.
	menu add: 'command-key help' target: Utilities action: #openCommandKeyHelp.
	menu add: 'world menu help' target: self action: #worldMenuHelp.
	menu add: 'font size summary' target: Utilities action: #fontSizeSummary.
	menu add: 'useful expressions' target: Utilities action: #openStandardWorkspace.
	menu add: 'view image imports' target: Smalltalk action: #viewImageImports.

	menu addLine.
	menu add: 'full screen on' target: screenCtrl action: #fullScreenOn.
	menu add: 'full screen off' target: screenCtrl action: #fullScreenOff.
	menu add: 'set display depth...' action: #setDisplayDepth.
	menu add: 'set desktop color...' action: #changeBackgroundColor.
	menu add: 'use texture background' target: self world action: #setStandardTexture.
	gridOn
		ifTrue: [menu add: 'turn gridding off' action: #setGridding]
		ifFalse: [menu add: 'turn gridding on' action: #setGridding].
	menu add: ((Preferences valueOfFlag: #disableSounds)
							ifTrue: ['turn sound on']
							ifFalse: ['turn sound off'])
		target: screenCtrl action: #soundOnOrOff.

	menu addLine.
	menu add: 'update code from server' action: #absorbUpdatesFromServer.
	menu add: 'about this system' target: Smalltalk action: #aboutThisSystem.
	menu add: 'set author initials...' target: screenCtrl action: #setAuthorInitials.
	menu add: 'vm statistics' target: screenCtrl action: #vmStatistics.
	menu add: 'space left' target: screenCtrl action: #garbageCollect.
	^ menu
! !


!ScreenController methodsFor: 'menu messages' stamp: 'sw 2/15/1999 16:18'!
aboutThisSystem 
	Smalltalk aboutThisSystem! !


!SystemDictionary methodsFor: 'sources, change log' stamp: 'sw 2/15/1999 16:18'!
aboutThisSystem 
	"Identify software version"

	^ self inform: self systemInformationString! !

!SystemDictionary methodsFor: 'sources, change log' stamp: 'sw 2/15/1999 16:32'!
currentChangeSetString
	"Smalltalk currentChangeSetString"
	^ 'Current Change Set: ', self changes name! !

!SystemDictionary methodsFor: 'sources, change log' stamp: 'sw 2/15/1999 16:30'!
lastUpdateString
	"Smalltalk lastUpdateString"
	| aNumber |
	aNumber _ ChangeSorter highestNumberedChangeSet.
	^ (aNumber notNil and: [aNumber > 0])
		ifTrue:
			['Last update: ', aNumber printString]
		ifFalse:
			['No updates present.']! !

!SystemDictionary methodsFor: 'sources, change log' stamp: 'sw 2/15/1999 16:34'!
systemInformationString
	"Identify software version"
	^ self version, String cr, self lastUpdateString, String cr, self currentChangeSetString

"
	(eToySystem _ self at: #EToySystem ifAbsent: [nil]) ifNotNil:
		[aString _ aString, '
Squeak-Central version: ', eToySystem version, ' of ', eToySystem versionDate]."! !


