'From Squeak 2.3 of January 14, 1999 on 2 April 1999 at 11:46:13 pm'!
"Change Set:		ProtocolBrowserFixes
Date:			2 April 1999
Author:			Dan Ingalls

Enables emphasized items in morphic list panes, in particular for the protocol browser."!


!PluggableListMorph methodsFor: 'initialization' stamp: 'di 4/2/1999 16:07'!
list: listOfStrings
	| morphList handler h loc index |
	scroller removeAllMorphs.
	list _ listOfStrings ifNil: [Array new].
	list isEmpty ifTrue: [self setScrollDeltas.  ^ self selectedMorph: nil].
	"NOTE: we will want a quick StringMorph init message, possibly even
		combined with event install and positioning"
	font ifNil: [font _ TextStyle default fontAt: 1].
	morphList _ list collect:
		[:item | item isText
			ifTrue: [StringMorph contents: item font: (font emphasized: (item emphasisAt: 1))]
			ifFalse: [StringMorph contents: item font: font]].

	"Sensitize first morph and copy handler to all the rest"
	morphList first on: #mouseDown send: #mouseDown:onItem: to: self.
	handler _ morphList first eventHandler.
	morphList do: [:m | m eventHandler: handler].

	"Lay items out vertically and install them in the scroller"
	h _ morphList first height "self listItemHeight".
	loc _ 0@0.
	morphList do: [:m | m bounds: (loc extent: 9999@h).  loc _ loc + (0@h)].
	scroller addAllMorphs: morphList.
	index _ self getCurrentSelectionIndex.
	self selectedMorph: ((index = 0 or: [index > morphList size]) ifTrue: [nil] ifFalse: [morphList at: index]).
	self setScrollDeltas.
	scrollBar setValue: 0.0.! !


!ProtocolBrowser methodsFor: 'private' stamp: 'di 3/31/1999 14:33'!
setClassAndSelectorIn: csBlock
	"Decode strings of the form    <selectorName> (<className> [class])  "

	| i classAndSelString sel |
	sel _ self selection asString.
	i _ sel indexOf: $(.
	"Rearrange to  <className> [class] <selectorName> , and use MessageSet"
	classAndSelString _ (sel copyFrom: i + 1 to: sel size - 1) , ' ' ,
					(sel copyFrom: 1 to: i - 1) withoutTrailingBlanks.
	MessageSet parse: classAndSelString toClassAndSelector: csBlock! !


!Text methodsFor: 'emphasis' stamp: 'di 4/1/1999 15:17'!
emphasisAt: characterIndex
	"Answer the fontfor characters in the run beginning at characterIndex."
	| attributes emph |
	self size = 0 ifTrue: [^ 0].	"null text tolerates access"
	emph _ 0.
	attributes _ runs at: characterIndex.
	attributes do: 
		[:att | emph _ emph bitOr: att emphasisCode].
	^ emph
	! !


!TextAttribute methodsFor: 'as yet unclassified' stamp: 'di 4/1/1999 15:16'!
emphasisCode
	"Subclasses may override to add bold, italic, etc"
	^ 0! !


ProtocolBrowser removeSelector: #parse:toClassAndSelector:!
