'From Squeak 2.3 of January 14, 1999 on 5 April 1999 at 3:34:06 am'!
"Change Set:		morphic-tkJX
Date:			5 April 1999
Author:			Ted Kaehler

Fixes a few interface bugs in Morphic.

Finished Dan's 'nil fix' for annotation.
Fixes annoying bug: when you leave a window, then reenter and type without reselecting, it put the new text in bold!!  Now takes emphasis from place where you type.
Conversion method for StringMorph (added variable 'emphasis').
"!


!PluggableTextMorph methodsFor: 'pane events' stamp: 'tk 4/5/1999 03:12'!
mouseEnter: event
	super mouseEnter: event.
	selectionInterval ifNotNil:
		[textMorph handleEdit: [textMorph editor selectInterval: selectionInterval.
			textMorph editor setEmphasisHere]].
	event hand newKeyboardFocus: textMorph! !


!StringMorph methodsFor: 'object fileIn' stamp: 'tk 4/4/1999 17:42'!
convertbosfcefch0: varDict bosfcefech0: smartRefStrm
	"These variables are automatically stored into the new instance ('font' 'contents' 'hasFocus' ).
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"Be sure to to fill in ('emphasis' ) and deal with the information in ()"! !


!Utilities class methodsFor: 'miscellaneous' stamp: 'tk 4/5/1999 02:35'!
timeStampForMethod: method
	"Answer the authoring time-stamp for the given method, retrieved from the sources or changes file, or nil if none is found"
	| position preamble tokens stamp file tokenCount |
	method fileIndex == 0 ifTrue: [^ String new].
	position _ method filePosition.
	file _ (SourceFiles at: method fileIndex) readOnlyCopy.
	file position: (0 max: position - 150).  "Skip back to before the preamble"
		[file position < (position - 1)]  "then pick it up from the front"
			whileTrue: [preamble _ file nextChunk].
		stamp _ String new.
		tokens _ (preamble findString: 'methodsFor:' startingAt: 1) > 0
			ifTrue: [Scanner new scanTokens: preamble]
			ifFalse: [Array new  "ie cant be back ref"].
		(((tokenCount _ tokens size) between: 7 and: 8) and: [(tokens at: tokenCount - 5) = #methodsFor:])
			ifTrue:
				[(tokens at: tokenCount - 3) = #stamp:
					ifTrue: ["New format gives change stamp and unified prior pointer"
							stamp _ tokens at: tokenCount - 2]].
		((tokenCount between: 5 and: 6) and: [(tokens at: tokenCount - 3) = #methodsFor:])
			ifTrue:
				[(tokens at: tokenCount  - 1) = #stamp:
					ifTrue: ["New format gives change stamp and unified prior pointer"
						stamp _ tokens at: tokenCount]].
	file close.
	^ stamp! !


