'From Squeak 2.3 of January 14, 1999 on 31 March 1999 at 12:47:04 pm'!
"Change Set:		twoThumbnailFixes-bf
Date:			31 March 1999
Author:			Bert Freudenberg

Fixes two bugs: Firstly, there were recursive thumbnails (that is, thumbnails inside of thumbnails) when dropping a thumbnail into a flap smaller than the thumbnail. Secondly, with flaps open, Morphs showed 'innocuous' names ending in digits because thumbnails had 'known' names from their representees. The postscriptum nils all names in existing thumbnails (new thumbnails shouldn't get one)."!


!MorphThumbnail methodsFor: 'all' stamp: 'bf 3/31/1999 12:24'!
innocuousName
	^ morphRepresented isNil
		ifTrue: [super innocuousName]
		ifFalse: [morphRepresented innocuousName]! !

!MorphThumbnail methodsFor: 'all' stamp: 'bf 3/31/1999 12:38'!
morphRepresented: aMorph

	morphRepresented _ aMorph.
	self computeThumbnail.
! !

!MorphThumbnail methodsFor: 'all' stamp: 'bf 3/31/1999 07:54'!
representativeNoTallerThan: maxHeight norWiderThan: maxWidth thumbnailHeight: thumbnailHeight

	"Return a morph representing the receiver but which is no taller than aHeight.  If the receiver is already small enough, just return it, else return a MorphThumbnail companioned to the receiver, enforcing the maxWidth"

	(self height <= maxHeight and: [self width <= maxWidth]) ifTrue: [^ self].

	^ MorphThumbnail new
		extent: maxWidth @ (thumbnailHeight min: self height);
		morphRepresented: morphRepresented! !


"Postscript:
Nil out all existing external names in MorphThumbnails."
MorphThumbnail allInstances do:
	[:m | m extension ifNotNil: [m extension externalName: nil]] 
!