'From Squeak2.9alpha of 13 June 2000 [latest update: #3299] on 2 February 2001 at 1:29:25 pm'!
"Change Set:		MacintoshPowerMgrPrefs
Date:			2 February 2001
Author:			John M McIntosh johnmci@smalltalkconsulting.com

Add a preference to get at the power manager option. The macintosh 3.x VM supports this feature, support is platform specific"!

Object subclass: #PowerManagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Support'!

!PowerManagement commentStamp: 'JMM 2/2/2001 13:08' prior: 0!
This class is used to restore the VM's view of the power manage option. On the macintosh in a 3.x VM  you can  turn the power manager on or off. This may make your iBook run faster, and will prevents your macintosh from sleeping. This does consume more power so your battery life will be degraded. 

Usually you can turn processor cycling off in the control panel, but this class ensures it's off if you set the preference to turn power management off!


!PowerManagement class methodsFor: 'startup logic' stamp: 'JMM 2/2/2001 13:10'!
deinstall
	"PowerManagement deinstall"

	Smalltalk removeFromStartUpList: self.
! !

!PowerManagement class methodsFor: 'startup logic' stamp: 'JMM 2/2/2001 13:26'!
startUp
	[Preferences turnOffPowerManager
		ifTrue: [Smalltalk disablePowerManager]] ifError: []! !

!PowerManagement class methodsFor: 'class initialization' stamp: 'JMM 2/2/2001 13:09'!
initialize
	"PowerManagement initialize"

	Smalltalk addToStartUpList: self! !

PowerManagement initialize!
"Postscript:
Add Preference for Power Manager."
Preferences
	addPreference: #turnOffPowerManager
	category: #performance
	default:  false
	balloonHelp: 'May offer higer performance at the expense of the life of your Battery (macintosh only in 3.VM)'. 
PowerManagement initialize.
!

