'From Squeak3.1alpha of 28 February 2001 [latest update: #3814] on 8 March 2001 at 5:59:03 pm'!
"Change Set:		pluginFixes
Date:			15 March 2001
Author:			Michael Rueger, Chris Norton

Misc fixes for URL handling and plugin detection.
Includes the fix by Chris Norton."!


!HTTPLoader class methodsFor: 'class initialization' stamp: 'mir 3/8/2001 16:31'!
initialize
	"HTTPLoader initialize"

	MaxNrOfConnections _ 4.
	DefaultLoader ifNotNil: [
		DefaultLoader release.
		DefaultLoader _ nil]! !


!HTTPRequest methodsFor: 'initialize'!
for: aUrl in: aLoader
	url _ self httpEncodeSafely: aUrl.
	loader _ aLoader.
	semaphore _ Semaphore new.! !

!HTTPRequest methodsFor: 'private' stamp: 'mir 3/8/2001 17:57'!
httpEncodeSafely: aUrl
	"Encode the url but skip $/ and $:."

	| encodedStream |
	encodedStream _ WriteStream on: (String new).
	
	aUrl do: [ :c |
		(c isSafeForHTTP or: [c == $/ or: [c == $:]]) ifTrue: [ encodedStream nextPut: c ] ifFalse: [
			encodedStream nextPut: $%.
			encodedStream nextPut: (c asciiValue // 16) asHexDigit.
			encodedStream nextPut: (c asciiValue \\ 16) asHexDigit.
		]
	].
	^encodedStream contents. ! !


!StandardFileStream class methodsFor: 'browser requests' stamp: 'mir 3/8/2001 16:28'!
isRunningAsBrowserPlugin
	self new waitBrowserReadyFor: 1000 ifFail: [^false].
	^true! !


!HTTPClient class methodsFor: 'testing' stamp: 'ccn 3/14/2001 19:56'!
isRunningInBrowser

	RunningInBrowser isNil
		ifTrue: [self determineIfRunningInBrowser].
	^RunningInBrowser! !



"Postscript: "
HTTPLoader initialize.
!

