'From Squeak3.1alpha of 28 February 2001 [latest update: #4089] on 28 May 2001 at 1:18:42 pm'!
"Change Set:		TexPaintTweaks-ar
Date:			28 May 2001
Author:			Andreas Raab

Fix up the obsolete #view mode and make filling faster."!


!WonderlandCameraMorph methodsFor: 'event handling' stamp: 'ar 5/28/2001 13:04'!
mouseDown: evt 
	"When the user clicks in a camera window, determine which actor the    
	         user clicked on and have that actor respond to the event"
	| newEvent reactions |
	mode == #view ifTrue:[mode _ nil].
	"ar 5/28/2001 - remove the above at some point; it's compensating for old wonderlands"

	self on: #mouseMove send: #mouseMoveDefault: to: self.
	self on: #mouseUp send: #mouseUpDefault: to: self.
	(evt redButtonPressed and:[evt anyModifierKeyPressed not]) ifTrue:[
		(mode == nil and:[firstPersonControls == true]) ifTrue:[
			myControls setCenter: evt position.
			myControls mouseDown: evt.
			evt hand needsToBeDrawn ifFalse:[Cursor crossHair show].
			self on: #mouseMove send: #mouseMoveFirstPersonControl: to: self.
			self on: #mouseUp send: #mouseUpFirstPersonControl: to: self.
			^self
		].

		mode == #stroke ifTrue:[
			self on: #mouseMove send: #mouseMoveStroke: to: self.
			self on: #mouseUp send: #mouseUpStroke: to: self.
			^self recordStroke: evt cursorPoint].

		newEvent _ self convertEvent: evt.
		newEvent ifNil:[^self].

		mode == #paint ifTrue:[
			newEvent getVertex ifNil:[^self].
			self prepareAction: newEvent.
			self on: #mouseMove send: #mouseMovePaint: to: self.
			self on: #mouseUp send: #mouseUpPaint: to: self.
			^self perform: palette action with: newEvent].
	] ifFalse:[
		newEvent _ self convertEvent: evt.
		newEvent ifNil:[^self].
	].
	newEvent getActor hasActiveTexture
		ifTrue: [^ newEvent getActor morphicMouseDown: newEvent].

	(evt redButtonPressed or:[evt controlKeyPressed]) ifTrue:[
		reactions _ newEvent getActor getReactionsTo: leftMouseDown.
		mouseUpButton _ leftMouseUp.
	] ifFalse: [evt yellowButtonPressed ifTrue:[ 
		reactions _ newEvent getActor getReactionsTo: rightMouseDown.
		mouseUpButton _ rightMouseUp.
	] ifFalse: [reactions _ nil]].
	reactions ifNotNil: [reactions do: [:aReaction | aReaction reactTo: newEvent]].
! !

!WonderlandCameraMorph methodsFor: 'pooh-actions' stamp: 'ar 5/28/2001 13:10'!
fill: newEvent
	currentCanvas form floodFill: currentColor at: currentPosition asIntegerPoint! !

