'From Squeak3.1alpha of 6 February 2001 [latest update: #4347] on 28 September 2001 at 1:33:20 pm'!
"Change Set:		removeAllSpeedup
Date:			27 April 2001
Author:			Richard A. O'Keefe

Improves the performance of OrderedCollection>>removeAllSuchThat: from O(n**2) to O(n)."!


!OrderedCollection methodsFor: 'removing' stamp: 'raok 4/27/2001 15:35'!
removeAllSuchThat: aBlock 
	"Remove each element of the receiver for which aBlock evaluates to true.
	The method in Collection is O(N^2), this is O(N)."

	| n |
	n _ firstIndex.
	firstIndex to: lastIndex do: [:index |
	    (aBlock value: (array at: index)) ifFalse: [
			array at: n put: (array at: index).
			n _ n + 1]].
	n to: lastIndex do: [:index | array at: index put: nil].
	lastIndex _ n - 1! !

