'From Squeak3.2alpha of 3 October 2001 [latest update: #4472] on 5 November 2001 at 4:09:54 pm'!
"Change Set:		moreCleanups-sw
Date:			5 November 2001
Author:			Scott Wallace

 Adds a command in the ObjectsTool to reset thumbnails.
 Restores the class-var-refs button to the optional button pane -- I really could not live without it.
 Fixes a long-standing bug in ObjectWithDocumentation.documentation:
 Adds stay-up item to class-list menu in change-sorter.
 A few other miscellaneous cleanups, including some method removals"!


!DescriptionForPartsBin commentStamp: 'sw 10/30/2001 05:09' prior: 0!
An object description, for use with the ObjectsTool and other parts-bin-like repositories.

formalName				The formal name by which the object is to be known 
categoryList				A list of category symbols, by way of attribute tags
documentation			For use in balloon help, etc.
globalReceiverSymbol	A symbol representing the global to whom to send nativitySelector 
nativitySelector 		The selector to send to the global receiver to obtain a new instance!


!CodeHolder methodsFor: 'controls' stamp: 'sw 10/2/2001 00:22'!
optionalButtonPairs
	"Answer a tuple (formerly pairs) defining buttons, in the format:
			button label
			selector to send
			help message"

	| aList |

	aList _ #(
	('browse'			browseMethodFull			'view this method in a browser')
	('senders' 			browseSendersOfMessages	'browse senders of...')
	('implementors'		browseMessages				'browse implementors of...')
	('versions'			browseVersions				'browse versions')), 

	(Preferences decorateBrowserButtons
		ifTrue:
			[{#('inheritance'		methodHierarchy 'browse method inheritance
green: sends to super
tan: has override(s)
mauve: both of the above' )}]
		ifFalse:
			[{#('inheritance'		methodHierarchy			'browse method inheritance')}]),

	#(
	('hierarchy'		classHierarchy				'browse class hierarchy')
	('inst vars'			browseInstVarRefs			'inst var refs...')
	('class vars'			browseClassVarRefs			'class var refs...')).

	^ aList! !


!ChangeSorter methodsFor: 'class list' stamp: 'sw 11/3/2001 09:34'!
classListMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	aMenu title: 'class list'.
	Smalltalk isMorphic ifTrue: [aMenu addStayUpItemSpecial].
	(parent notNil and: [shifted not])
		ifTrue: [aMenu addList: #( "These two only apply to dual change sorters"
			('copy class chgs to other side'			copyClassToOther)	
			('move class chgs to other side'			moveClassToOther))].

	aMenu addList: (shifted
		ifFalse: [#(
			-
			('delete class from change set (d)'		forgetClass)
			('remove class from system (x)'			removeClass)
			-
			('browse full (b)'						browseMethodFull)
			('browse hierarchy (h)'					spawnHierarchy)
			('browse protocol (p)'					browseFullProtocol)
			-
			('printOut'								printOutClass)
			('fileOut'								fileOutClass)
			-
			('inst var refs...'						browseInstVarRefs)
			('inst var defs...'						browseInstVarDefs)
			('class var refs...'						browseClassVarRefs)
			('class vars'								browseClassVariables)
			('class refs (N)'							browseClassRefs)
			-
			('more...'								offerShiftedClassListMenu))]

		ifTrue: [#(
			-
			('unsent methods'						browseUnusedMethods)
			('unreferenced inst vars'				showUnreferencedInstVars)
			('unreferenced class vars'				showUnreferencedClassVars)
			-
			('sample instance'						makeSampleInstance)
			('inspect instances'						inspectInstances)
			('inspect subinstances'					inspectSubInstances)
			-
			('more...'								offerUnshiftedClassListMenu ))]).
	^ aMenu! !


!ObjectWithDocumentation methodsFor: 'documentation' stamp: 'sw 11/5/2001 15:36'!
documentation: maneno
	"Set the receiver's documentation, in the current langauge"

	| wording |
	wording _ self wording.
	self absorbTranslation: (ElementTranslation new wording: wording  helpMessage: maneno language: #English) ! !


!ObjectsTool methodsFor: 'menu' stamp: 'sw 11/1/2001 00:07'!
addAddHandMenuItemsForHalo: aMenu hand: aHand
	"Add items to the given halo-menu, given a hand"

	super addAddHandMenuItemsForHalo: aMenu hand: aHand.
	aMenu addLine.
	aMenu add: 'alphabetic' target: self selector: #showAlphabeticTabs.
	aMenu add: 'find' target: self selector: #showSearchPane.
	aMenu add: 'categories' target: self selector: #showCategories.
	aMenu addLine.
	aMenu add: 'reset thumbnails' target: self selector: #resetThumbnails.
	aMenu addLine
! !

!ObjectsTool methodsFor: 'menu' stamp: 'sw 11/5/2001 15:36'!
resetThumbnails
	"Reset the thumbnail cache"

	PartsBin clearThumbnailCache.
	"should do more -- refresh this pane, at a minimum"! !

EToyVocabulary removeSelector: #addGetterAndSetterInterfacesFromOldSlotSpec:!
CategoryViewer removeSelector: #listPane!
AlignmentMorph removeSelector: #demandsBoolean!
