'From Squeak3.2alpha of 4 October 2001 [latest update: #4521] on 17 November 2001 at 9:36:28 pm'!
"Change Set:		Stack-OM3-tk
Date:			13 November 2001
Author:			Ted Kaehler

Objects to go in categories Basic 1 and Basic 2 in the Master Parts Bin.  A new look for some objects that initializeToStandAlone.

Adds a menu item to a DictionaryInspector to refresh the list of keys.  When keys are added to a Dictionary, an old inspector can be brought up to date."!


!DictionaryInspector methodsFor: 'menu' stamp: 'tk 11/13/2001 16:07'!
dictionaryMenu: aMenu

	^ aMenu labels:
'inspect
copy name
references
objects pointing to this value
refresh view
add key
remove
basic inspect'
	lines: #( 5 7)
	selections: #(inspectSelection copyName selectionReferences objectReferencesToSelection calculateKeyArray addEntry removeSelection inspectBasic)
! !


!EllipseMorph class methodsFor: 'parts bin' stamp: 'tk 11/13/2001 02:23'!
descriptionForPartsBin
	^ self partName:	'Ellipse'
		categories:		#('Graphics' ' Basic 1 ')
		documentation:	'An elliptical or circular shape'! !


!ImageMorph class methodsFor: 'parts bin' stamp: 'tk 11/16/2001 12:12'!
descriptionForPartsBin
	^ self partName:	'Image'
		categories:		#('Graphics' ' Basic 2 ')
		documentation:	'A non-editable picture.  If you use the Paint palette to make a picture, you can edit it afterwards.'! !


!PolygonMorph methodsFor: 'initialization' stamp: 'tk 11/14/2001 20:12'!
initialize
	super initialize.
	vertices _ Array with: 5@0 with: 20@10 with: 0@20.
	borderWidth _ 2.
	borderColor _ Color r: 0.0 g: 0.419 b: 0.935.
	closed _ true.
	smoothCurve _ false.
	arrows _ #none.
	self computeBounds.
! !

!PolygonMorph methodsFor: 'initialization' stamp: 'tk 11/14/2001 20:12'!
initializeToStandAlone

	super initializeToStandAlone.
! !


!PolygonMorph class methodsFor: 'instance creation' stamp: 'tk 11/13/2001 17:23'!
arrowPrototype

	| aa |
	aa _ self new. 
	aa vertices: (Array with: 0@0 with: 40@40) 
		color: Color black 
		borderWidth: 2 
		borderColor: Color black.
	aa makeForwardArrow.		"is already open"
	aa computeBounds.
	^ aa! !

!PolygonMorph class methodsFor: 'instance creation' stamp: 'tk 11/16/2001 12:15'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Arrow'
		categoryList: #(' Basic 1 ' 'Graphics')
		documentation: 'A line with an arrowhead.  Shift-click to get handles and move the ends.'
		globalReceiverSymbol: #PolygonMorph
		nativitySelector: #arrowPrototype}
! !

!PolygonMorph class methodsFor: 'parts bin' stamp: 'tk 11/16/2001 12:15'!
descriptionForPartsBin
	^ self partName:	'Polygon'
		categories:		#('Graphics' ' Basic 1 ')
		documentation:	'A series of connected line segments, which may be a closed solid, or a zig-zag line.  Shift-click to get handles and move the points.'! !


!CurveMorph class methodsFor: 'parts bin' stamp: 'tk 11/14/2001 17:47'!
arrowPrototype

	| aa |
	aa _ PolygonMorph vertices: (Array with: 5@40 with: 5@8 with: 35@8 with: 35@40) 
		color: Color black 
		borderWidth: 2 
		borderColor: Color black.
	aa beSmoothCurve; makeOpen; makeForwardArrow.		"is already open"
	aa dashedBorder: {10. 10. Color red}.
		"A dash spec is a 3- or 5-element array with
		{ length of normal border color.
		length of alternate border color.
		alternate border color}"
	aa computeBounds.
	^ aa! !

!CurveMorph class methodsFor: 'parts bin' stamp: 'tk 11/16/2001 12:17'!
descriptionForPartsBin
	^ self partName:	'Curve'
		categories:		#('Graphics' ' Basic 1 ')
		documentation:	'A smooth wiggly curve, or a curved solid.  Shift-click to get handles and move the points.'! !

!CurveMorph class methodsFor: 'parts bin' stamp: 'tk 11/16/2001 12:17'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Curvy Arrow'
		categoryList: #(' Basic 1 ' 'Graphics')
		documentation: 'A curved line with an arrowhead.  Shift-click to get handles and move the points.'
		globalReceiverSymbol: #CurveMorph
		nativitySelector: #arrowPrototype}
! !


!LineMorph class methodsFor: 'parts bin' stamp: 'tk 11/16/2001 12:13'!
descriptionForPartsBin
	^ self partName:	'Line'
		categories:		#('Graphics' ' Basic 2 ')
		documentation:	'A straight line.  Shift-click to get handles and move the ends.'! !


!RectangleMorph class methodsFor: 'as yet unclassified' stamp: 'tk 11/15/2001 20:54'!
roundRectPrototype
	^ self authoringPrototype useRoundedCorners 
		color: ((Color r: 1.0 g: 0.452 b: 0.645) alpha: 0.45); 
		borderWidth: 1;
		setNameTo: 'RoundRect'! !

!RectangleMorph class methodsFor: 'parts bin' stamp: 'tk 11/14/2001 20:09'!
diagonalPrototype

	| rr |
	rr _ self authoringPrototype.
	rr useGradientFill; borderWidth: 0.
	rr fillStyle direction: rr extent.
	^ rr! !

!RectangleMorph class methodsFor: 'parts bin' stamp: 'tk 11/14/2001 20:09'!
gradientPrototype

	| rr |
	rr _ self authoringPrototype.
	rr useGradientFill; borderWidth: 0.
	^ rr! !

!RectangleMorph class methodsFor: 'parts bin' stamp: 'tk 11/14/2001 20:05'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'RoundRect'
		categoryList: #('Graphics' ' Basic 1 ')
		documentation: 'A rectangle with rounded corners'
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #roundRectPrototype.

	DescriptionForPartsBin
		formalName: 'Gradient'
		categoryList: #('Graphics' ' Basic 1 ')
		documentation: 'A rectangle with a horizontal gradient'
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #gradientPrototype.

	DescriptionForPartsBin
		formalName: 'Gradient (slanted)'
		categoryList: #('Graphics' ' Basic 2 ')
		documentation: 'A rectangle with a diagonal gradient'
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #diagonalPrototype}! !


!ScriptableButton class methodsFor: 'name' stamp: 'tk 11/13/2001 02:14'!
descriptionForPartsBin
	^ self partName:	'Button'
		categories:		#('Scripting' ' Basic 1 ')
		documentation:	'A button to use with tile scripting; its script will be a method of its containing playfield'! !


!TextMorph methodsFor: 'private' stamp: 'tk 11/13/2001 01:57'!
setDefaultContentsIfNil
	"Set the default contents"

	| toUse |
	text ifNil:
		[toUse _ self valueOfProperty: #defaultContents.
		toUse ifNil: [toUse _'abc' asText "allBold"].	"try it plain for a while"
		text _ toUse]! !


!TextMorph class methodsFor: 'parts bin' stamp: 'tk 11/13/2001 01:55'!
authoringPrototype
	| t |
	t _ super authoringPrototype.
	t contents: 'abc' asText.
	t wrapFlag: true. 

"Strangeness here in order to avoid two offset copies of the default contents when operating in an mvc project before cursor enters the morphic window"
	t paragraph.
	^ t! !

!TextMorph class methodsFor: 'parts bin' stamp: 'tk 11/14/2001 19:51'!
fancyPrototype

	| t |
	t _ self authoringPrototype.
	t autoFit: false; extent: 150@75.
	t borderWidth: 2; margins: 4@0; useRoundedCorners.	"Why not rounded?"
	"fancy font, shadow, rounded"
	t fontName: #ComicBold size: 18; textColor: Color blue; backgroundColor: Color lightBrown.
	t addDropShadow.

"Strangeness here in order to avoid two offset copies of the default contents when operating in an mvc project before cursor enters the morphic window"
	t paragraph.
	^ t! !

!TextMorph class methodsFor: 'parts bin' stamp: 'tk 11/14/2001 17:57'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Text (border)'
		categoryList: #(' Basic 1 ' 'Text')
		documentation: 'A text field with border'
		globalReceiverSymbol: #TextMorph
		nativitySelector: #borderedPrototype.

	DescriptionForPartsBin
		formalName: 'Text (fancy)'
		categoryList: #(' Basic 1 ' 'Text')
		documentation: 'A text field with a rounded shadowed border, with a fancy font.'
		globalReceiverSymbol: #TextMorph
		nativitySelector: #fancyPrototype.}
! !

"Postscript:
For items that have changed look, remove their cached thumbnail.
Make the default ImageMorph be a real picture."

#('Curve' 'Polygon' 'Rectangle' 'Paint' 'Text' 'RoundRect' 'Text (border)' 'Line' 'Image') 
	do: [:nn | (PartsBin classPool at: #Thumbnails) removeKey: nn ifAbsent: []].

ImageMorph classPool at: #DefaultForm put: ((ColorForm
	extent: 127@57
	depth: 8
	fromArray: #( 4024820954 3230027315 487721739 184944143 252579342 235802126 236131863 386994449 438583384 1875895807 4294967277 3854943685 3318072002 3032662732 3267741381 3146409011 571150342 101062159 252646918 386666778 608197260 3269916653 3261421652 1481925509 1991293644 3436829145 3873033436 3705330404 3839414743 3521307362 3621244879 3218587392 4024755429 3682174528 857543179 186058262 252579342 235802126 236130070 386535706 438117439 1570954231 4294967287 3871726277 3318138306 3267546310 3334850245 3316155982 589433611 184944143 253103878 386994458 607476364 3269916653 3262470228 607600212 1415734629 2241042835 2475922340 2764095963 3687961047 3621970658 3805337559 3620654592 4025544676 3686491726 857543186 186058262 252579342 235802126 236131094 369758481 437920804 932823270 4160225279 4158315205 3318072002 3267741382 3334915781 3318058073 941822475 302384646 252645129 370610458 438583151 2044325337 2369201207 926367316 1045714004 1415799651 1667457877 1415808432 3132799667 3016736727 3620852194 3806056448 4024758245 3685000292 942875410 186058262 252579342 235802126 235803414 369758476 437919012 932226012 4160749567 4159036101 3318071980 3334653382 3334915782 3334842503 941826834 117835270 252645129 101781786 438583151 2379012550 2758104149 1536990362 2308750010 3133975738 2627509402 2592441733 2444275897 3117338318 3469659855 3484983808 4025479377 2406796134 1312301842 186062598 370086658 34475534 235802131 369694481 286923300 1063683777 3656908799 4294436314 3418538690 3269122778 3670394309 3318070173 1714959139 302712326 101650198 102174993 438583130 1908524512 3771116721 3010877476 168366389 891106126 1718986946 3334847401 2847915943 2813900984 3099113662 3199778304 4025479374 1246543523 1951281955 285939462 101650190 34475534 235802131 252253964 286923293 625903268 3421632503 4294440922 3301098178 3318072773 3318072773 3318072763 2251825954 302714886 101650198 102176529 287122495 1571406560 3990926197 1566922805 168366389 914785932 2830353090 3435578048 3233851303 2511911096 3099115198 3201355776 4025472899 791643328 2723033629 302713623 101062147 51249678 235802131 320210455 185735706 606428550 2363289079 4294439653 3687566274 3705195473 3520123083 3419128523 2844211250 840043270 101650198 370611985 286924069 1518840258 3772827074 3150037441 3250700738 3653419738 3671775448 3687956671 3234910399 3218856907 3520123088 3502154496 4023883850 790579902 2724482355 303106839 386274831 51252750 235802131 320210442 185667866 438584157 2258950903 4160223211 3637234635 3419521216 3233857728 3232015529 2844407858 841157382 100994831 370611980 286923293 1065847489 3318072770 3334652610 3269122524 3269122778 3670789083 3638086609 3419525585 3520188624 3216938389 2728564992 3617016367 640635267 2726770752 588386571 386270735 51315214 34475539 319755782 386994444 438117722 1871956965 4160749559 3856391120 3501766840 3218133467 3688553690 3669727544 841159184 101060367 253105930 185405981 1080464321 3319454428 3706054108 3705461466 3672565477 3857049061 4041598427 3688618971 3687567825 3233857728 3217014272 2200905263 791621415 2710791246 857936139 386270726 51315214 34475539 319755782 386666764 438115647 1871954405 4160225271 4075150043 3502227408 3688616395 3688680395 3418071908 941822475 270992911 252249610 168496154 625903529 3269122778 3705461477 3856456922 3873892081 4058441189 3857769957 4059162341 3856193752 3638086603 3419134720 640043345 1229473831 2193531470 1294148363 185272838 101650191 33686030 252645126 386994449 438580799 1516662977 3774873599 4294965211 3504069596 3705461989 3688555994 3857439370 1446191890 185009925 51318550 655824666 609129409 3269122778 3705330394 3671775962 3756385765 3857772786 4075876594 4075547627 3957712346 3671775962 3671644160 1364283686 642861102 1250927204 941826834 185273098 101650191 33686030 235867910 386601228 437920832 1062880650 3153592319 4294965221 3639668976 3706777847 4042782711 4160220597 1951216419 303040262 84877078 369497885 629574849 3269253850 3705461707 3419130840 3638287323 3840206043 3688618971 3687961041 3520844235 3419130827 3418338560 1212762441 1361465647 1363971993 1681011235 302713606 101058063 252576270 236130054 102173457 286925860 624968550 2363160575 4294440933 3857049061 3857774583 4160223223 4160223192 3209573155 588384016 84872975 252322597 1128624268 2024522437 3317876186 3672499685 3672499685 3857049060 3688618971 3687961041 3520188624 3503345855 3217014528 1230066001 1363693870 774341785 1951283235 571150347 184944143 252644878 236130070 102173457 286923293 608190566 2260851191 4160221413 3857049074 4160223223 4160223223 3958238693 3683012146 589435408 102105864 370225984 1059406426 1164938409 3150103260 3672499942 3857574885 3857049072 4042453232 3857048804 3840271589 3839548379 3520188416 1364281416 1214939522 3164725968 2573501491 841091856 184944134 370085646 236130063 369497867 286333466 438576451 1569506009 3992451058 4075154935 4160223223 4160225279 4160749567 4155077683 841163282 268830214 286923293 488975426 1111644783 2325588155 3319390432 3671775962 3671778797 4160223223 4075152869 3856983268 3857049061 3857772288 640051872 3403866593 3805405905 2507441208 841157392 268830214 370085651 34803471 252053015 185667858 303899712 1518774475 3656906738 4074433515 3957713911 4160223231 4294967295 4157315384 841163538 117835281 858989341 489434179 740631874 1499892393 3251362522 3671775962 3671778789 3857049061 3857049060 3840206053 3857774583 4294835456 2714422991 3788431842 3806515409 3499717688 942809611 186062598 101650191 135467795 252646918 386601233 286924068 1063095464 3270375415 4075154411 3857049072 4042323967 4294967295 4159029364 942809891 117838106 857939251 943013952 891100467 860772966 1720098245 3334849218 3267746265 3654998746 3672499685 3856196837 3857049072 4042321920 3789677026 3806520034 3806651627 3836320100 942809874 304155398 101060367 252908296 134419974 101321489 286924068 624975238 2832920055 4160223223 4160223223 4160749567 4294967295 4294433443 1949840163 185670963 589512768 857546013 438506002 303182681 1720360360 2879687315 2327888604 3672499685 3857049061 3856985067 3958436093 4294967040 4025544944 4043177469 4076008183 4158308487 942875427 302713606 101058063 252645139 320016143 369493515 286331162 606421853 1974060523 4159764471 4042782711 4294440951 4160223223 4160220123 3196532786 589505315 489895965 303108375 387584262 186061091 1315333766 1717998470 1681406054 2274010305 3706119909 3873103834 3672499684 4043308800 4261281277 4075810799 4025545463 4159560360 2268607267 588319511 101058063 252645139 33690383 252053015 185340186 488914778 1519626699 3673225207 4160225271 4294967295 4294967287 4160223213 3670119246 591413312 942875410 185667857 859115782 101254662 185273099 186851635 2273785890 268764688 1284554955 3417690549 3234910416 3503280128 4294967282 4076008178 4076008183 4160223194 2841917475 589505291 184944134 101650191 33689107 318967558 387389201 438117696 1080461992 3271032831 4294967295 4294967287 4160223223 4160223223 4159425433 2219724377 1310528011 304356661 1482509859 101058051 103224854 318964491 573793870 268632835 52514473 3653622490 3318072795 3638287104 4294967295 4294111986 4076008183 4159565280 3414833203 858989346 184944134 101060367 252579342 235078406 102176524 286925860 625897380 3153199103 4294967295 4294440951 4160223213 3992122103 4159560379 2743559246 941820683 591413301 894328142 386598408 134744086 369427203 50733880 1712324865 16977998 2762460127 3756056811 3958891776 4294967295 4294967293 4076731903 4294440941 3854595128 942875427 302714886 101058063 252907022 235081487 369493527 286005789 624909685 2832988159 4294965239 4160221413 3857575403 3857772784 4042322149 3836189017 941820690 589110557 303186010 487262982 100860694 369165830 16975395 2268269318 117835315 2254750150 3334850010 3302676992 4294967295 4294967295 4294967295 4294965239 4158301028 942875427 572590859 268830223 252907022 235081487 370546199 286005789 608197213 2379281151 4294967287 4160223223 4159567853 3992453111 4076008183 4156860295 941429283 857543186 303178585 1716400929 186720561 655362849 101057285 1317430873 1310919430 189637846 3603285466 3671647488 4294966781 4260557552 4076731901 4261281279 4294432931 1951281955 589505057 184944134 252646158 235799059 252646918 386994714 488914781 2378226423 4160223223 4160747511 4160223223 4160749567 4294835709 4075540905 2269125952 1513300754 302713637 1166831397 304300134 1720165284 839256839 102991558 3329166086 102994882 3267741146 3671775744 4294967293 4260557552 4042915325 4261281791 4076337114 3211152947 589505313 187106822 370085651 318898702 320016134 386601229 220472669 1992346584 3688558071 4160749567 4294967295 4294967295 4294967293 4075547588 2321101632 1566061347 185274909 1116386484 2040376278 3773684215 3261490227 185011000 2360641075 307151328 3317417403 3150695168 4294967295 4294836223 4294967295 4294967295 4294967287 4038432056 841163282 302712582 101060367 51252750 235803407 101387019 303703133 1857326214 1972152517 3773691903 4294967295 4294967287 4294440951 3991793120 3316156238 946237248 589110546 590588121 3654998746 4160749567 4293782953 840042002 1873653115 1734973103 2526457750 2528089600 4294967295 4294967295 4294967295 4294967295 4294967295 4158698887 942809891 302713606 101058063 252907022 235802115 84282130 303703133 2374395480 1720093864 3151687167 4294967295 4294967295 4294967287 3992448480 3334843276 2322570607 941432082 304319685 3319454443 4160354815 4294440928 2318611290 2882121080 1736349359 2526451350 2526451200 4261281791 4294835709 4261412863 4294967295 4294967295 4294437824 1949839907 571607819 268830223 252644878 235802127 252057355 286933085 1849701176 1517259404 2644820442 3992977407 4294440951 4160220653 3956982971 3319191237 3317421506 2320376587 189709274 3319326187 3959422967 4159565280 3313081723 3316480880 1736343680 2155905150 2525003776 4261412863 4294835709 4261412863 4294967295 4294967295 4294440941 3228848946 589500939 184944143 252646158 235802114 252053003 186269759 892548416 1517258380 2359601611 3673686015 4293256666 3638283211 3418736069 3318072773 3319191238 3265091918 1722343648 3318470872 3639665893 3854877893 3148589995 2913842301 2944303232 2155905152 2155904512 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4157640580 1395794465 185271814 101650190 235802114 318965259 185670197 893403226 1517252463 1871087244 2831342061 3991793133 3990870746 3670399711 3318070212 3319121349 3586504105 3150300613 3419130833 3419130827 3418074027 3064703867 2880878205 2908840289 1616994657 1635803136 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293774227 1949839906 185273094 101650191 319688206 318969354 185736501 892682304 1062885978 1871087244 2846474714 3990544351 3671775962 3670394309 3318072773 3317414843 3149642683 3150300612 3319322840 3637234628 3301227435 3316362141 2641918055 1885298783 1197433185 1635803136 4294967295 4294967295 4160223231 4294967295 4294967295 4294967295 4294440907 3230087203 571609611 117769487 252646163 320214534 186856221 437393949 1077959258 1566399855 1868981894 2361771461 3317414843 3150300613 3267083195 2843178871 2006821307 3049571781 3318006980 3418078148 3148586397 3047005578 2644356022 3058124615 1197498721 1633705984 4294965239 4160225279 4294443007 4294967295 4294967295 4294967295 4042784759 3987310392 841163538 184943887 252646163 318969355 589500689 286335773 859848768 1062885466 1871087251 2359929001 2844428938 2326313915 3149644225 3249252777 2845674122 2847259579 3148461499 3233135547 2880147125 2881865157 3318073800 2908774497 1633771873 1633771776 4159762679 4294443007 4294965247 4294967295 4294967295 4294967295 4294967287 4158636132 841163538 117900805 84869903 252256547 285936395 185667875 437919029 1077959258 1482188422 1569091430 1717989254 2357612110 1720953019 3249252523 2643110059 2847254953 2846468521 2880027579 3149642693 3318072773 3318072773 3313533056 1633771873 1633771776 4160223231 4294967295 4294967295 4294967295 4294967295 4294967295 4294440941 3991788201 1681400594 303042566 101058070 253174049 184944139 185273105 287513117 893337664 1079663192 1315327552 858993486 1720092294 1717996737 2831532741 2880023467 2846600107 3149642683 3149642693 3318072773 3586508229 3318072789 3314980480 1616994657 1633771776 4294440951 4160747511 4160223223 4159895543 4294967295 4294967295 4294439659 3958238661 2844211235 571609611 268830231 185273111 101058054 102176535 386601242 438115637 1516068198 1717200486 1310527761 590553891 439572597 2827778475 2830878139 3149642699 3318072773 3318072773 3318072773 3318007002 3301300933 3316625278 2120245345 1633771776 4294440951 4160223223 4159894258 4075877106 4294967295 4294967295 4294967287 4159565279 3317402212 941826851 572596513 555156998 101058051 84478217 386996787 890903058 589505315 589509990 1566988376 1714621190 168495925 2257362316 1720369861 3771057605 3318072773 3318072773 3318072773 3302677210 3671777237 3316625302 2120245345 1616922368 4294440951 4076337133 3857049061 4076339199 4294967295 4294967295 4294967295 4294440951 4159560384 2572040243 842212113 184944134 101060367 252250391 288575064 1482315805 302713611 185273123 589505315 860769843 184944139 489907847 2276050372 3420117722 3671775962 3670394052 3301295578 3670333636 3301295556 3145578390 2525003873 1632054528 4294440951 3957712357 3857049079 4160749567 4294967295 4294967295 4294967295 4294967287 4160220634 3416885048 944648993 101058054 101057295 252249611 859131456 891115610 890374923 184944134 101058059 187911782 1311968006 185274915 593804255 3990543066 3671775962 3671775941 3318072794 3319322820 3418672059 3044769174 2525003873 1633765120 4160223223 3857442277 3857446903 4160749567 4294967295 4294967295 4294967295 4294967295 4294442999 4158700426 2472948513 185271814 102108959 520685067 589109778 303913583 1866474258 303040006 101057797 84619854 1717973767 117638662 106152152 3688421592 3840271845 3856325317 3301229764 3519070119 2812783005 2004581782 2525003873 2155904512 4160223223 3858230763 3958896631 4160225279 4294967295 4294967295 4294967295 4294967295 4294967287 4159561952 3651423499 554042886 103229215 520492811 287515427 306200640 1517247032 589439248 268830214 100993803 593061427 302384646 103989477 3638879460 3840202968 3686513589 3048584629 3050426816 3233135556 3148853167 2525003873 1633714176 4260557029 3958238711 4159894258 4076009471 4294967295 4294967295 4294967287 4160223223 4294967295 4294965239 3954533410 302712583 117835267 134612491 588915474 488444445 626880881 959656755 857869067 269158151 185736512 1862993414 191284677 3318007237 3418078139 3149642683 3419130827 3687107531 3638089957 3855200150 2120188032 1599111168 4260557029 3858233335 4160221938 4076337151 4294967292 4294835711 4294967287 4160223223 4160749567 4294111991 4158302564 941826850 185271830 50529803 590689050 437391890 488981342 1905044418 2827650916 1681396231 303174208 2359134860 2360067515 3149249467 3149642683 3148594123 3269188568 3671775962 3672894455 4155486102 2122219648 1633779712 4210225124 3858233335 4160223211 3958896631 4076008189 4261412855 4160223213 4159565293 3992451063 4160223223 3990936251 2002335795 589366790 101059346 491671091 487723538 303897893 493140973 3991793120 3771041571 302715494 3331090022 2326383552 3233857728 3047926699 2880157381 3319454431 3958238204 4244109280 3598745697 1618902687 2528096000 3924092132 4076337143 4160223211 3958567666 4076011007 4294963952 3857045722 3671775973 3857049061 3857053677 3670787269 3318071976 2321960525 1294148387 946244748 2354715922 303899941 489859552 3773689325 3990930845 1717995176 3330758968 1688452043 3419130821 3318072773 3318073562 3655724013 3991664625 4042782678 3311493472 1619034271 2947526400 4007781097 4026400253 4076008171 3958896619 3958567677 4260095448 3638283227 3688618725 3857045720 3519794116 3417680297 2846604219 3148590011 3148393387 2831337174 3604396957 2251825954 594856934 3671907281 3416899753 2325981632 2760550336 3050035930 3671775702 3603548591 2947526613 3605786093 3991201008 4041272726 2137088353 1637261228 3334915584 4007846633 3925736957 4076008171 3958107627 3958571005 4260092632 3419525328 3420183269 3671644376 3519788469 3048581002 2326374825 2846468521 2844567723 2881865157 3317414853 3265890954 2327960282 3419130827 3419126715 3149646786 3265903556 3756914679 4158708438 3335112879 2930683589 3320573421 3991660016 4040808854 2137088353 1637261236 2041883648 4008636142 4009294074 4210225899 3958107639 4160749567 4074756811 3419459792 3521439205 3839416536 3636770217 2846467978 2324335242 2324335261 2643102365 2847652777 2847981771 3420183277 3990543064 3688618968 3671775962 3756385765 3857049048 3958238688 3603548591 2947526550 2524807109 3319459319 4160220121 3653873505 1633771904 2159523752 1720952832 4008636142 4008633071 4210225899 3958241271 4160749554 3839544273 3520123088 3690133495 4075083992 3517556647 2810874506 2324335242 2273806182 1720158087 2327559115 3319454445 3991793133 3688616155 3857049067 4159565303 3992451071 4294440941 4159555013 3316493693 2105376125 2105376709 3319459319 4159431898 3668948833 1632657792 2529806760 1315343360 4092522222 4176737262 4008307186 4260557559 4160223205 3686845387 3503345892 4076011511 4075545816 3518739879 2812512906 2844428935 2271635046 1687535812 3671777261 3991268343 4160221412 3688424933 4076335851 3958107127 4160223231 4294967287 3989161341 2087875167 1599033211 2105376173 2917529599 4244106158 2927649120 2158984621 3385181632 2575599360 4092849902 4008965107 4091668964 3841127159 4159890907 3687567824 3420186103 4159894258 3856983256 3519329705 2846460585 2846468490 2270779786 2646923994 3671644909 3992448498 4159890916 3840666610 4075152858 3638225899 3992451071 4294967277 3637040511 2084970014 509501031 1736277421 3320180223 4294438319 2103395911 2157352662 3603282891 3231291648 4008965107 4092851187 4092522209 4008701949 4260422875 3502362832 3689281535 4294111983 3840206052 3839411409 3049302464 3150299819 2878113705 3320573431 3991661541 3858233335 4160221936 4076006379 3857049048 3637627844 3638949887 4294965741 3687101820 2067406380 507076217 3032925893 3320178428 4243451286 1917205114 3083196909 3990537451 3958098688 4008636142 4092851187 4092522209 3789746162 4261408987 3503348699 3706056959 4294832356 3840206052 3957315780 3301686203 3150300613 3334843323 3319457261 4160220645 3672499685 4076008178 4159432165 3857049050 3635792843 3420779263 4294834679 3636754279 1732655673 1583835003 2915682774 3605391100 4243447666 1179013023 3386958061 3991793143 4160219904 4008636142 4008636142 4008637427 4092522217 4177194978 3806059749 3856983538 4076004568 3688618212 3857442008 3638221515 3150300613 3317869506 3268533210 3958102746 3671644890 3671780333 3991657178 3671775940 3301230042 3302745599 4294965759 3839871925 2322613573 1888385963 3066414533 3756783615 4294433422 1886959321 3992451071 4160223223 4160219904 4008636142 4008636142 4008637427 4092522209 4007848418 3806717413 3857905650 3856980187 3689208792 3840271845 3957381829 3149645243 2879228573 2847986138 3958102235 3672496858 3419130842 3671775448 3638221508 3301229764 3419460080 4294966770 3840798166 3313203312 2394343624 3368404447 3756914674 4075678638 2662189529 3992451063 3856980955 3503406592 4008636142 4007846638 4008636147 4092851187 4091666914 3924160754 4076339191 3956857041 3638876376 3856983282 4075674309 3416893853 2844419174 2260718059 4159423691 3638215867 2810881973 3150695364 3670394309 3317413301 2847915995 4294834941 4025548791 4160220613 3318009284 3303335147 3958102232 3638094829 3957777893 4057783504 3200171682 2407748352)
	offset: 0@0)
	colorsFromArray: #(#(1.0 1.0 1.0) #(1.0 0.839 0.776) #(0.936 0.839 0.807) #(0.936 0.807 0.741) #(0.936 0.776 0.71) #(0.936 0.71 0.71) #(0.936 0.71 0.678) #(0.936 0.678 0.646) #(0.905 0.839 0.741) #(0.905 0.776 0.678) #(0.905 0.741 0.58) #(0.905 0.678 0.611) #(0.905 0.678 0.548) #(0.905 0.611 0.548) #(0.87 0.839 0.807) #(0.87 0.807 0.741) #(0.87 0.678 0.678) #(0.87 0.678 0.548) #(0.87 0.611 0.548) #(0.839 0.87 0.741) #(0.839 0.839 0.741) #(0.839 0.776 0.741) #(0.839 0.776 0.678) #(0.839 0.741 0.611) #(0.839 0.678 0.548) #(0.839 0.646 0.646) #(0.839 0.611 0.482) #(0.839 0.58 0.548) #(0.839 0.58 0.451) #(0.839 0.548 0.482) #(0.839 0.353 0.353) #(0.807 0.807 0.741) #(0.807 0.776 0.71) #(0.807 0.678 0.611) #(0.807 0.611 0.58) #(0.807 0.58 0.517) #(0.807 0.548 0.419) #(0.807 0.451 0.388) #(0.776 0.776 0.87) #(0.776 0.71 0.71) #(0.776 0.611 0.58) #(0.776 0.58 0.517) #(0.776 0.548 0.388) #(0.776 0.482 0.388) #(0.776 0.388 0.388) #(0.776 0.223 0.16) #(0.741 0.776 0.807) #(0.741 0.741 0.776) #(0.741 0.71 0.807) #(0.741 0.646 0.58) #(0.741 0.548 0.517) #(0.741 0.548 0.482) #(0.741 0.548 0.451) #(0.741 0.548 0.419) #(0.741 0.548 0.353) #(0.741 0.548 0.289) #(0.741 0.482 0.451) #(0.741 0.258 0.289) #(0.741 0.223 0.258) #(0.71 0.741 0.776) #(0.71 0.71 0.807) #(0.71 0.517 0.517) #(0.71 0.517 0.223) #(0.71 0.482 0.353) #(0.71 0.451 0.419) #(0.71 0.451 0.321) #(0.71 0.419 0.388) #(0.71 0.388 0.353) #(0.71 0.388 0.289) #(0.71 0.321 0.321) #(0.71 0.16 0.192) #(0.71 0.129 0.063) #(0.678 0.807 0.807) #(0.678 0.776 0.839) #(0.678 0.678 0.741) #(0.678 0.678 0.71) #(0.678 0.58 0.58) #(0.678 0.517 0.451) #(0.678 0.451 0.419) #(0.678 0.129 0.129) #(0.678 0.031 0.063) #(0.646 0.741 0.776) #(0.646 0.611 0.646) #(0.646 0.548 0.548) #(0.646 0.517 0.223) #(0.646 0.517 0.16) #(0.646 0.482 0.517) #(0.646 0.482 0.419) #(0.646 0.482 0.321) #(0.646 0.419 0.419) #(0.646 0.419 0.353) #(0.646 0.419 0.223) #(0.646 0.388 0.321) #(0.646 0.388 0.289) #(0.646 0.258 0.223) #(0.646 0.063 0.063) #(0.646 0.063 0.0) #(0.646 0.0 0.0) #(0.611 0.482 0.223) #(0.611 0.451 0.129) #(0.611 0.419 0.419) #(0.611 0.419 0.192) #(0.611 0.388 0.353) #(0.611 0.192 0.16) #(0.611 0.16 0.223) #(0.611 0.129 0.063) #(0.58 0.678 0.741) #(0.58 0.419 0.419) #(0.58 0.388 0.353) #(0.58 0.388 0.321) #(0.58 0.353 0.223) #(0.58 0.321 0.258) #(0.58 0.258 0.258) #(0.58 0.258 0.192) #(0.58 0.031 0.129) #(0.548 0.451 0.16) #(0.548 0.388 0.388) #(0.548 0.353 0.223) #(0.548 0.353 0.16) #(0.548 0.223 0.258) #(0.548 0.192 0.223) #(0.548 0.192 0.16) #(0.548 0.192 0.094) #(0.548 0.129 0.129) #(0.548 0.094 0.129) #(0.548 0.063 0.063) #(0.548 0.063 0.0) #(0.548 0.031 0.063) #(0.548 0.0 0.0) #(0.517 0.646 0.71) #(0.517 0.58 0.611) #(0.517 0.482 0.517) #(0.517 0.451 0.451) #(0.517 0.388 0.129) #(0.517 0.353 0.289) #(0.517 0.321 0.353) #(0.517 0.321 0.223) #(0.517 0.321 0.0) #(0.517 0.289 0.289) #(0.517 0.258 0.258) #(0.517 0.258 0.223) #(0.517 0.258 0.16) #(0.517 0.16 0.192) #(0.482 0.419 0.419) #(0.482 0.388 0.321) #(0.482 0.388 0.094) #(0.482 0.353 0.388) #(0.482 0.353 0.258) #(0.482 0.353 0.16) #(0.482 0.289 0.321) #(0.482 0.0 0.0) #(0.451 0.419 0.517) #(0.451 0.419 0.482) #(0.451 0.353 0.353) #(0.451 0.353 0.0) #(0.451 0.321 0.031) #(0.451 0.289 0.0) #(0.451 0.192 0.223) #(0.451 0.094 0.16) #(0.451 0.063 0.031) #(0.419 0.517 0.548) #(0.419 0.353 0.388) #(0.419 0.321 0.353) #(0.419 0.289 0.289) #(0.419 0.289 0.223) #(0.419 0.258 0.223) #(0.419 0.258 0.192) #(0.419 0.223 0.289) #(0.419 0.223 0.16) #(0.419 0.192 0.192) #(0.419 0.192 0.129) #(0.419 0.16 0.16) #(0.419 0.129 0.0) #(0.419 0.094 0.094) #(0.419 0.031 0.063) #(0.419 0.0 0.0) #(0.388 0.258 0.094) #(0.388 0.223 0.0) #(0.388 0.192 0.223) #(0.388 0.192 0.063) #(0.388 0.16 0.063) #(0.388 0.129 0.192) #(0.388 0.094 0.129) #(0.388 0.063 0.031) #(0.353 0.289 0.353) #(0.353 0.258 0.129) #(0.353 0.223 0.0) #(0.353 0.16 0.129) #(0.321 0.388 0.419) #(0.321 0.289 0.321) #(0.321 0.289 0.258) #(0.321 0.223 0.289) #(0.321 0.192 0.223) #(0.321 0.192 0.129) #(0.321 0.16 0.063) #(0.321 0.129 0.129) #(0.321 0.094 0.129) #(0.321 0.094 0.063) #(0.321 0.094 0.0) #(0.321 0.063 0.094) #(0.321 0.031 0.063) #(0.321 0.031 0.0) #(0.289 0.353 0.419) #(0.289 0.16 0.129) #(0.289 0.16 0.0) #(0.289 0.0 0.129) #(0.258 0.289 0.321) #(0.258 0.258 0.289) #(0.258 0.223 0.223) #(0.258 0.16 0.223) #(0.258 0.16 0.16) #(0.258 0.129 0.129) #(0.258 0.129 0.031) #(0.258 0.031 0.063) #(0.258 0.031 0.0) #(0.223 0.192 0.289) #(0.223 0.094 0.16) #(0.223 0.094 0.031) #(0.223 0.063 0.094) #(0.192 0.16 0.16) #(0.192 0.16 0.094) #(0.192 0.094 0.16) #(0.192 0.063 0.094) #(0.192 0.031 0.063) #(0.192 0.031 0.0) #(0.16 0.223 0.258) #(0.16 0.16 0.223) #(0.16 0.16 0.192) #(0.16 0.094 0.16) #(0.16 0.094 0.063) #(0.16 0.094 0.0) #(0.16 0.063 0.094) #(0.129 0.192 0.289) #(0.129 0.094 0.223) #(0.129 0.094 0.16) #(0.129 0.031 0.094) #(0.129 0.031 0.063) #(0.129 0.031 0.0) #(0.094 0.129 0.289) #(0.094 0.094 0.16) #(0.094 0.094 0.094) #(0.094 0.063 0.031) #(0.094 0.031 0.094) #(0.063 0.16 0.353) #(0.063 0.16 0.321) #(0.063 0.16 0.258) #(0.063 0.129 0.321) #(0.063 0.0 0.031) #(0.031 0.094 0.258) #(0.031 0.094 0.063) #(0.031 0.063 0.16) #(0.031 0.063 0.094) #(0.031 0.063 0.0) #(0.031 0.0 0.094) #(0.0 0.0 0.031) #(0.0 0.0 0.0)  )).!

