'From Squeak3.3alpha of 24 January 2002 [latest update: #4875] on 20 May 2002 at 1:21:58 pm'!
"Change Set:		codegeneratorModuleFix
Date:			19 May 2002
Author:			Henrik Gedenryd

Make plugins use constants from modules instead of pools."!


!CCodeGenerator methodsFor: 'public' stamp: 'hg 5/19/2002 18:05'!
addClass: aClass 
	"Add the variables and methods of the given class to the code base."
	| source |
	self checkClassForNameConflicts: aClass.
	self addClassVarsFor: aClass.
	self addConstantsForClass: aClass.
	variables addAll: aClass instVarNames.
	'Adding Class ' , aClass name , '...'
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: aClass selectors size
		during: [:bar | aClass selectors
				doWithIndex: 
					[:sel :i | 
					bar value: i.
					source _ aClass sourceCodeAt: sel.
					self addMethod: ((Compiler new
							parse: source
							in: aClass
							notifying: nil)
							asTranslationMethodOfClass: self translationMethodClass)]]! !

!CCodeGenerator methodsFor: 'public' stamp: 'hg 5/19/2002 18:04'!
addConstantsForClass: aPluginClass

	aPluginClass constantModules do: [:mod |
		self addConstantsFromModule: mod].! !

!CCodeGenerator methodsFor: 'public' stamp: 'hg 5/19/2002 18:05'!
addConstantsFromModule: aModule 
	"Add the definitions in the given module to the code base as constants."

	aModule exportedNames keysAndValuesDo: [:key :value |
			constants at: key asString 
				put: (TConstantNode new setValue: value)]! !


!InterpreterPlugin class methodsFor: 'translation' stamp: 'hg 5/19/2002 17:50'!
constantModules
	"return a list of modules whose globals should be provided as constants for the code of this plugin"

	^{}! !


!B3DAcceleratorPlugin class methodsFor: 'translation' stamp: 'ar 5/20/2002 13:20'!
constantModules
	"return a list of modules whose globals should be provided as constants for the code of this plugin"

	^{Module @ #(Squeak Media Balloon3D Engine B3DEngineConstants)}! !


!B3DEnginePlugin class methodsFor: 'translation' stamp: 'ar 5/20/2002 13:17'!
constantModules
	"return a list of modules whose globals should be provided as constants for the code of this plugin"

	^{Module @ #(Squeak Media Balloon3D Engine B3DEngineConstants)}! !


!BalloonEngineBase class methodsFor: 'accessing' stamp: 'ar 5/20/2002 13:17'!
constantModules
	"return a list of modules whose globals should be provided as constants for the code of this plugin"

	^{Module @ #(Squeak Media Balloon Engine BalloonEngineConstants)}! !


!FFIPlugin class methodsFor: 'accessing' stamp: 'ar 5/20/2002 13:17'!
constantModules
	"return a list of modules whose globals should be provided as constants for the code of this plugin"

	^{Module @ #(Squeak Technology FFI Kernel FFIConstants)}! !


!KlattSynthesizerPlugin class methodsFor: 'translation' stamp: 'ar 5/20/2002 13:17'!
constantModules
	"return a list of modules whose globals should be provided as constants for the code of this plugin"

	^{Module @ #(Squeak Media Speech Klatt KlattResonatorIndices)}! !


!ObjectMemory class methodsFor: 'translation' stamp: 'ar 5/20/2002 13:15'!
constantModules
	^#()! !

Interpreter class removeSelector: #constantModules!
