'From Squeak3.4beta of ''1 December 2002'' [latest update: #5138] on 28 December 2002 at 3:13:48 pm'!
"Change Set:		FileListEmptyDirectoryFix
Date:			28 December 2002
Author:			Steven Swerling

Currently in the hierarchy list FileList2, all folders have toggles that make them appear to have subfolders. This changeset removes the toggle from folders that do not contain subfolders. The old behavior of assuming that a subfolder exists is maintained in cases that would incur a performance hit (such as nonlocal directories).
Changes this version: Catch Error in #hasContents causes default behavior (assume subfolder) instead of walkback."!

ListItemWrapper subclass: #FileDirectoryWrapper
	instanceVariableNames: 'itemName balloonText hasContents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Explorer'!

!FileDirectoryWrapper methodsFor: 'as yet unclassified' stamp: 'sps 12/27/2002 00:47'!
hasContents
"Return whether this directory has subfolders. The value is cached to avoid a performance penalty.	Also for performance reasons, the code below will just assume that the directory does indeed have contents in a few of cases: 
			1. If the item is not a FileDirectory (thus avoiding the cost
			of refreshing directories that are not local)
			2. If it's the root directory of a given volume
			3. If there is an error computing the FileDirectory's contents
"
	hasContents isNil ifTrue:[
		hasContents _ true. "default"
		[
		  (	
			"Best test I could think of for determining if this is a local directory"
			(item isKindOf: FileDirectory) and: [ 

			"test to see that it's not the root directory"
			(item pathParts size > 1)
		  ])
			ifTrue:[ hasContents _ self contents notEmpty. ].
		] on: Error do: [ hasContents _ true ].
			
	].
	^hasContents
! !

!FileDirectoryWrapper methodsFor: 'as yet unclassified' stamp: 'sps 12/5/2002 16:59'!
setItem: anObject name: aString model: aModel

	item _ anObject.
	model _ aModel.
	itemName _ aString.
	hasContents _ nil.
! !

