'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5566] on 27 November 2003 at 5:15:18 pm'!
"Change Set:		BecomeForwardCopyHashImage
Date:			25 November 2003
Author:			Brent Pinkney

This is the image support for 

	Object>>#becomeForward:copyHash:
	Array>>#elementsForwardIdentityTo:copyHash:

A VM change is also required to introduce a new primitive

	Interpreter>>#primitiveArrayBecomeOneWayCopyHash

This change has been introduced in the VMMaker3-7a.sar package.

Note. The existing primitive primitiveArrayBecomeOneWay could have been modified to support the new functionality but this would neccessitate a simultaneous change to both the image and the virtual machine.


"!


!Object methodsFor: 'system primitives' stamp: 'di 1/9/1999 15:19'!
becomeForward: otherObject 
	"Primitive. All variables in the entire system that used to point
	to the receiver now point to the argument.
	Fails if either argument is a SmallInteger."

	(Array with: self)
		elementsForwardIdentityTo:
			(Array with: otherObject)! !

!Object methodsFor: 'system primitives' stamp: 'brp 9/19/2003 16:20'!
becomeForward: otherObject copyHash: copyHash
	"Primitive. All variables in the entire system that used to point to the receiver now point to the argument.
	If copyHash is true, the argument's identity hash bits will be set to those of the recevier.
	Fails if either argument is a SmallInteger."

	(Array with: self)
		elementsForwardIdentityTo:
			(Array with: otherObject)
				copyHash: copyHash! !


!Array methodsFor: 'converting' stamp: 'di 3/28/1999 10:23'!
elementsForwardIdentityTo: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 72>
	self primitiveFailed! !

!Array methodsFor: 'converting' stamp: 'brp 9/26/2003 08:09'!
elementsForwardIdentityTo: otherArray copyHash: copyHash
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 249>
	self primitiveFailed! !

