'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5566] on 2 December 2003 at 9:02:38 am'!
"Change Set:		OnlyStartScriptsOnce-nk
Date:			2 December 2003
Author:			Ned Konz

Currently, scripts or projects named on the command line will be started again after the image is saved.

This change set fixes that problem by only starting them once at startup.
"!


!AutoStart class methodsFor: 'class initialization' stamp: 'nk 12/2/2003 09:00'!
startUp: resuming
	"The image is either being newly started (resuming is true), or it's just been snapshotted.
	If this has just been a snapshot, skip all the startup stuff."

	| startupParameters launchers |
	resuming ifFalse: [ ^self ].

	startupParameters _ AbstractLauncher extractParameters.
	(startupParameters includesKey: 'apiSupported' asUppercase )
		ifTrue: [HTTPClient browserSupportsAPI: ((startupParameters at: 'apiSupported' asUppercase) asUppercase = 'TRUE')].
	self checkForUpdates
		ifTrue: [^self].
	self checkForPluginUpdate.
	launchers _ self installedLaunchers collect: [:launcher |
		launcher new].
	launchers do: [:launcher |
		launcher parameters: startupParameters].
	launchers do: [:launcher |
		Smalltalk at: #WorldState ifPresent: [ :ws | ws addDeferredUIMessage: [launcher startUp]]]! !

AutoStart class removeSelector: #startUp!
