'From Squeakland 3.2.4913 of 10 July 2002 [latest update: #203] on 15 March 2004 at 11:55:51 pm'!
"Change Set:		q23referencesFix-sw
Date:			15 March 2004
Author:			Scott Wallace

Adopted from Squeakland update 0204referencesFix-sw

Fixes two bugs occasionally seen with etoy tiles, as reported by Michael Rueger:
*  Sometimes no internal name in References was being handed out for an object.
*  Sometimes an internal name that coincided with a global was being handed out.

An example scenario for recreating one of the bugs:
*  Get a Slider
*  Rename it to Slider (sic!!)
*  Now refer to that object in the script of another object. 
*  The code in that script will be bound to the global 'Slider' object (a class) because a name registered in the References table was not handed out for this object."!


!Object methodsFor: 'viewer' stamp: 'sw 3/15/2004 23:53'!
uniqueNameForReferenceFrom: proposedName
	"Answer a satisfactory symbol, similar to the proposedName but obeying the rules, to represent the receiver"

	| aName nameSym stem okay |
	proposedName = self uniqueNameForReferenceOrNil 
		ifTrue: [^ proposedName].  "No change"

	stem _ proposedName select: [:ch | ch isLetter or: [ch isDigit]].
	stem size == 0 ifTrue: [stem _ 'A'].
	stem first isLetter ifFalse:
		[stem _ 'A', stem].
	stem _ stem capitalized.
	aName _ Utilities keyLike: stem satisfying:
		[:jinaLake |
			nameSym _ jinaLake asSymbol.
			okay _ true.
			self class scopeHas: nameSym ifTrue: [:x | okay _ false "don't use it"].
			okay].
	^ aName asSymbol! !

!Object methodsFor: 'viewer' stamp: 'sw 3/15/2004 23:01'!
uniqueNameForReferenceOrNil
	"If the receiver has a unique name for reference, return it here, else return nil"

	^ References keyAtValue: self ifAbsent: [nil]! !

