'From Squeak3.7beta of ''1 April 2004'' [latest update: #5948] on 10 June 2004 at 1:34:53 pm'!
"Change Set:		StackPrintingAlignmentFix-nk
Date:			10 June 2004
Author:			Ned Konz

Fixes a bug in printing BookMorphs and StackMorphs as Postscript.

Also fixes a Postscript printing bug with text alignment attributes.

"!


!DSCPostscriptCanvas methodsFor: 'morph drawing' stamp: 'nk 6/10/2004 13:19'!
fullDrawBookMorph: aBookMorph
	" draw all the pages in a book morph, but only if it is the top-level morph "

	morphLevel = 1 ifFalse: [^ super fullDrawBookMorph: aBookMorph].

	"Unfortunately, the printable 'pages' of a StackMorph are the cards, but for a BookMorph, they are the pages.  Separate the cases here."
	(aBookMorph isKindOf: StackMorph) 
		ifTrue: [
			aBookMorph cards do: [:aCard |
				aBookMorph goToCard: aCard.	"cause card-specific morphs to be installed"
				pages _ pages + 1.
				target print: '%%Page: '; write: pages; space; write: pages; cr.
				self drawPage: aBookMorph currentPage]]
		ifFalse: [
			aBookMorph pages do: [:aPage |
				pages _ pages + 1.
				target print: '%%Page: '; write: pages; space; write: pages; cr.
				self drawPage: aPage]].
	morphLevel = 0 ifTrue: [ self writeTrailer: pages ].
! !


!PostscriptCharacterScanner methodsFor: 'textstyle support' stamp: 'nk 6/10/2004 13:32'!
setAlignment: alignment
	self paragraph textStyle alignment: alignment.! !

