'From Squeak3.7beta of ''1 April 2004'' [latest update: #5954] on 22 June 2004 at 4:26:28 pm'!
"Change Set:		WaveEditorInitFix-nk
Date:			22 June 2004
Author:			Ned Konz

The default WaveEditorMorph in the Objects catalog wasn't getting its data initialized correctly. Because of this, it wouldn't store on disk properly.

This change set changes the initialization of the default WaveEditorMorph to use a real sound instead.
"
!


!WaveEditor methodsFor: 'accessing' stamp: 'nk 6/22/2004 16:17'!
sound: aSound
	| buffer |
	buffer _ aSound samples mergeStereo.
	graph data: buffer.
	loopLength := loopEnd := buffer size.
	self samplingRate: aSound originalSamplingRate.
	loopCycles :=  buffer size / aSound originalSamplingRate * 400.
	perceivedFrequency := 400.
! !

!WaveEditor methodsFor: 'initialization' stamp: 'nk 6/22/2004 16:22'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	samplingRate _ SoundPlayer samplingRate.
	loopEnd _ loopLength _ 0.
	loopCycles _ 1.
	perceivedFrequency _ 0.
	"zero means unknown"
	self extent: 5 @ 5;
		 listDirection: #topToBottom;
		 wrapCentering: #topLeft;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 layoutInset: 3.
	graph _ GraphMorph new extent: 450 @ 100.

	graph cursor: 0.
	graph cursorColorAtZeroCrossings: Color blue.
	self addControls.
	self addLoopPointControls.
	self addMorphBack: graph.
	self
		addMorphBack: (Morph
				newBounds: (0 @ 0 extent: 0 @ 3)
				color: Color transparent).
	self addMorphBack: (keyboard _ PianoKeyboardMorph new).
	self sound: (SampledSound soundNamed: 'croak').
! !

