'From Squeakland 3.8.5976 of 15 August 2004 [latest update: #242] on 18 August 2004 at 10:26:10 pm'!
"Change Set:		tolerateElementTransl-sw
Date:			18 August 2004
Author:			Scott Wallace

The class ElementTranslation was eliminated between Squeak 3.8a and Squeakland 3.8a as part of the m17n work.  However,projects saved under the old regime can have ElementTranslation instances in them.  One known way this can happen is if the user has supplied balloon help for a user-defined script in an etoy; the UniclassScript object associated with the selector will have an ElementTranslation in its naturalLanguageTranslations slot which holds the help message.

This update allows the presence of such ElementTranslation objects to be tolerated, and even salvages the help messages for scripts from legacy projects"!

Object subclass: #ElementTranslation
	instanceVariableNames: 'wording helpMessage naturalLanguageSymbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Protocols-Kernel'!

!ElementTranslation methodsFor: 'access' stamp: 'sw 8/18/2004 22:12'!
helpMessage
	"Answer the helpMessage"

	^ helpMessage! !


!ObjectWithDocumentation methodsFor: 'accessing' stamp: 'sw 8/18/2004 20:23'!
helpMessage
	"Check if there is a getterSetterHelpMessage. 
	Otherwise try the normal help message or return nil."

	^ self getterSetterHelpMessage
		ifNil: [(self propertyAt: #helpMessage ifAbsent:
			[self legacyHelpMessage ifNil: [^ nil]]) translated]! !

!ObjectWithDocumentation methodsFor: 'accessing' stamp: 'sw 8/18/2004 22:11'!
legacyHelpMessage
	"If I have a help message stashed in my legacy naturalTranslations slot, answer its translated rendition, else answer nil.  If I *do* come across a legacy help message, transfer it to my properties dictionary."

	| untranslated |
	naturalLanguageTranslations isEmptyOrNil  "only in legacy (pre-3.8) projects"
		ifTrue: [^ nil].
	untranslated _ naturalLanguageTranslations first helpMessage ifNil: [^ nil].
	self propertyAt: #helpMessage put: untranslated.
	naturalLanguageTranslations removeFirst.
	naturalLanguageTranslations isEmpty ifTrue: [naturalLanguageTranslations _ nil].
	^ untranslated translated! !

