'From Squeakland 3.8.5976 of 19 August 2004 [latest update: #243] on 20 August 2004 at 4:09:53 pm'!
"Change Set:		viewerMenuFixes-sw
Date:			20 August 2004
Author:			Scott Wallace

Fixes two bugs that appeared when putting up and using the menu associated with the is-over-color tile in a Viewer"!


!DataType methodsFor: 'tiles' stamp: 'sw 8/20/2004 16:07'!
addWatcherItemsToMenu: aMenu forGetter: aGetter
	"Add watcher items to the menu if appropriate, provided the getter is not an odd-ball one for which a watcher makes no sense"

	(#(colorSees copy isOverColor: seesColor: newClone getNewClone color:sees: touchesA: overlaps:) includes: aGetter) ifFalse:
		[aMenu add: 'simple watcher' translated selector: #tearOffWatcherFor: argument: aGetter]! !


!Player methodsFor: 'slots-kernel' stamp: 'sw 8/20/2004 15:49'!
typeForSlotWithGetter: aGetter
	"Answer the data type for values of the instance variable of the given name"

	| getter inherentSelector |
	(#(color:sees: seesColor: touchesA: overlaps:) includes: aGetter) ifTrue: [^ #Boolean].  "Annoying special cases"
	inherentSelector _ Utilities inherentSelectorForGetter: aGetter.
	(self slotInfo includesKey: inherentSelector) ifTrue: [^ (self slotInfoAt: inherentSelector) type].
	getter _ (aGetter beginsWith: 'get')
		ifTrue:
			[aGetter]
		ifFalse:
			[Utilities getterSelectorFor: aGetter].
	^ (Vocabulary eToyVocabulary methodInterfaceAt: getter ifAbsent: [self error: 'Unknown slot name: ', aGetter]) resultType! !

