'From Squeak3.8alpha of ''17 July 2004'' [latest update: #6232] on 24 September 2004 at 4:59:18 pm'!
"Change Set:		PNMPNGIntegrationEnh-st
Date:			18 September 2004
Author:			Samuel Tardieu

PNM was not integrated with file services and MIME types. At the same time, I added some PNG similar fixes.

After this test, a file list will propose to open or import a pnm image."!


!FileList2 class methodsFor: 'blue ui' stamp: 'st 9/18/2004 23:34'!
endingSpecs
	"Answer a collection of specs to build the selective 'find anything' tool called by the Navigator. This version uses the services registry to do so."
	"FileList2 morphicViewGeneralLoaderInWorld: World"
	| categories services specs rejects |
	rejects _ #(addFileToNewZip: compressFile: openInZipViewer: extractAllFrom: openOn:).
	categories _ #(
		('Art' ('bmp' 'gif' 'jpg' 'jpeg' 'form' 'png' 'pcx' 'xbm' 'xpm' 'ppm' 'pbm' 'pnm'))
		('Morphs' ('morph' 'morphs' 'sp'))
		('Projects' ('extseg' 'project' 'pr'))
		('Books' ('bo'))
		('Music' ('mid'))
		('Movies' ('movie' 'mpg' 'mpeg' 'qt' 'mov'))
		"('Code' ('st' 'cs'))"
		('Flash' ('swf'))
		('TrueType' ('ttf'))
		('3ds' ('3ds'))
		('Tape' ('tape'))
		('Wonderland' ('wrl'))
		('HTML' ('htm' 'html'))
	).
	categories first at: 2 put: ImageReadWriter allTypicalFileExtensions.
	specs _ OrderedCollection new.
	categories do: [ :cat | | catSpecs catServices okExtensions |
		services _ Dictionary new.
		catSpecs _ Array new: 3.
		catServices _ OrderedCollection new.
		okExtensions _ Set new.

		cat second do: [ :ext | (FileList itemsForFile: 'fred.',ext) do: [ :i |
			(rejects includes: i selector) ifFalse: [
				okExtensions add: ext.
				services at: i label put: i ]]].
		services do: [ :svc | catServices add: svc ].
		services isEmpty ifFalse: [ 
			catSpecs at: 1 put: cat first;
				at: 2 put: okExtensions;
				at: 3 put: catServices.
			specs add: catSpecs ]
	].
	^specs
! !


!GZipWriteStream class methodsFor: 'file list services' stamp: 'st 9/18/2004 23:44'!
fileReaderServicesForFile: fullName suffix: suffix
	"Don't offer to compress already-compressed files
	sjc 3-May 2003-added jpeg extension"

	^({ 'gz' . 'sar' . 'zip' . 'gif' . 'jpg' . 'jpeg'. 'pr'. 'png'} includes: suffix)
		ifTrue: [ #() ]
		ifFalse: [ self services ]
! !


!MIMEDocument methodsFor: 'testing' stamp: 'st 9/18/2004 23:37'!
isPng
	^ self mainType = 'image'
		and: [self subType = 'png']! !

!MIMEDocument methodsFor: 'testing' stamp: 'st 9/18/2004 23:38'!
isPnm
	^ self mainType = 'image'
		and: [self subType = 'pnm']! !


!MIMEDocument class methodsFor: 'initialize-release' stamp: 'st 9/18/2004 23:36'!
defaultMIMEdatabase
	| d |
	(d _ Dictionary new)
	at: 'html' put: 'text/html';
	at: 'htm' put: 'text/html';
	at: 'xml' put: 'text/xml';
	at: 'txt' put: 'text/plain';
	at: 'c' put: 'text/plain';
	at: 'gif' put: 'image/gif';
	at: 'jpg' put: 'image/jpeg';
	at: 'jpeg' put: 'image/jpeg';
	at: 'gif' put: 'image/gif';
	at: 'png' put: 'image/png';
	at: 'pnm' put: 'image/pnm';
	at: 'xbm' put: 'image/x-xbitmap';
	at: 'mid' put: 'audio/midi';
	at: 'doc' put: 'application/ms-word-document'.
	^d! !


!MailMessage methodsFor: 'multipart' stamp: 'st 9/18/2004 23:40'!
save
	"save the part to a file"
	| fileName file |
	fileName _ self name
				ifNil: ['attachment' , Utilities dateTimeSuffix].
	(fileName includes: $.) ifFalse: [
		#(isJpeg 'jpg' isGif 'gif' isPng 'png' isPnm 'pnm') pairsDo: [ :s :e |
			(self body perform: s) ifTrue: [fileName _ fileName, '.', e]
		]
	].
	fileName _ FillInTheBlank request: 'File name for save?' initialAnswer: fileName.
	fileName isEmpty
		ifTrue: [^ nil].
	file _ FileStream newFileNamed: fileName.
	file nextPutAll: self bodyText.
	file close! !


!PNMReadWriter class methodsFor: 'image reading/writing' stamp: 'st 9/18/2004 23:47'!
typicalFileExtensions
	"Answer a collection of file extensions (lowercase) which files that I can read might commonly have"
	^#('pnm')! !

