'From Squeak3.7beta of ''1 April 2004'' [latest update: #5923] on 22 May 2004 at 4:30:54 pm'!
"Change Set:		LowSpaceWatcherFix-dtl
Date:			22 May 2004
Author:			David T. Lewis

The low space watcher is interrupted in the context of the wrong process when the eventTickler process (or other high priority process) is running. This prevents low space detection from functioning properly.

This is a one line fix to Project>>interruptName: that corrects the problem.
"!


!Project class methodsFor: 'utilities' stamp: 'dtl 5/22/2004 16:13'!
interruptName: labelString
	"Create a Notifier on the active scheduling process with the given label."
	| preemptedProcess projectProcess suspendingList |
	Smalltalk isMorphic ifFalse:
		[^ ScheduledControllers interruptName: labelString].
	ActiveHand ifNotNil:[ActiveHand interrupted].
	ActiveWorld _ World. "reinstall active globals"
	ActiveHand _ World primaryHand.
	ActiveHand interrupted. "make sure this one's interrupted too"
	ActiveEvent _ nil.

	projectProcess _ self uiProcess.	"we still need the accessor for a while"
	preemptedProcess _ Processor preemptedProcess.
	"Only debug preempted process if its priority is >= projectProcess' priority"
	preemptedProcess priority < projectProcess priority ifTrue:[
		(suspendingList _ projectProcess suspendingList) == nil
			ifTrue: [projectProcess == Processor activeProcess
						ifTrue: [projectProcess suspend]]
			ifFalse: [suspendingList remove: projectProcess ifAbsent: [].
					projectProcess offList].
		preemptedProcess _ projectProcess.
	] ifFalse:[
		preemptedProcess _ projectProcess suspend offList.
	].
	Debugger openInterrupt: labelString onProcess: preemptedProcess
! !

