'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #328] on 6 October 2004 at 11:29:22 am'!
"Change Set:		ThumbnailTranslucencyImprovement-nk
Date:			7 September 2004
Author:			Ned Konz

Makes iconic buttons on translucent flaps look better.

Also increases the contrast of the RoundRect prototype.
"!


!IconicButton methodsFor: 'initialization' stamp: 'nk 9/7/2004 11:43'!
initializeWithThumbnail: aThumbnail withLabel: aLabel andColor: aColor andSend: aSelector to: aReceiver 	
	"Initialize the receiver to show aThumbnail on its face, giving it the label supplied and arranging for it, when the button goes down on it, to obtain a new morph by sending the supplied selector to the supplied receiver"

	| labeledItem nonTranslucent |
	nonTranslucent := aColor asNontranslucentColor.
	labeledItem _ AlignmentMorph newColumn.
	labeledItem color: nonTranslucent.
	labeledItem borderWidth: 0.
	labeledItem
		layoutInset: 4@0;
		cellPositioning: #center.
	labeledItem addMorph: aThumbnail.
	labeledItem addMorphBack: (Morph new extent: (4@4)) beTransparent.
	labeledItem addMorphBack: (TextMorph new
		backgroundColor: nonTranslucent;
		contentsAsIs: aLabel;
		beAllFont: Preferences standardEToysFont;
		centered).

	self
		beTransparent;
		labelGraphic: ((labeledItem imageForm: 32 backgroundColor: nonTranslucent forRectangle: labeledItem fullBounds) replaceColor: nonTranslucent withColor: Color transparent);
		borderWidth: 0;
		target: aReceiver;
		actionSelector: #launchPartVia:label:;
		arguments: {aSelector. aLabel};
		actWhen: #buttonDown.

	self stationarySetup.! !


!RectangleMorph class methodsFor: 'as yet unclassified' stamp: 'nk 9/7/2004 11:44'!
roundRectPrototype
	^ self authoringPrototype useRoundedCorners 
		color: ((Color r: 1.0 g: 0.3 b: 0.6) alpha: 0.5); 
		borderWidth: 1;
		setNameTo: 'RoundRect'! !

