'From Vancouver1.0 of 28 September 2004 [latest update: #345] on 13 November 2004 at 2:16:25 am'!
"Change Set:		lostMethods-sw
Date:			30 September 2004
Author:			Scott Wallace

When adding a parameter to a script, the underlying method was momentarily lost -- this fixes that.  Existing situations with lost methods can be revived just by momentarily picking up a tile that's in the script.

Derived from Vancouver update 0236lostMethods, from which the change to ScriptEditorMorph.renameScriptTo: had to be omitted"!


!Player methodsFor: 'costume' stamp: 'sw 9/30/2004 04:29'!
ceaseHavingAParameterFor: aSelector
	"Make the script represented by aSelector cease bearing a parameter"

	| newSel |
	self renameScript: aSelector newSelector: (newSel _ (aSelector copyWithout: $:) asSymbol).

	(self scriptEditorFor: newSel) assureParameterTilesValid; install! !

!Player methodsFor: 'costume' stamp: 'sw 9/30/2004 04:49'!
startHavingParameterFor: aSelector
	"Start having a parameter for the given selector.  After this change, the script name will change by the addition of a colon."

	| newSelector |
	self renameScript: aSelector newSelector: (newSelector _ (aSelector, ':') asSymbol).
	(self scriptEditorFor: newSelector) install! !


!ScriptEditorMorph methodsFor: 'other' stamp: 'sw 11/1/2004 22:50'!
addParameter
	"Transform the receiver so that it bears a parameter.  This will require a selector change, e.g. from #script3 to #script3:"

	playerScripted startHavingParameterFor: scriptName asSymbol! !


!Variable methodsFor: 'name' stamp: 'sw 9/30/2004 05:02'!
printOn: aStream
	"Print the receiver on the stream"

	super printOn: aStream.
	aStream nextPutAll: ' named ', (self variableName ifNil: ['<unnamed>']), ' type = ', variableType printString, ' default val = ', defaultValue printString! !

