'From Vancouver1.0 of 28 September 2004 [latest update: #278] on 12 October 2004 at 5:51:04 am'!
"Change Set:		findAgainFix-sw
Date:			12 October 2004
Author:			Scott Wallace

Fix for a boundary-condition error encountered in the GraphicalDictionaryMenu, in which if the last match had been precisely on the final element of the dictionary, another find-again would generate an error
From vancouver update 0279findAgainFix-sw."!


!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'sw 10/12/2004 05:04'!
findAgain
	"Look for the next occurrence of the search string"

	| toFind searchIndex |
	lastSearchString ifNil: [lastSearchString _ 'controls'].
	searchIndex _ currentIndex + 1.
	searchIndex > entryNames size ifTrue:
		[currentIndex _ 0.
		self inform: 'not found' translated.
		^ self].
	toFind _ '*', lastSearchString, '*'.
	[toFind match: (entryNames at: searchIndex) asString]
		whileFalse:
			[searchIndex _ (searchIndex \\ entryNames size) + 1.
			searchIndex == currentIndex ifTrue:
				[^ (toFind match: (entryNames at: searchIndex) asString)
					ifFalse:
						[self inform: 'not found' translated]
					ifTrue:
						[self flash]]].

	currentIndex _ searchIndex.
	self updateThumbnail! !

