'From Squeak3.9alpha of ''2 November 2004'' [latest update: #6485] on 30 November 2004 at 11:07:58 am'!
"Change Set:		misc-cleanups-md
Date:			30 November 2004
Author:			Marcus Denker

some cleanups:

-> removes AbstractString>>findTokens, moves the impl.
      from MultiString to AbstractString
-> deprecates Utilities>>isObject:memberOfOneOf: 
-> removes TheWorldMenu class>>registerStandardInternetApps
"!


!AbstractString methodsFor: 'accessing' stamp: 'md 11/30/2004 11:02'!
findTokens: delimiters
	"Answer the collection of tokens that result from parsing self.  Return strings between the delimiters.  Any character in the Collection delimiters marks a border.  Several delimiters in a row are considered as just one separation.  Also, allow delimiters to be a single character."

	| tokens keyStart keyStop separators |

	tokens _ OrderedCollection new.
	separators _ delimiters isCharacter
		ifTrue: [Array with: delimiters]
		ifFalse: [delimiters].
	keyStop _ 1.
	[keyStop <= self size] whileTrue:
		[keyStart _ self skipDelimiters: separators startingAt: keyStop.
		keyStop _ self findDelimiters: separators startingAt: keyStart.
		keyStart < keyStop
			ifTrue: [tokens add: (self copyFrom: keyStart to: (keyStop - 1))]].
	^tokens! !


!Utilities class methodsFor: 'deprecated' stamp: 'md 11/30/2004 11:05'!
isObject: anObject memberOfOneOf: aCollectionOfClassnames
	self deprecated: 'no used'.
	aCollectionOfClassnames do:
		[:classname | (anObject isMemberOf: (Smalltalk at: classname)) ifTrue: [^ true]].
	^ false! !


!Utilities class reorganize!
('class initialization' initialize registerInFlapsRegistry startUp unload)
('common requests' appendToCommonRequests: closeAllDebuggers commonRequestStrings: editCommonRequestStrings eval: evaluate:in:to: initializeCommonRequestStrings offerCommonRequests offerCommonRequestsInMorphic)
('debugging' doesNotUnderstand: inspectCollection:notifying:)
('durable menus' windowFromMenu:target:title: windowFromMenu:target:title:colorPattern: windowMenuWithLabels:colorPattern:targets:selections:title: windowMenuWithLabels:colorPattern:targets:selections:wordingSelectors:title:)
('fetching updates' applyUpdatesFromDisk applyUpdatesFromDiskToUpdateNumber:stopIfGap: assureAbsenceOfUnstableUpdateStream assureAvailabilityOfUnstableUpdateStream broadcastUpdatesFrom:to:except: chooseUpdateList extractThisVersion: fileInFromUpdatesFolder: getUpdateDirectoryOrNil lastUpdateNum: newUpdatesOn:special:throughNumber: objectStrmFromUpdates: parseListContents: position:atVersion: readNextUpdateFromServer readNextUpdatesFromDisk: readServer:special:updatesThrough:saveLocally:updateImage: readServerUpdatesSaveLocally:updateImage: readServerUpdatesThrough:saveLocally:updateImage: retrieveUrls:ontoQueue:withWaitSema: saveUpdate:onFile: serverUrls setUpdateServer: summariesForUpdates:through: updateComment updateFromServer updateFromServerThroughUpdateNumber: updateUrlLists writeList:toStream: zapUpdateDownloader)
('deprecated' fileOutChangeSetsNamed: fileOutChanges hierarchyOfClassesSurrounding: hierarchyOfImplementorsOf:forClass: isObject:memberOfOneOf: methodHierarchyBrowserForClass:selector: spawnHierarchyForClass:selector: stripMethods:messageCode:)
('flaps' globalFlapTabOrDummy:)
('graphical support' grabScreenAndSaveOnDisk showFormsAcrossTopOfScreen: showFormsDictAcrossTopOfScreen:)
('identification' authorInitials authorInitialsPerSe authorName authorName: authorNamePerSe browseUncommentedMethodsWithInitials: changeStamp changeStampPerSe copyrightNotice dateStamp dateTimeSuffix fixStamp: methodsWithInitials: monthDayTime24StringFrom: monthDayTimeStringFrom: setAuthorInitials setAuthorInitials: setAuthorName)
('investigations' inspectGlobals reportSenderCountsFor:)
('miscellaneous' addSampleWindowsTo: awaitMouseUpIn:repeating:ifSucceed: awaitMouseUpIn:whileMouseDownDo:whileMouseDownInsideDo:ifSucceed: cleanseOtherworldlySteppers convertCRtoLF: createPageTestWorkspace decimalPlacesForFloatPrecision: decommissionTheAllCategory doesMethod:forClass:bearInitials: emergencyCollapse fixUpProblemsWithAllCategory floatPrecisionForDecimalPlaces: garbageCollectAndReport getterSelectorFor: inherentSelectorForGetter: instanceComparisonsBetween:and: keyLike:satisfying: keyLike:withTrailing:satisfying: lookUpDefinition methodDiffFor:class:selector:prettyDiffs: nextClockwiseSideAfter: openScratchWorkspaceLabeled:contents: oppositeCornerFrom: oppositeModeTo: oppositeSideTo: reconstructTextWindowsFromFileNamed: setClassAndSelectorFrom:in: setterSelectorFor: simpleSetterFor: steplistToolsWorkspace storeTextWindowContentsToFileNamed: timeStampForMethod:)
('recent method submissions' assureMostRecentSubmissionExists browseRecentSubmissions dumpAnyOldStyleRecentSubmissions event: mostRecentlySubmittedMessage noteMethodSubmission:forClass: numberOfRecentSubmissionsToStore numberOfRecentSubmissionsToStore: openRecentSubmissionsBrowser purgeFromRecentSubmissions: purgeRecentSubmissionsOfMissingMethods recentMethodSubmissions recentSubmissionsWindow revertLastMethodSubmission)
('scraps' addToTrash: emptyScrapsBook maybeEmptyTrash scrapsBook trashTitle)
('summer97 additions' browseVersionsForClass:selector: chooseFileWithSuffix: chooseFileWithSuffixFromList:withCaption: classCategoriesStartingWith: classFromPattern:withCaption: graphicsFileSuffixes inviolateInstanceVariableNames isLegalInstVarName: wellFormedInstanceVariableNameFrom:)
('support windows' commandKeyMappings openCommandKeyHelp openStandardWorkspace standardWorkspaceContents)
('user interface' informUser:during: informUserDuring:)
('vm statistics' vmStatisticsReportString vmStatisticsShortString)
('tailoring system' makeNihongoImage)
!

TheWorldMenu class removeSelector: #registerStandardInternetApps!
MultiString removeSelector: #findTokens:!
